#include <iostream>
#include <cmath>
using namespace std;
int compare(const void* a, const void* b);
int main() {
    int size;
    cin >> size;
    long long* arr = new long long[size];
    for (int i = 0; i < size; i++) cin >> arr[i];
    qsort(arr, size, sizeof(long long), compare);
    long long min = arr[0];
    long long max = arr[1] - 1;
    if (max < min) {
        cout << 0;
        return 0;
    }
    else {
        for (long long i = min; i <= max; i++) {
            bool result_ok = true;
            for (int j = 1; j < size - 1; j++) {
                if (arr[j] - arr[j - 1] >= i) {
                    result_ok = false;
                    break;
                }
                if (arr[j + 1] - arr[j - 1] >= i) {
                    result_ok = false;
                    break;
                }
            }
            if (result_ok) {
                cout << i;
                return 0;
            }
        }
        cout << 0;
    }
    return 0;
}

int compare(const void* a, const void* b) {
    long long x = *(long long*)a;
    long long y = *(long long*)b;
    if (x < y) return -1;
    else if (x == y) return 0;
    else return 1;
}