#include <iostream>
#include <cmath>
using namespace std;
int compare(const void* a, const void* b);
bool checkSteps(long long* arr, int size, long long step);
int main() {
    int size;
    cin >> size;
    long long* arr = new long long[size];
    for (int i = 0; i < size; i++) cin >> arr[i];
    qsort(arr, size, sizeof(long long), compare);
    bool result_ok = true;
    long long min = arr[0];
    if (arr[0] == 0L) min++;
    for (long long i = min; i < arr[2]; i++) {
        result_ok = checkSteps(arr, size, i);
        if (result_ok) {
            cout << i;
            break;
        }
    }
    if (!result_ok) cout << 0;
    return 0;
}

int compare(const void* a, const void* b) {
    long long x = *(long long*)a;
    long long y = *(long long*)b;
    if (x < y) return -1;
    else if (x == y) return 0;
    else return 1;
}

bool checkSteps(long long* arr, int size, long long step) {
    for (int j = 1; j < size; j++) {
        long long card = arr[j];
        long long stack = arr[j - 1];
        if ((card < stack) || (card > stack + step)) {
            return false;
        }
        if (j != size - 1) {
            long long next_card = arr[j + 1];
            if ((next_card >= stack) && (next_card <= stack + step)) {
                return false;
            }
        }
    }
    return true;
}