from collections import defaultdict
from math import ceil

n, w, h, s = map(int, input().strip().split())

switches = defaultdict(lambda: defaultdict(lambda: defaultdict(int)))

for i in range(n):
    letter = input().strip()
    for line_num in range(h):
        line = input()
        for row in range(w)[::-1]:
            character = line[row]

            # last char
            if row == w - 1:
                if character == '#':
                    switches[letter][line_num][row] = 2
                else:
                    switches[letter][line_num][row] = 0
                continue
            if character == '#':
                if line[row+1] == '.':
                    switches[letter][line_num][row] = switches[letter][line_num][row+1] + 2
                else:
                    switches[letter][line_num][row] = switches[letter][line_num][row + 1]
            else:
                switches[letter][line_num][row] = switches[letter][line_num][row + 1]

max_num = -1
max_letter = ""

for letter in switches:
    for line in switches[letter]:
        for row in switches[letter][line]:
            if switches[letter][line][row] > max_num:
                max_num = switches[letter][line][row]
                max_letter = letter


print(max_letter * int(ceil(s / max_num)))

