import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {

    public static void main(String[] args)  throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

        String str = reader.readLine();

        String[] strings = str.split(" ");

        int n = Integer.parseInt(strings[0]);
        int w = Integer.parseInt(strings[1]);
        int h = Integer.parseInt(strings[2]);
        int s = Integer.parseInt(strings[3]);

        String[] letters = new String[n];
        String[][][] chars = new String[n][h][w];
        int[] maxs = new int[n];
        int count = 0;

        for (int i = 0; i < n; i++) {
            letters[i] = reader.readLine();
            for (int j = 0; j < h; j++) {
                chars[i][j] = reader.readLine().split("");

                if (chars[i][j][0].equals("#")) count++;
                if (chars[i][j][w-1].equals("#")) count++;

                for (int z = 0; z < w - 1; z++) {
                    if (!chars[i][j][z].equals(chars[i][j][z + 1])) {
                        count++;
                    }
                }


                maxs[i] += count;
                count = 0;
            }
        }
        int sum = max(maxs)[0];
        int index = max(maxs)[1];

        for (int i=0;i<n;i++) System.out.print(letters[index]);
            while (sum<s) {
                System.out.print(letters[index]);
                sum+=sum;
            }
    }

    public static int[] max(int[] array) {

        int maximum = array[0];
        int index = 0;

        for (int i = 0; i < array.length; i++)
            if (maximum < array[i]) {
                maximum = array[i];
                index = i;
            }
        int[] res = {maximum, index};
        return res;
    }
}