#include <stdio.h>
#include <vector>
#include <algorithm>

typedef unsigned long int ulint;

int main()
{
    unsigned int n;
    scanf("%d", &n);
    
    std::vector<ulint> cards;

    for (unsigned int i = 0; i < n; i++)
    {
        ulint val;

        scanf("%ld", &val);
        cards.push_back(val);
    }
    
    //sort 
    std::sort(cards.begin(), cards.end());
    
    ulint lower_max = cards[0];
    ulint upper_min = cards[1];

    for (unsigned int i = 0; i < n; i++)
    {
        //printf("%ld ", cards[i]);

        if (i > 0)
        {
            if (i > 1)
            {
                if (upper_min > (cards[i] - cards[i - 2])) { upper_min = cards[i] - cards[i - 2]; }
            }
            else
            {
                if (upper_min > (cards[i] - 0)) { upper_min = cards[i] - 0; }
            }
        
            if (lower_max < (cards[i] - cards[i - 1])) lower_max = cards[i] - cards[i - 1];
        }    
    }

    if (lower_max >= upper_min) { printf("0"); }
    else { printf("%d", lower_max); }

    return 0;
}
