#include <stdio.h>
#include <algorithm>
#include <vector>
#include <utility>

using std::vector;
#define pi std::pair<int, int>
#define mp std::make_pair

const long long INF = 1e18;

int main() {
	int p;
	scanf("%d", &p);
	vector<int> kek[26];
	vector<pi> lol[26];
	for (int i = 0; i < p; i++) {
		char c, c1, c2;
		scanf("\n%c -> %c", &c, &c1);
		if (c1 >= 'A' && c1 <= 'Z') {
			scanf("%c", &c2);
			lol[c - 'A'].push_back(mp(c1 - 'A', c2 - 'A'));
		} else {
			kek[c1 - 'a'].push_back(c - 'A');
		}
	}
	int n, m, s, t;
	scanf("%d%d%d%d", &n, &m, &s, &t);
	s--, t--;
	long long dp[n][n][26];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int k = 0; k < 26; k++) {
				dp[i][j][k] = INF;
			}
		}
	}
	for (int i = 0; i < m; i++) {
		int u, v;
		char x;
		scanf("%d%d %c", &u, &v, &x);
		u--, v--;
		x -= 'a';
		for (int j : kek[x]) {
			dp[u][v][j] = 1;
		}
	}
	bool flag = true;
	while (flag) {
		flag = false;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int k = 0; k < n; k++) {
					for (int _ = 0; _ < 26; _++) {
						for (pi pa : lol[_]) {
							if (dp[j][i][pa.first] + dp[i][k][pa.second] < dp[j][k][_]) {
								flag = true;
								dp[j][k][_] = dp[j][i][pa.first] + dp[i][k][pa.second];
							}
						}
					}
				}
			}
		}
	}
	if (dp[s][t]['S' - 'A'] < INF) {
		printf("%lld", dp[s][t]['S' - 'A']);
	} else {
		printf("NO");
	}
	return 0;
}
