import java.math.BigInteger
import java.util.*
import kotlin.math.*

private fun readLn() = readLine()!! // string line
private fun readInt() = readLn().toInt() // single int
private fun readStrings() = readLn().split(" ") // list of strings
private fun readInts() = readStrings().map { it.toInt() } // list of ints
private fun readLongs() = readStrings().map { it.toLong() } // list of ints


fun main(args: Array<String>) {
    var p = readInt()
    var kek = MutableList<MutableList<Int>>(26) { mutableListOf() }
    var lol = MutableList<MutableList<Pair<Int, Int>>>(26) { mutableListOf() }
    for (i in 1..p) {
        val (c, tmp, c1) = readStrings()
        if (c1.length == 2) {
            lol[c[0].toInt() - 'A'.toInt()].add(c1[0].toInt() -  'A'.toInt() to c1[1].toInt() - 'A'.toInt())
        } else {
            kek[c1[0].toInt() - 'a'.toInt()].add(c[0].toInt() - 'A'.toInt())
        }
    }
    var (n, m, s, t) = readInts()
    s--
    t--
    val dp = mutableListOf<MutableList<MutableList<BigInteger>>>()
    val azaz = mutableListOf<MutableList<MutableList<Boolean>>>()
    for (i in 0 until n) {
        dp.add(mutableListOf())
        azaz.add(mutableListOf())
        for (j in 0 until n) {
            dp[i].add(mutableListOf())
            azaz[i].add(mutableListOf())
            for (chr in 0 until 26) {
                dp[i][j].add(BigInteger.valueOf(0))
                azaz[i][j].add(false)
            }
        }
    }

    for (i in 0 until m) {
        var (su, sv, sx) = readStrings()
        val u = su.toInt() - 1
        val v = sv.toInt() - 1
        val x = sx[0].toInt() - 'a'.toInt()
        for (j in kek[x]) {
            dp[u][v][j] = BigInteger.valueOf(1)
            azaz[u][v][j] = true
        }
    }

    var flag = true
    while (flag) {
        flag = false
        for (chr in 0 until 26) {
            for (pa in lol[chr]) {
                for (i in 0 until n) {
                    for (j in 0 until n) {
                        for (k in 0 until n) {
                            if (azaz[j][i][pa.first] && azaz[i][k][pa.second] && (!azaz[j][k][chr] || dp[j][i][pa.first] + dp[i][k][pa.second] < dp[j][k][chr])) {
                                flag = true
                                dp[j][k][chr] = dp[j][i][pa.first] + dp[i][k][pa.second]
                                azaz[j][k][chr] = true
                            }
                        }
                    }
                }
            }
        }
    }

    val indx = 'S'.toInt() - 'A'.toInt()
    if (azaz[s][t][indx]) {
        print(dp[s][t][indx])
    } else {
        print("NO")
    }
}