#pragma GCC optimize("O3")
#pragma GCC optimize ("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define sz(X) (int)(X).size()
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define fornr(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define forab(i, a, b) for(int i = int(a); i < int(b); i++)
#define all(X) X.begin(), X.end()

typedef long long ll;
typedef vector<pair<ll, ll>> vpll;
typedef pair<int, int> pii;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef double dbl;
typedef long double ld;
typedef vector<int> vi;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(20);

    int n;
    cin >> n;
    ld p;
    cin >> p;

    vi a(n);
    forn(i, n) cin >> a[i];

    vi x(n - 1), y(n - 1);
    forab(i, 1, n) {
        x[i - 1] = (a[i] - a[i - 1]);
        y[i - 1] = x[i - 1] * x[i - 1];
    }

    vector<ll> prefx(n), prefy(n);
    forab(i, 1, n) {
        prefx[i] = prefx[i - 1] + x[i - 1];
        prefy[i] = prefy[i - 1] + y[i - 1];
    }

    int cnt1 = 0, cnt2 = 0;
    forn(l, n) {
        forab(r, l + 2, n) {
            int len = r - l;
            ld A = (ld) (prefx[r] - prefx[l]) / (1.0 * len);
            ld D = sqrt((ld) (prefy[r] - prefy[l]) / (1.0 * len) - A * A);
            if (abs(A) < 1e-8) continue;
            if (D < 1e-8) {
                if (A > 0) cnt1++;
                if (A < 0) cnt2++;
                continue;
            }
            if (A / D >= p) cnt1++;
            if (A / D <= -p) cnt2++;
        }
    }
    cout << cnt1 << " " << cnt2 << "\n";
    return 0;
}