#include <cstdio>
#include <cassert>
#include <vector>
#include <iostream>
#include <algorithm>
#include <queue>
#include <set>
#include <unordered_map>
#include <cmath>

#define all(a) a.begin(), a.end()
#define beg() begin()
#define srt(a) sort(all(a))
#define ll long long
#define ld double
#define f first
#define s second
#define io cin.sync_with_stdio(false);cout.sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define EPS 1e-9
#define point pair<ll, ll>

using namespace std;

int main() {
    io;
    int n, w, h, s;
    cin >> n >> w >> h >> s;
    vector<char> c(n);
    vector<vector<vector<bool>>> bb(n, vector<vector<bool>>(h, vector<bool>(w + 2)));
    vector<vector<int>> hy(n, vector<int> (h));
    for(int i = 0; i < n; i++) {
        cin >> c[i];
        for(int u = 0; u < h; u++) {
            for(int j = 1; j <= w; j++) {
                char cc;
                cin >> cc;
                if(cc == '#')
                    bb[i][u][j] = true;
            }
        }
    }
    char ans;
    int col = -1;
    for(int gg = 0; gg < h; gg++) {
        for(int i = 0; i < n; i++) {
            for(int j = 1; j <= w + 1; j++) {
                if(bb[i][gg][j] != bb[i][gg][j - 1]) {
                    hy[i][gg]++;
                }
            }
        }
        int ind = 0;
        for(int i = 1; i < n; i++) {
            if(hy[i][gg] > hy[ind][gg]) {
                ind = i;
            }
        }
        if((s + hy[ind][gg] - 1) / hy[ind][gg] < col || col == -1) {
            col = (s + hy[ind][gg] - 1) / hy[ind][gg];
            ans = c[ind];
        }
    }
    for(int i = 0; i < col; i++) {
        cout << ans;
    }
}