#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,tune=native")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <queue>
#include <list>
#include <set>
#include <map>
#include <cassert>
#include <cmath>
#include <stack>
#include <ctime>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <random>
//#include "optimization.h"
using namespace std;
const double PI = 3.141592653589793;
typedef long long ll;
typedef unsigned long long ull;

random_device dev;
mt19937 rng(dev());
ll mod = 1e9;



void solve() {
	int d;
	cin >> d;
	double p;
	cin >> p;

	vector<ll> c(d), pref2(d, 0);

	for (int i = 0; i < d; i++) {
		cin >> c[i];
	}
	
	for (int i = 1; i < d; i++) {
		pref2[i] = pref2[i - 1] + (c[i] - c[i - 1]) * (c[i] - c[i - 1]); // CORRECT TOO
	}

	//for (int i = 0; i < d; i++) {
	//	cout << pref2[i] << " ";
	//}
	//cout << "\n\n";


	ll cntPos = 0, cntNeg = 0;

	for (ll i = 1; i < d; i++) {
		for (ll j = i + 1; j < d; j++) {

			double a = (c[j] - c[i - 1]) / (j - i + 1.);

			double k = sqrt( (pref2[j] - pref2[i - 1] + a * a * (j - i + 1.) - 2 * a * (c[j] - c[i - 1])) / (j - i + 1) );

			/*cout << a << " " << k << "\n";

			cout << (a > p * k) << "\n";
			cout << (a < -p * k) << "\n";*/

			if (a > p * k) {
				cntPos++;
				continue;
			}

			if (a < -p * k) {
				cntNeg++;
				continue;
			}
		}
	}
	cout << cntPos << " " << cntNeg << "\n";
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}