#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,tune=native")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <queue>
#include <list>
#include <set>
#include <map>
#include <cassert>
#include <cmath>
#include <stack>
#include <ctime>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <random>
//#include "optimization.h"
using namespace std;
const double PI = 3.141592653589793;
typedef long long ll;
typedef unsigned long long ull;

random_device dev;
mt19937 rng(dev());
ll mod = 1e9;


void solve() {
	// ENDL
	ll s;
	cin >> s;
	ll l = 0, r = s;
	while (l < r) {
		while (l < r && l * l + r * r > s) {
			r--;
		}
		if (l < r && l * l + r * r == s) {
			cout << "0 0\n";
			cout << -r << " " << l << '\n';
			cout << -r + l << " " << l + r << "\n";
			cout << l << " " << r << "\n";
			return;
		}
		l++;
	}

	cout << "Impossible" << '\n';

}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}