

#include <iostream>
#include <vector>
using namespace std;



struct Switches
{
	int cnt;
	bool b = false;
};

struct SupFont {
	char ch;
	vector<vector<bool>> pixel;
};
int n, w, h, s;
vector<Switches> v_sw;

vector<vector<Switches>> vv_sw;


int is_switch(bool b1, bool b2) {
	if (b1 xor b2) {
		return 1;
	}
	else {
		return 0;
	}
}

int cnt_switch(SupFont sf1, int n_str) {
	int res = 0;
	for (int i = 0; i < w-1; i++) {
		res += is_switch(sf1.pixel[n_str][i], sf1.pixel[n_str][i + 1]);
	}
	return res;
}

Switches cnt_switch_pair(SupFont sf1, SupFont sf2, int nomer_str) {
	Switches sw;
	int cnt = 0;
	cnt += cnt_switch(sf1, nomer_str);
	cnt += is_switch(sf1.pixel[nomer_str][w - 1], sf2.pixel[nomer_str][0]);
	cnt += cnt_switch(sf2, nomer_str);
	sw.cnt = cnt;
	sw.b = (bool)is_switch(sf1.pixel[nomer_str][0], sf2.pixel[nomer_str][w - 1]);
	return sw;
}

bool max_sw(Switches sw1, Switches sw2) {
	if (sw1.cnt == sw2.cnt) {
		return sw1.b;
	}
	else {
		return sw1.cnt > sw2.cnt;
	}
}

Switches cnt_switch(SupFont sf1) {
	Switches sw;
	vector<Switches> sws(h);
	int cnt = 0;
	for (int i = 0; i < h; i++) {
		sws[i].cnt = cnt_switch(sf1, i);
	}
	
	int	index = 0;
	for (int i = 0; i < h; i++) {
		if (max_sw(v_sw[i], v_sw[index])) {
			sw = v_sw[i];
			index = i;
		}
	}
	sw = v_sw[index];
	return sw;
}


Switches max_switch_for_pair(SupFont sf1, SupFont sf2) {
	Switches sw_max;
	sw_max.b = false;
	sw_max.cnt = 0;
	for (int i = 0; i < h; i++) {
		v_sw[i] = cnt_switch_pair(sf1, sf2, i);		
	}
	int index = 0;

	for (int i = 0; i < h; i++) {
		if (max_sw(v_sw[i], sw_max)) {
			sw_max = v_sw[i];
			index = i;
		}
	}
	return sw_max;
}


//void cnt_on_off(int &ch1, int &ch2, vector<SupFont> supFonts) {
//	for (int i = 0; i < h; i++) {
//		for (int j = 0; j < w; j++) {
//			
//		}
//	}
//}

int max_vect_switch(vector<Switches> &vect_sw) {
	int res = 0;
	for (int j = 0; j < vect_sw.size(); j++) {
		if (max_sw(vect_sw[j], vect_sw[res])) {
			res = j;
			//sw_max = v_sw[i];
		}
	}
	return res;
}



int main()
{

	//input data

	cin >> n >> w >> h >> s;
	vector<SupFont> supFonts(n);
	vv_sw.resize(n);
	for (int i = 0; i < n; i++) {
		vv_sw[i].resize(n);
	}
	v_sw.resize(h);
	for (int i = 0; i < n; i++) {
		supFonts[i].pixel.resize(h);
		cin >> supFonts[i].ch;
		for (int j = 0; j < h; j++) {
			supFonts[i].pixel[j].resize(w);
			for (int z = 0; z < w; z++) {
				char ch;
				cin >> ch;
				if (ch == '#') {
					supFonts[i].pixel[j][z] = true;
				}
				else {
					supFonts[i].pixel[j][z] = false;
				}
			}
		}
	}

	//int res = is_switch(false, true);
	//cout << res;

	//cout<<cnt_switch(supFonts[0], 0);
	//Switches sw;
	//sw = cnt_switch_pair(supFonts[0], supFonts[1], 0);
	//cout << sw.cnt << endl << sw.b;



	//all pairs
	//Switches sw_max;
	//sw_max.b = false;
	//sw_max.cnt = 0;
	int index_i = 0;//  
	int index_j = 0;//
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			vv_sw[i][j] = max_switch_for_pair(supFonts[i], supFonts[j]);
			if (max_sw(vv_sw[i][j], vv_sw[index_i][index_j])) {
				index_i = i;
				index_j = j;
				//sw_max = v_sw[i];
			}
		}
	}



	int cnt_pair_number, ost;

	if (vv_sw[index_i][index_j].b) {
		//cnt_pair_number = (s-1) / (vv_sw[index_i][index_j].cnt+1);
		//ost = (cnt_pair_number * (vv_sw[index_i][index_j].cnt + 1)) - 1;
		cnt_pair_number = s / (vv_sw[index_i][index_j].cnt + 1);
		ost = s % (vv_sw[index_i][index_j].cnt + 1);
	}else {
		cnt_pair_number = s / vv_sw[index_i][index_j].cnt;
		ost = s % vv_sw[index_i][index_j].cnt;
	}
	//cout << s << endl;
	//cout << cnt_pair_number<<endl;
	//cout << ost;
	for (int i = 0; i < cnt_pair_number; i++) {
		cout << supFonts[index_i].ch;
		cout << supFonts[index_j].ch;
	}
	if (ost != 0) {
		vector<Switches> tmpv(n);
		for (int i = 0; i < n; i++) {
			tmpv[i] = cnt_switch(supFonts[i]);
		}
		int nomer_ch = max_vect_switch(tmpv);
		cout << supFonts[nomer_ch].ch;
	}
	//cout << index_i << " " << index_j;

	return 0;
}



