#include <bits/stdc++.h>
using namespace std;

#define llong long long 
#define len(x) ((int)x.size())
#define rep(i,n) for (int i = -1; ++ i < n; )
#define rep1(i,n) for (int i = 0; i ++ < n; )
#ifdef testing
mt19937 rng(177013);
#else
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
#endif
#define rand() (int)(rng() >> 1)
#define CONCAT_(x, y) x##y/*{{{*/
#define CONCAT(x, y) CONCAT_(x, y)
#define SPEC(name) CONCAT(name, __LINE__)
#ifdef LOCAL_DEBUG   
int __db_level = 0;
#define clog cerr << string(__db_level * 2, ' ')
struct debug_block {
    string msg;
    debug_block(const string& s): msg(s) { clog << "{ " << msg << endl; ++__db_level; }
    ~debug_block() { --__db_level; clog << "} " << msg << endl; }
};
#define DB(args...) stringstream SPEC(ss); SPEC(ss)<< args; debug_block SPEC(dbbl)(SPEC(ss).str())
#else
#define clog if (0) cerr
#define DB(...)
#endif
#define db(val) "[" #val " = " << val << "]; "
template<class U, class V> ostream& operator<<(ostream& out, const pair<U, V>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")";
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup);
}
template<class ...U>
ostream& operator<<(ostream& out, const tuple<U...>& tup) { return print_tuple_utils<0, tuple<U...>>(out, tup); }
template<class, typename = void> struct has_const_iterator : false_type {};
template<class T> struct has_const_iterator<T, void_t<typename T::const_iterator>> : true_type {};
template<class T>
typename enable_if<has_const_iterator<T>::value && !is_same<T, string>::value, ostream&>::type
operator<<(ostream& out, const T& container) { 
    auto beg = container.begin(), end = container.end();
    out << "(" << container.size() << ") {";
    if (beg != end) out << *(beg++);
    while (beg != end) out << ", " << *(beg++);
    return out << "}";
}
#define ptrtype(x) typename iterator_traits<x>::value_type
template<class u> vector<ptrtype(u)> $v(u a, u b) { return vector<ptrtype(u)>(a, b); }/*}}}*/
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////

using ld = long double;
const int maxn = 3030;
const ld eps = 1e-10;
int n;
ld p;
int c[maxn];
int diff[maxn];

ld cal_avg(int l, int r) {
    ld sum = 0;
    for (int i = l; i <= r; ++i) sum += diff[i];
    return sum / (r - l + 1);
}

ld cal_std(int l, int r) {
    auto a = cal_avg(l, r);
    ld sum = 0;
    for (int i = l; i <= r; ++i) sum += (diff[i] - a) * (diff[i] - a);
    return sqrt(sum / (r - l + 1));
}

int main(void) {
#ifdef LOCAL
    freopen("main.inp", "r", stdin);
    freopen("main.out", "w", stdout);
    freopen(".log", "w", stderr);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> p;
    rep(i, n) cin >> c[i];
    rep(i, n - 1) diff[i] = c[i + 1] - c[i];
    
    llong neg_ans = 0, pos_ans = 0;
    clog << db(vector(diff, diff + n -1 )) << endl;
    
    // rep(left, n - 1) { 
        // for (int right = left; right < n - 1; ++ right) { 
            // int cnt = right - left + 1; 
            // if (cnt < 2) continue; 
            // auto a = cal_avg(left, right); 
            // auto d = cal_std(left, right); 
            // if (abs(a) < eps) continue; 
            // if (abs(d) < eps or abs(a / d) >= p) { 
                // if (a > 0) { 
                    // clog << "+ " << left << ' ' << right << endl; 
                // } 
                // else clog << "- " << left << ' ' << right << endl; 
            // } 
        // } 
    // } 
    
    rep(left, n - 1) {
        llong sum = 0;
        llong sum_sqr = 0;
        
        for (int right = left; right < n - 1 ; ++right) {
            int cnt = right - left + 1;
            sum += diff[right];
            sum_sqr += diff[right] * diff[right];
            ld avg = (ld)sum / cnt;
            if (cnt < 2) continue;
            if (cnt * avg * avg * (1 - p * p) >= p * p * (sum_sqr - 2 * avg * sum)) {
                if (sum == 0) continue;
                if (sum < 0) {
                    neg_ans++;
                } else {
                    pos_ans++;
                    clog << db(left) << db(right) << db(neg_ans) << db(pos_ans) << db(sum) << db(sum_sqr) << db(avg) << endl;
                }
            }
        }
    }
    cout << pos_ans << ' ' << neg_ans;
    
    return 0;
}

// vim: foldmethod=marker

