#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

ll c[200][200];

int rev(int mask, int n) {
  vector<int> v;
  for (int i = 0; i < n; i++) {
    v.push_back((mask >> i) & 1);
  }
  int res = 0;
  for (int i = 0; i < n; i++) {
    res = res * 2 + v[i];
  }
  return res;
}

int n, k;

int slow_solve() {
  set<int> masks;
  int cnt = 0;
  for (int mask = 0; mask < (1 << n); mask++) {
    if (__builtin_popcount(mask) <= min(n, k) && k - __builtin_popcount(mask) <= min(n, k) && !masks.count(mask)) {
      masks.insert(mask);
      masks.insert(rev(mask, n));
      cnt++;
      if (k % 2 == 0 && __builtin_popcount(mask) == k / 2) {
        cnt++;
      }
    }
  }
  return cnt;
}

void read() {
  cin >> n >> k;
}

ll calc(ll n, ll i) {
  ll cur;
  if (i % 2 == 0) {
    cur = (c[n][i] + c[n / 2][i / 2]) / 2;
  } else {
    cur = c[n][i] / 2;
  }
  return cur;
}

ll solve() {
  c[0][0] = 1;
  for (int i = 1; i < 200; i++) {
    c[i][0] = 1;
    for (int j = 1; j < 200; j++) {
      c[i][j] = c[i - 1][j - 1] + c[i - 1][j];
    }
  }

  if (k == 0) {
    return 2;
  } else if (k == 2 * n) {
    return 2;
  }
  ll ans = 0;
  for (int i = max(1, k - n); i <= min(n - 1, k); i++) {
    ll cur;
    if (n % 2 == 0) {
      cur = calc(n, i);
    } else {
      cur = calc(n - 1, i) + calc(n - 1, i - 1);
    }
    if (k % 2 == 0 && i == k / 2) {
      cur *= 2;
    }
    ans += cur;
  }
  if (k >= n) {
    ans++;
  }
  if (k <= n) {
    ans++;
  }
  return ans;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  read();cout << solve(); return 0;
  for (int i = 1; i < 10; i++) {
    cout << i << ": ";
    for (int j = 0; j <= min(2 * i, 10); j++) {
      n = i, k = j;
      cout << solve() << " ";
    }
    cout << endl;
  }
  cout << endl;

  for (int i = 1; i < 10; i++) {
    cout << i << ": ";
    for (int j = 0; j <= min(2 * i, 10); j++) {
      n = i, k = j;
      cout << slow_solve() << " ";
    }
    cout << endl;
  }
  return 0;
}
