#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <cmath>
#include <iomanip>
#include <map>
#include <stack>
#include <set>
#include <queue>
#include <unordered_map>
#include <stdio.h>
#include <memory.h>
#include <bitset>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(a) (a)*(a)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const ll mod = 998244353;
const int inf = 1e9;
const ll biginf = 1e18;
const ld pi = acosl(-1);
const ld eps = 1e-9;
const int maxn = 1e5+1;
const ll negativeInf = -1e18;

void solve() {
	int n, w, h, s;
	cin >> n >> w >> h >> s;
	int maxsw = -1;
	char maxc = '0';
	for (int i = 0; i < n; i++) {
		char c;
		cin >> c;
		for (int j = 0; j < h; j++) {
			string str;
			cin >> str;
			int cur = 0;
			char st = '.';
			for (int k = 0; k < w; k++) {
				if (str[k] != st) {
					cur++;
					st = str[k];
				}
			}
			if (st == '#') {
				cur++;
			}
			if (cur > maxsw) {
				maxsw = cur;
				maxc = c;
			}
		}
	}
	for (int i = 0; i < (s + maxsw - 1) / maxsw; i++) {
		cout << maxc;
	}
}

void multisolve(){
	int t;
	cin >> t;
	while(t--){
		solve();
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed;
	solve();
}