#include <bits/stdc++.h>
 
using namespace std;

#define mp make_pair
#define pb push_back
#define fastIo ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define pii pair <int, int>
#define fs first
#define sc second
#define getFiles ifstream cin("input.txt"); ofstream cout("output.txt");
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;

const int INF = 2e9;
const ll BIG_INF = 1e18;
const ll MOD = 1e9 + 7;

const int MAX_N = 1e5 + 5;
int n, c, m, a[MAX_N], b[MAX_N];
vector<int> g[MAX_N], st, eulerPath, notUsed, ans;
map<int, int> verts;
map<pii, vector<int>> inds;
bool w[MAX_N];

bool isExist(int v) {
    return verts.find(v) != verts.end();
}

void updNotUsed(int v) {
    vector<int> newNotUsed;
    for (const int &j : notUsed) {
        if (a[j] != v) {
            ans.pb(j);
        } else {
            newNotUsed.pb(j);
        }
    }
    
    notUsed = newNotUsed;
}

int main() {
    fastIo;
    cin >> n >> c;
    
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> w[i];
        
        if (w[i]) {
            cnt++;
            if (!isExist(a[i])) {
                verts[a[i]] = ++m;
            }
            
            g[verts[a[i]]].pb(b[i]);
            inds[{a[i], b[i]}].pb(i);
        } else {
            notUsed.pb(i);
        }
    }
    
    if (!isExist(c)) {
        if (cnt) {
            cout << "No";
        } else {
            for (int i = 0; i < n; i++) {
                if (a[i] == c) {
                    cout << "No\n";
                    return 0;
                }
            }
            
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                cout << i + 1 << ' ';
            }
        }
        
        return 0;
    }
    
    st.pb(c);
    while (!st.empty()) {
        int val = st.back();
        
        if (!isExist(val)) {
            eulerPath.pb(val);
            st.pop_back();
            continue;
        }
        
        int v = verts[val];
        if (g[v].empty()) {
            eulerPath.pb(val);
            st.pop_back();
            continue;
        }
        
        st.pb(g[v].back());
        g[v].pop_back();
    }
    
    if (sz(eulerPath) != cnt + 1) {
        cout << "No";
        return 0;
    }
    
    updNotUsed(c);
    reverse(all(eulerPath));
    
    for (int i = 0; i < cnt; i++) {
        pii x = {eulerPath[i], eulerPath[i + 1]};
        
        if (inds[x].empty()) {
            cout << "No";
            return 0;
        }
        
        ans.pb(inds[x].back());
        inds[x].pop_back();
        
        updNotUsed(eulerPath[i + 1]);
    }
    
    if (sz(ans) == n) {
        cout << "Yes\n";
        for (const int &i : ans) {
            cout << i + 1 << ' ';
        }
    } else {
        cout << "No";
    }
    return 0;
}
