#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <cmath>
#include <iomanip>
#include <map>
#include <stack>
#include <set>
#include <queue>
#include <unordered_map>
#include <stdio.h>
#include <memory.h>
#include <bitset>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(a) (a)*(a)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const ll mod = 998244353;
const int inf = 1e9;
const ll biginf = 1e18;
const ld pi = acosl(-1);
const ld eps = 1e-9;
const int maxn = 1e5+1;
const ll negativeInf = -1e18;

void solve() {
	int d;
	ld p;
	cin >> d >> p;
	vector<ld> c(d), dif(d - 1), pdif(d - 1), psqdif(d - 1);
	for (int i = 0; i < d; i++) {
		cin >> c[i];
		if (i > 0) {
			dif[i - 1] = c[i] - c[i - 1];
			pdif[i - 1] = dif[i - 1];
			psqdif[i - 1] = sqr(dif[i - 1]);
			if (i > 1) {
				pdif[i - 1] += pdif[i - 2];
				psqdif[i - 1] += psqdif[i - 2];
			}
		}
	}
	int cntUp = 0, cntDown = 0;
	for (int i = 2; i < d; i++) {
		for (int j = i - 2; j >= 0; j--) {
			ld cnt = i - j;
			ld a;
			if (j == 0) {
				a = pdif[i - 1] / cnt;
			} else {
				a = (pdif[i - 1] - pdif[j - 1]) / cnt;
			}
			ld dsqr;
			if (j == 0) {
				dsqr = (psqdif[i - 1] + cnt * sqr(a) - 2 * a * pdif[i - 1]) / cnt;
			} else {
				dsqr = (psqdif[i - 1] - psqdif[j - 1] + cnt * sqr(a) - 2 * a * (pdif[i - 1] - pdif[j - 1])) / cnt;
			}
			ld d = sqrtl(dsqr);
			if (a / d >= p || (a > 0 && fabsl(d) < eps)) {
				cntUp++;
			}
			if (a / d <= -p || (a < 0 && fabsl(d) < eps)) {
				cntDown++;
			}
		}
	}
	cout << cntUp << " " << cntDown << "\n";
}

void multisolve(){
	int t;
	cin >> t;
	while(t--){
		solve();
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed;
	solve();
}