#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef double ld;

#define f first
#define s second
#define all(a) a.begin(), a.end()

map<pair<ll, ll>, ll> mem;
ll cnk(ll n, ll k) {
	if (k == 0) return 1;
    if (mem.count({n, k})) {
        return mem[{n, k}];
    }
    if (k == 0 || k == n) {
        return mem[{n, k}] = 1;
    }
    return mem[{n, k}] = (cnk(n - 1, k - 1) + cnk(n - 1, k));
}

ll f(ll n, ll k) {
	ll ans = cnk(n, k);
	if (n % 2 == 0 && k % 2 == 1) {
		return ans / 2ll;
	}
	else {
		ans += cnk(n / 2ll, k / 2ll);
		return ans / 2ll;
	}
}


void solve() {
	ll n, k, ans = 0;
	cin >> n >> k;
	for (int i = 0; i <= k / 2; i++) {
		ans += f(n, i) + f(n, k - i);
	}
	cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    #ifdef HOME
        freopen("input.in", "r", stdin);
        freopen("output.out", "w", stdout);
        clock_t clock1;
        clock1 = clock();
    #else
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
    #endif
	// int t;
	// cin >> t;
	// while (t--)
    solve();
    // system("pause");
    #ifdef HOME
        cout << "\n----------------------\n";
        cout << "time: " << (float) (clock() - clock1) / CLOCKS_PER_SEC;
    #endif
    return 0;
}
