#include <iostream>
#include <set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>

#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define fileio freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout)
#define pll pair<ll, ll>
#define pii pair<int, int>
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;
typedef long double ld;
const ll mod = 1e9;
const ll inf = 1e17;

int main() {
   int n;
   cin >> n;
   vector<ll> v(n + 1, 0);
   for (int i = 0; i < n; ++i) {
       cin >> v[i + 1];
   }
   sort(v.begin(), v.end());
   ll mx = -inf;
   ll mn = inf;
   for (int i = 1; i < n; ++i) {
       mn = min(mn, v[i + 1] - v[i - 1]);
       mx = max(mx, v[i] - v[i - 1]);
   }
   mx = max(mx, v[n] - v[n - 1]);
   if (mx > mn) {
       cout << 0;
   } else {
       cout << mx;
   }
}
