#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

const int maxn = 51;
vector<vector<ll>> cnk(maxn, vector<ll>(maxn));

ll symmetric(ll n, ll k) {
    if (n % 2 == 0 && k % 2 == 1) return 0;
    return cnk[n / 2][k / 2];
}

int main() {
    cnk[0][0] = 1;
    for (int i = 1; i < maxn; ++i) {
        for (int j = 0; j < maxn; ++j) cnk[i][j] = cnk[i - 1][j] + (j > 0 ? cnk[i - 1][j - 1] : 0);
    }
    int n, k;
    cin >> n >> k;
    ll ans = 0;
    for (int i = 0; i <= min(n, k); ++i) {
        if (i + n < k) continue;
        ll x = cnk[n][i];
        ll y = symmetric(n, i);
        ans += (x + y) / 2;
        if (2 * i == k) ans += (x + y) / 2;
    }
    cout << ans << '\n';
    return 0;
}
