import java.io.*;
import java.util.*;

public class Main {
    static int[] parent;
    static int[] size;
    static int[] exp;
    static int n;
    static String command;
    static Character symbol, last;

    static int[] sumSquare(int n) {
        for (int i = 0; i * i <= n; i++)
            for (int j = 0; j * j <= n; j++)
                if (i * i + j * j == n) {
                    return new int[]{i, j};
                }
        return new int[]{-1, -1};
    }

    public static void main(String[] args) {
        FastScanner scanner = new FastScanner(System.in);
        PrintStream writer = System.out;
        int s = scanner.nextInt();
        int[] a = sumSquare(s);
        if (a[0] == -1 && a[1] == -1) {
            writer.println("Impossible");
        } else {
            int x1, y1, x2, y2, x3, y3, x4, y4;
            x1 = a[0];
            y1 = a[1];
            x2 = x1 + a[0];
            y2 = y1 + a[1];
            x3 = x1 + a[1];
            y3 = y1 - a[0];
            x4 = x3 + a[0];
            y4 = y3 + a[1];
            writer.println(x1 + " " + y1);
            writer.println(x2 + " " + y2);
            writer.println(x3 + " " + y3);
            writer.println(x4 + " " + y4);
        }

    }


    static class MyStack {
        Stack<Integer> stackArray;
        Stack<Integer> minimalElement;

        MyStack() {
            stackArray = new Stack<>();
            minimalElement = new Stack<>();
        }

        public int getMinimum() {
            return minimalElement.peek();
        }

        void pop() {
            Integer t = stackArray.pop();
            if (t == getMinimum()) {
                minimalElement.pop();
            }
        }

        void push(Integer x) {
            if (stackArray.isEmpty()) {
                minimalElement.push(x);
                stackArray.push(x);
                return;
            }
            if (x <= getMinimum()) {
                minimalElement.push(x);
            }
            stackArray.push(x);
        }
    }

    public static class FastScanner implements AutoCloseable {
        BufferedReader br;
        StringTokenizer in;

        public FastScanner(InputStream stream) {
            br = new BufferedReader(new InputStreamReader(stream));
        }

        public String nextToken() {
            try {
                while (in == null || !in.hasMoreTokens()) {
                    in = new StringTokenizer(br.readLine());
                }
                return in.nextToken();
            } catch (IOException e) {
                System.out.printf("I/O error! %s", e.getMessage());
                return "";
            }
        }

        public int nextInt() {
            return Integer.parseInt(nextToken());
        }

        public void close() {
            try {
                br.close();
            } catch (IOException e) {
                System.out.printf("I/O error! %s", e.getMessage());
            }
        }
    }
}
