#include <bits/stdc++.h>

#include <iostream>

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define ef emplace_back
#define x first
#define y second
#define sz(x) (int)x.size()
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define FOR(i, a, b) for (int i = (a); i < (b); i++)
#define RFOR(i, b, a) for (int i = (b)-1; i >= (a); i--)

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ld, ld> pld;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

const int INF_I = 1e9;
const ll INF_LL = 1e18;
const int MOD = 1000000007;
const double eps = 1e-6;
//(clock() * 1.0 / CLOCKS_PER_SEC)

unordered_map<int, list<pi>> a, b;
unordered_set<int> used;
vector<int> res;
void dfs1(int v) {
  if (used.find(v) != used.end()) return;
  used.emplace(v);
  for (pi to : a[v]) dfs1(to.x);
}

void dfs2(int v, int index) {
  if (used.find(v) != used.end()) return;
  used.emplace(v);
  for (auto it1 = b.begin(); it1 != b.end();) {
    auto cur = *it1;
    if (cur.x == v) {
      it1++;
      continue;
    }
    for (auto it = cur.y.begin(); it != cur.y.end();) {
      res.emplace_back(it->y);
      it = cur.y.erase(it);
    }
    it1 = b.erase(it1);
  }
  for (pi to : a[v]) {
    res.emplace_back(to.y);
    dfs2(to.x, to.y);
  }
}

void solve() {
  int n, c;
  cin >> n >> c;
  int count = 0;
  for (int i = 0; i < n; i++) {
    int f, t, w;
    cin >> f >> t >> w;
    if (w == 0)
      b[f].emplace_back(t, i + 1);
    else {
      a[f].emplace_back(t, i + 1);
      count++;
    }
  }
  dfs1(c);
  if (sz(used) != count + 1) {
    cout << "No\n";
    return;
  }
  used.clear();
  dfs2(c, -1);
  if (sz(b) != 0){
    cout << "No\n";
    return;
  }
  for (int i : res) cout << i << ' ';
}

int main() {
  // freopen("garland.in", "r", stdin);
  // freopen("garland.out", "w", stdout);
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  int t = 1;
  while (t--) solve();

  return 0;
}