﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_map>

using namespace std;

int main() {
	int d;
	double p;
	cin >> d >> p;
	vector<double> c(d);
	int ansp = 0, ansn = 0;
	for (int i = 0; i < d; i++) {
		cin >> c[i];
	}
	vector<long long> prefsum(d);
	prefsum[0] = 0;
	for (int i = 1; i < d; i++) {
		prefsum[i] = (c[i] - c[i - 1]) * (c[i] - c[i - 1]) + prefsum[i - 1];
	}
	for (int l = 0; l < d; l++) {
		for (int r = l + 2; r < d; r++) {
			
			double a = (c[r] - c[l]) / (r - l);
			double b = double(prefsum[r] - prefsum[l]) / (r - l);
			b = sqrt(b - a * a);
			if (b == 0 && a == 0)continue;
			if (b == 0 && a > 0) {
				ansp++;
				continue;
			}
			if (b == 0 && a < 0) {
				ansn++;
				continue;
			}
			if (a / b >= p) {
				ansp++;
			}
			if (a / b <= -p) {
				ansn++;
			}
		}
	}
	cout << ansp << " " << ansn;
}