#include <iostream>
#include <set>
#include <vector>
#include <utility>
#include <queue>
#include <iomanip>
#include <unordered_map>
#include <algorithm>
#include <streambuf>
#include <fstream>
#include <map>
#define M_PI 3.14159265358979323846264338327950288
#define oo 1000000007
#define maxN 300007
using namespace std;

long long c[maxN], diff[maxN], sum_diff[maxN], sum_diff_pow_2[maxN];

int main() {
//#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif

    int n; double P;
    cin >> n >> P;

    for (int i = 1; i <= n; ++i) {
        cin >> c[i];
    }

    for (int i = 2; i <= n; ++i) {
        diff[i] = c[i]-c[i-1];
    }
    for (int i = 2; i <= n; ++i) {
        sum_diff[i] = sum_diff[i-1]+diff[i];
    }
    for (int i = 2; i <= n; ++i) {
        sum_diff_pow_2[i] = sum_diff_pow_2[i-1]+diff[i]*diff[i];
    }

    int pos = 0, neg = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = i+2; j <= n; ++j) {
            double p_1 = (double)sum_diff[j]-(double)sum_diff[i];
            double p_2 = (double)sum_diff_pow_2[j]-(double)sum_diff_pow_2[i];
            double A = p_1/(j-i);
            double D =  sqrt((p_2
                            -(double)2.0*A*p_1
                            +(double)A*A*(j-i))/((double)j-i));
            if (D*P <= A) ++pos;
            if (-D*P >= A) ++neg;
        }
    }

    cout << pos << " " << neg << endl;
    return 0;
}