#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

vector<vector<pair<int, int>>> rules(26);
vector<vector<char>> terms(26);
char G[31][31][31];
ll d[31][31][31];

void solve() {
    for (auto &i : d) {
        for (auto &j : i) {
            for (long long &k : j) {
                k = (ll) 1e18 + 7;
            }
        }
    }

    int p;
    cin >> p;
    for (int i = 0; i < p; i++) {
        char nont;
        cin >> nont;
        string tmp;
        cin >> tmp;
        string sec;
        cin >> sec;
        if (sec.size() == 2) {
            rules[nont - 'A'].emplace_back(sec[0] - 'A', sec[1] - 'A');
        } else {
            terms[nont - 'A'].push_back(sec[0] - 'a');
        }
    }

    int n, m, s, t;
    cin >> n >> m >> s >> t;
    s--, t--;

    for (int i = 0; i < m; i++) {
        int a, b;
        char c;
        cin >> a >> b >> c;
        a--, b--;
        G[a][b][c - 'a'] = 1;
    }

    for (int a = 0; a < n; a++) {
        for (int b = 0; b < n; b++) {
            for (int nt = 0; nt < 26; nt++) {
                for (auto c : terms[nt]) {
                    if (G[a][b][c]) {
                        d[a][b][nt] = 1;
                    }
                }
            }
        }
    }

    for (int it = 0; it < 60; it++) {
        for (int a = 0; a < n; a++) {
            for (int b = 0; b < n; b++) {
                for (int c = 0; c < n; c++) {
                    for (int nt = 0; nt < 26; nt++) {
                        for (auto rule : rules[nt]) {
                            if (d[a][c][rule.first] < (ll) 1e18 && d[c][b][rule.second] < (ll) 1e18) {
                                d[a][b][nt] = min(d[a][b][nt], d[a][c][rule.first] + d[c][b][rule.second]);
//                                assert(d[a][b][nt] <= (it + 5));
                            }
                        }
                    }
                }
            }
        }
    }


    if (d[s][t]['S' - 'A'] >= (ll) 1e18) {
        cout << "NO\n";
    } else {
        cout << d[s][t]['S' - 'A'] << "\n";
    }
}