

import java.io.BufferedReader;
import java.util.*;




public class taskE {
    public static class MyPair {
        int a;
        int b;
        int num;
        public MyPair(int a, int b, int num) {
            this.a = a;
            this.b = b;
            this.num = num;
        }
    }
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int c = scanner.nextInt();
        c--;
        Map<Integer, List<MyPair>> lst = new HashMap<>();
        Map<Integer, List<Integer>> adding = new HashMap<>();
        Map<Integer, Integer> rev_list = new HashMap<>();
        TreeSet<Integer> from  =new TreeSet<Integer>();
        List<MyPair> no_this = new ArrayList<>();
        int minA = Integer.MAX_VALUE;
        int maxA = Integer.MIN_VALUE;
        for (int i = 0; i < n; i++) {
            int a = scanner.nextInt();
            int b = scanner.nextInt();
            int w = scanner.nextInt();
            if (w == 1) {
                if (lst.get(a  - 1) == null) {
                    lst.put(a - 1, new ArrayList<>());
                }
                lst.get(a - 1).add(new MyPair(a  - 1, b - 1, i));
                rev_list.put(b - 1, rev_list.getOrDefault(b  - 1, 0) + 1);
                minA = Integer.min(minA, a - 1);
                maxA = Integer.max(maxA, a - 1);
            } else {
                no_this.add(new MyPair(a - 1, b - 1, i));
            }
        }



        boolean flag = true;
        //CHECK ZERO EDGES
        for (MyPair x : no_this) {
            if (n  - lst.getOrDefault(x.a, new ArrayList<>()).size() <= 0) {
                flag = false;
                continue;
            } else {
                if (minA != x.a) {
                    if (adding.get(minA) == null) {
                        adding.put(minA, new ArrayList<>());
                    }
                    adding.get(minA).add(x.num);
                } else if (maxA != x.a) {
                    if (adding.get(maxA) == null) {
                        adding.put(maxA, new ArrayList<>());
                    }
                    adding.get(maxA).add(x.num);
                }
            }
        }


        //CHECK IS EULER
        int cntEnds = 0;
        for (int i = 0; i  < n ; i++) {
            if (i == c) {
               if (rev_list.getOrDefault(i, 0) + 1 != lst.getOrDefault(i, new ArrayList<>()).size()) {
                   flag  = false;
               }
               continue;
            }

            if (lst.getOrDefault(i, new ArrayList<>()).size() + 1 == rev_list.getOrDefault(i, 0)) {
                cntEnds++;
            }
        }
        flag = flag & (cntEnds <= 1);


        if (!flag) {
            System.out.println("No");
            return;
        }
        //BUild euler
        boolean[] marked = new boolean[n];
        Stack<MyPair> stack = new Stack<>();
        stack.add(new MyPair(0, c, -1));
        List<Integer> path = new ArrayList<>();
        while (!stack.empty()) {
            MyPair cur = stack.peek();
            boolean found = false;
            for (MyPair pair : lst.getOrDefault(cur.b, new ArrayList<>())) {
                if (!marked[pair.num]) {
                    marked[pair.num] = true;
                    found = true;
                    stack.push(new MyPair(0, pair.b, pair.num));
                }
            }
            if (!found) {
                // fix numbers
                // add cycle
                stack.pop();
                for (int x : adding.getOrDefault(cur.b, new ArrayList<Integer>())) {
                    path.add(x);
                }
                if (cur.num != -1) {
                    path.add(cur.num);
                }
            }
        }
        Collections.reverse(path);
        if (path.size() < n) {
            System.out.println("No");
            return;
        }
        System.out.println("Yes");
        for (int x : path) {
            System.out.print(x + 1);
            System.out.print(" ");
        }
    }
}
