#include <bits/stdc++.h>

using namespace std;

int n;
vector<multiset<pair<int, int>>> edg;
vector<multiset<int>> edg_n;
vector<int> in, out;
vector<bool> used;
vector<int> ans;
unordered_map<int, int> id;
set<pair<int, int>> bad;
int cnt = 0;

bool check(int st) {
  int same = 0, stok = 0, istok = 0;
  int stok_id = -1;
  int istok_id = -1;
  for (int i = 0; i < cnt; ++i) {
    if (out[i] == in[i]) ++same;
    if (out[i] == in[i] - 1){
      ++stok;
      stok_id = i;
    }
    if (st == i && out[i] - 1 == in[i]) {
      ++istok;
      istok_id = i;
    }
  }
  if (stok == 1 && istok == 1 && same == cnt - 2) {
    edg[stok_id].insert({istok_id, -1});
    return true;
  }
  return same == cnt;
}

void dfs(int v, int &cnt_m) {
  ++cnt_m;
  used[v] = true;

  for (auto &e : edg_n[v]) {
    if (!used[e]) {
      dfs(e, cnt_m);
    }
  }
}

void euler(int v) {
  stack<pair<int, int>> st;
  st.push({v, -10});
  while(!st.empty()) {
    auto u = st.top();
    pair<int, int> f = {-1, -1};
    for (auto &e : edg[u.first]) {
      st.push(e);
//      cout << u.first << " " << e.first << "\n";
//      ans.push_back(e.second);
      f = e;
      break;
    }
    if (f.first == -1) {
      st.pop();
      ans.push_back(u.second);
    }
    else {
      edg[u.first].erase(f);
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  int c;
  cin >> n >> c;
  unordered_map<int, pair<int, int>> cache;
  for (int i = 0; i < n; ++i) {
    int a, b, w;
    cin >> a >> b >> w;
    if (w == 0) {
      bad.insert({a, i});
    }
    else {
      if (id.count(a) == 0) {
        id[a] = cnt++;
        in.push_back(0);
        out.push_back(0);
        edg.emplace_back();
        edg_n.emplace_back();
        used.emplace_back();
      }
      if (id.count(b) == 0) {
        id[b] = cnt++;
        in.push_back(0);
        out.push_back(0);
        edg.emplace_back();
        edg_n.emplace_back();
        used.emplace_back();
      }
      int id_a = id[a];
      int id_b = id[b];
      ++out[id_a];
      ++in[id_b];
      edg[id_a].insert({id_b, i});
      edg_n[id_a].insert(id_b);
      cache[i] = {a, b};
    }
  }

  int cnt_m = 0;
  if (bad.size() != n && id.count(c) == 0) {
    cout << "No";
    return 0;
  }
  if (bad.size() == n) {
    for (auto &el : bad) {
      if (el.first == c) {
        cout << "No";
        return 0;
      }
    }
    cout << "Yes\n";
    for (auto &el : bad) {
      cout << el.second + 1 << " ";
    }
    return 0;
  }
  dfs(id[c], cnt_m);
  if (!check(id[c]) || cnt_m != cnt) {
    cout << "No";
    return 0;
  }

  euler(id[c]);
  ans.pop_back();
  reverse(ans.begin(), ans.end());

//  for (auto el : ans) {
//    cout << el << " ";
//  }

  int id = -1;
  for (int i = 0; i < ans.size(); i++) {
    if (ans[i] == -1) {
      id = i;
      break;
    }
  }
  if (id != -1) {
    vector <int> tmp;
    for (int i = id + 1; i < ans.size(); i++) {
      tmp.push_back(ans[i]);
    }
    for (int i = 0; i < id; i++) {
      tmp.push_back(ans[i]);
    }
    swap(ans, tmp);
  }

  vector<int> real_ans;
  bool flag = false;
  for (auto good : ans) {
    set<pair<int, int>> new_bad;
    if (!flag) {
      for (auto &bad_el : bad) {
        if (bad_el.first == c) {
          new_bad.insert(bad_el);
        } else {
          real_ans.push_back(bad_el.second);
        }
      }
    }
    bad = new_bad;
    int old_c = c;
    c = cache[good].second;
    flag = c == old_c;
    real_ans.push_back(good);
  }

  if (real_ans.size() < n) {
    cout << "No";
  }
  else {
    cout << "Yes\n";
    for (auto el : real_ans) {
      cout << el + 1 << " ";
    }
  }

  return 0;
}