﻿#include <iostream>
#include <stdio.h>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <functional>
#include <complex>
#include <assert.h>
#include <chrono>
#pragma comment(linker, "/STACK:256000000")
using namespace std;

#define in(s) freopen(s, "r", stdin)
#define out(s) freopen(s, "w", stdout)
#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

typedef long long ll;
typedef double ld;

const int MAXN = 51;

ll dp[MAXN][MAXN];

ll calc(ll n, ll k) {
	ll res = dp[n][k];

	if (n % 2ll == 0ll && k % 2ll == 1ll) {
		res /= 2ll;
		return res;
	}
	else {
		res += dp[n / 2ll][k / 2ll];
		return res / 2ll;
	}
}

int main()
{
	//in("input.txt");
	//out("output.txt");
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(1373737);

	for (int i = 0; i < MAXN; i++)
		dp[i][0] = 1ll;
	
	for (int i = 1; i < MAXN; i++) {
		for (int j = 1; j < MAXN; j++) {
			dp[i][j] = dp[i - 1][j] + dp[i - 1][j - 1];
		}
	}


	ll n, k;
	cin >> n >> k;

	if (k > n)
		k = 2ll * n - k;

	ll res = 0ll;
	for (ll i = 0ll; i <= k; i++) {
		ll cur = calc(n, i);
		if (2ll * i == k)
			cur *= 2ll;
		res += cur;
	}

	cout << res;


	return 0;
}