#include<iostream>
#include<utility>
#include<vector>
#include<algorithm>
#include<cassert>
#include<iomanip>
#include<cmath>
#include<map>
#include<fstream>
#include<unordered_set>
#include<unordered_map>
#include<set>
#include<queue>
using namespace std;
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define sz(a) (int)a.size()
#define pb push_back
#define ll long long
const int N = 2e5 + 10;

map<int, int> mp;
map<pair<int, int>, vector<int>> good;
vector<int> bad;
multiset<int> g[N];
int ct[N], digs;
bool used[N];

void add(int x) {
  if (mp.count(x)) {
    return;
  }
  mp[x] = digs;
  digs++;
}

void check_dfs(int v) {
  used[v] = true;
  for (int to : g[v]) {
    if (!used[to]) {
      check_dfs(to);
    }
  }
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  vector<int> ans;
  int n, c;
  cin >> n >> c;
  add(c);
  for (int i = 0; i < n; i++) {
    int a, b, f;
    cin >> a >> b >> f;
    if (f) {
      add(a);
      add(b);
      g[mp[a]].insert(mp[b]);
      good[{mp[a], mp[b]}].pb(i);
      ct[mp[b]]++;
    } else {
      if (a != c) {
        ans.pb(i);
      } else {
        bad.pb(i);
      }
    }
  }
  int end = 0;
  check_dfs(0);
  for (int i = 0; i < digs; i++) {
    if (ct[i] != sz(g[i])) {
      if (ct[i] == sz(g[i]) + 1) {
        end++;
      } else if (sz(g[i]) == ct[i] + 1) {
        if (i == mp[c]) {
          continue;
        } else {
          cout << "No";
          return 0;
        }
      } else {
        cout << "No";
        return 0;
      }
    }
    if (!used[i]) {
      cout << "No";
      return 0;
    }
  }
  if (end > 1 || (end == 1 && sz(g[mp[c]]) != ct[mp[c]] + 1) || (end == 0 && sz(g[mp[c]]) != ct[mp[c]])) {
    cout << "No";
    return 0;
  }
  vector<int> st, way;
  st.push_back(mp[c]);
  while (!st.empty()) {
    int v = st.back();
    bool f = false;
    for (int to : g[v]) {
        st.push_back(to);
        g[v].erase(g[v].find(to));
        f = true;
        break;
      }
    if (!f) {
      way.pb(v);
      st.pop_back();
    }
  }
  reverse(all(way));
  for (int i = 0; i < sz(way) - 1; i++) {
    if (way[i] != mp[c]) {
      for (int el : bad) {
        ans.pb(el);
      }
      bad.clear();
    }
    ans.pb(good[{way[i], way[i + 1]}].back());
    good[{way[i], way[i + 1]}].pop_back();
  }
  if (way.back() != mp[c]) {
    for (int el : bad) {
      ans.pb(el);
    }
  }
  if (sz(ans) == n) {
    cout << "Yes\n";
    for (int el : ans) {
      printf("%d ", el + 1);
    }
  } else {
    cout << "No";
  }
  return 0;
}