#include<iostream>
#include<utility>
#include<vector>
#include<algorithm>
#include<iomanip>
#include<cmath>
#include<map>
#include<fstream>
#include<unordered_set>
#include<unordered_map>
#include<set>
#include<queue>
using namespace std;
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define sz(a) (int)a.size()
#define pb push_back
#define ll long long
const int N = 2e5;

unordered_map<int, int> mp;
map<pair<int, int>, vector<int>> good;
map<int, vector<int>> bad;
vector<int> digs, g[N];
multiset<pair<int, int>> edges;
int ct[N], used[N], u;

void add(int x) {
  if (mp.count(x)) {
    return;
  }
  mp[x] = sz(digs);
  digs.pb(x);
}

void check_dfs(int v) {
  used[v] = u;
  for (int to : g[v]) {
    if (used[to] != u) {
      check_dfs(to);
    }
  }
}

int main() {
  int n, c, ops = 0;
  cin >> n >> c;
  add(c);
  for (int i = 0; i < n; i++) {
    int a, b, f;
    cin >> a >> b >> f;
    ops++;
    if (f) {
      add(a);
      add(b);
      g[mp[a]].pb(mp[b]);
      good[{mp[a], mp[b]}].pb(ops - 1);
      edges.insert({mp[a], mp[b]});
      ct[mp[b]]++;
    } else {
      bad[a].pb(ops - 1);
    }
  }
  int end = 0;
  u++;
  check_dfs(0);
  for (int i = 0; i < sz(digs); i++) {
    if (ct[i] != sz(g[i])) {
      if (ct[i] == sz(g[i]) + 1) {
        end++;
      } else if (sz(g[i]) == ct[i] + 1) {
        if (i == mp[c]) {
          continue;
        } else {
          cout << "No";
          return 0;
        }
      } else {
        cout << "No";
        return 0;
      }
    }
    if (used[i] != u) {
      cout << "No";
      return 0;
    }
  }
  if (end > 1 || (end == 1 && sz(g[mp[c]]) != ct[mp[c]] + 1)) {
    cout << "No";
    return 0;
  }
  vector<int> st, way, ans;
  st.push_back(mp[c]);
  while (!st.empty()) {
    int v = st.back();
    bool f = false;
    for (int to : g[v])
      if (edges.count({v, to})) {
        st.push_back(to);
        edges.erase(edges.find({v, to}));
        f = true;
        break;
      }
    if (!f) {
      way.pb(v);
      st.pop_back();
    }
  }
  reverse(all(way));
  if (!edges.empty()) {
    cout << "No";
    return 0;
  }
  for (int i = 0; i < sz(way) - 1; i++) {
    vector<int> erase;
    for (const auto& p : bad) {
      if (p.x != digs[way[i]]) {
        for (auto el : p.y) {
          ans.pb(el);
        }
        erase.pb(p.x);
      }
    }
    for (int el : erase) {
      bad.erase(el);
    }
    ans.pb(good[{way[i], way[i + 1]}].back());
    good[{way[i], way[i + 1]}].pop_back();
  }
  if (sz(ans) == ops) {
    cout << "Yes\n";
    for (int el : ans) {
      cout << el + 1 << ' ';
    }
  } else {
    cout << "No";
  }
  return 0;
}