#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int n;
string com;

void readCommand() {
    cout << flush;
    cin >> com;
    if (com == "WIN") {
        exit(0);
    }
}

int doSort(int i) {
    int actions = 0;
    for (int j = i + 1; j < n; j++) {
        cout << i + 1 << " " << j + 1<< endl;
        readCommand();
        actions++;
    }

    return actions;
}

int doFix(int i) {
    int actions = 0;

    for (int j = n - 1; j > 0; j--) {
        cout << j << " " << j + 1<< endl;
        readCommand();
        actions++;
    }

    for (int j = 1; j < i - 1; j++) {
        cout << j + 1 << " " << j + 2 << endl;
        readCommand();
        actions++;
    }

    return actions;
}


int main() {
    cin >> n;

    for (int i = 0; i < n - 1; i++) {
        int actions = 0;

        if (i > 0) {
            cout << "Fix:" << endl;
            actions += doFix(i);
        }

        cout << "Sort: " << endl;
        actions += doSort(i);
        cout << "Hold: " << actions << endl;
        for (int j = 0; j < 2 * n - actions; j++) {
            cout << "1 2" << endl;
            readCommand();
        }
    }
}
