#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int n, moves = 0, prefix = 0;

void make_move(int, int);

void backup() {
    for (int i = 0; i < prefix; i++) {
        make_move(i, i + 1);
    }
}

void read() {
    string s;
    cin >> s;
    if (s == "WIN") {
        exit(0);
    }
    moves++;
    if (moves % (2 * n) == 0) {
        backup();
    }
}

void make_move(int i, int j) {
    cout << i + 1 << ' ' << j + 1 << endl;
    read();
}

int main() {
    // ios::sync_with_stdio(false); cin.tie(0);

    cin >> n;

    for (; prefix < n; prefix++) {
        for (int i = prefix + 1; i < n; i++) {
            make_move(prefix, i);
        }
    }
}
