#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());

    int max_neib = -1;
    int min_three = 1'000'000'007;
    for (int i = 0; i < n - 1; i++) {
        if (i > 0) {
            min_three = min(min_three, a[i + 1] - a[i - 1]);
        }
        max_neib = max(max_neib, a[i + 1] - a[i]);
    }

    if (max_neib >= min_three) {
        cout << 0;
    } else {
        cout << max_neib;
    }
}
