#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n, k;
    cin >> n >> k;

    vector<vector<long long>> C(
        n + 1,
        vector<long long>(n + 1, 0)
    );
    C[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        C[i][0] = C[i - 1][0];
        for (int j = 1; j <= i; j++) {
            C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
        }
    }

    long long ans = 0;
    for (int i = max(k - n, 0); i <= min(k, n); i++) {
        long long all = C[n][i];
        long long sym = (i % 2 == 0 || n % 2 == 1) * C[n / 2][i / 2];

        if (i * 2 == k) {
            ans += all + sym;
        } else {
            ans += (all + sym) / 2;
        }
        // cerr << i << ' ' << all << ' ' << sym << ' ' << ans << endl;
        
    }

    cout << ans;
}
