#include <iostream>
#include <functional>
#include <vector>
#include <map>


void solve(std::istream& is, std::ostream& os)
{
    int n, w, h, s;
    is >> n >> w >> h >> s;
    std::vector<std::vector<int>> count(n, std::vector<int>(h, 0));
    std::vector<char> letters(n);
    std::pair<int, int> const KEK = {-1, -1};
    std::pair<int, int> best = KEK;
    for (int i = 0; i < n; ++i)
    {
        is >> letters[i];
        std::string t;
        for (int j = 0; j < h; ++j)
        {
            is >> t;
            char cur = '.';
            for (char c : t)
            {
                count[i][j] += c != cur;
                cur = c;
            }
            count[i][j] += 'c' == '#';
            if (best == KEK || (s - 1) / count[best.first][best.second] + 1 > (s - 1) / count[i][j] + 1)
            {
                best = {i, j};
            }
        }
    }
    for (int i = 0; i < (s - 1) / count[best.first][best.second] + 1; ++i)
    {
        os << letters[best.first];
    }
    os << std::endl;
}

signed main()
{
    solve(std::cin, std::cout);
    return 0;
}
/*
3 4 5 16
I
.#..
#.#.
.#..
.#..
###.
C
.##.
#..#
#...
#..#
.##.
P
###.
#..#
###.
#...
#...
 */