#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<long long>> c(200, vector<long long>(200));

void pred_c() {
    for (int i = 0; i < 200; i++) {
        c[i][0] = 1;
        if (i > 0) {
            c[0][i] = 0;
        }
    }
    for (int i = 1; i < 200; i++) {
        for (int j = 1; j < 200; j++) {
            c[i][j] = c[i - 1][j - 1] + c[i - 1][j];
        }
    }
}

int main() {
    pred_c();
    int n, k;
    cin >> n >> k;
    long long ans = 0;
    for (int i = max(0, k - n); i <= min(k, n); i++) {
        long long delta = 0;
        if (!(n % 2 == 0 && i % 2 != 0)) {
            delta = c[n / 2][i / 2];
        }
        long long cur = (c[n][i] - delta) / 2 + delta;
        if (i * 2 == k) {
            ans += 2 * cur;
        } else {
            ans += cur;
        }
    }

    cout << ans;
    return 0;
}
