#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("unswitch-loops")


#define all(x) x.begin(), x.end()
#define len(x) int(x.size())

typedef long long ll;
namespace std {
    template<>
    struct hash<std::pair<int, int>> {
        inline size_t operator()(const std::pair<int, int>& v) const {
            std::hash<int> int_hasher;
            return int_hasher(v.first) ^ int_hasher(v.second);
        }
    };
}

const int N = 100;

vector <string> letter_pic[N];
vector <char> letter;
vector <int> cost;

int main() {
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#endif  // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, w, h, s;
    cin >> n >> w >> h >> s;
    letter.resize(n);
    cost.resize(n, -1e9);
    for (int i = 0; i < n; i++) {
        cin >> letter[i];
        letter_pic[i].resize(h);

        for (int j = 0; j < h; j++) {
            cin >> letter_pic[i][j];
            letter_pic[i][j] = "." + letter_pic[i][j] + ".";
            //  cout << letter_pic[i][j] << "\n";
            int cur_cost = 0;
            for (int k = 0; k < len(letter_pic[i][j]) - 1; k++) {
                if (letter_pic[i][j][k] != letter_pic[i][j][k + 1]) {
                    cur_cost++;
                }
            }
            cost[i] = max(cost[i], cur_cost);
        }
        // cout << "\n";
    }
    int mx_id = -1;
    int mx = -1e9;
    for (int i = 0; i < n; i++) {
        if (cost[i] > mx) {
            mx = cost[i];
            mx_id = i;
        }
    }
    int word_len = (s + cost[mx_id] - 1) / (cost[mx_id]);
    for (int i = 0; i < word_len; i++) {
        cout << letter[mx_id];
    }
    return 0;
}