//
// Created by tycoon on 14.11.2020.
//
#include <bits/stdc++.h>

using namespace std;

int64_t choose_val[60][30];

int64_t choose(int64_t n, int64_t k) {
    if (n < k) {
        return 0;
    }
    if (k > (n - k)) {
        k = n - k;
    }
    return choose_val[n][k];
}

int64_t calc(int64_t a, int64_t n) {
    int64_t sim, asim, all;
    if (n % 2 == 0) {
        if (a % 2 == 0) {
            sim = choose(n / 2, a / 2);
        } else {
            sim = 0;
        }
    } else {
        if (a % 2 == 0) {
            sim = choose((n - 1) / 2, a / 2);
        } else {
            sim = choose((n - 1) / 2, (a - 1) / 2);
        }
    }
    all = choose(n, a);
    asim = (all - sim) / 2;
//    cout << "n = " << n << '\n' << "a = " << a << '\n';
//    cout << "sim asim all\n";
//    cout << sim << "   " << asim << "   " << all << '\n' << '\n';
    return sim + asim;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int64_t n, k;
    cin >> n >> k;

    choose_val[0][0] = 1;
    choose_val[1][0] = 1;
    choose_val[1][1] = 1;
    for (size_t i = 2; i < 60; ++i) {
        choose_val[i][0] = 1;
        choose_val[i][i] = 1;
        for (size_t j = 1; j < i; ++j) {
            choose_val[i][j] = choose_val[i-1][j-1] + choose_val[i-1][j];
        }
        for (size_t j = i + 1; j < 30; ++j) {
            choose_val[i][j] = 0;
        }
    }

    int64_t ans = 0;
    for (int64_t a = 0; a * 2 <= k; ++a) {
        int64_t b = k - a;
//        calc(a, n);
//        calc(b, n);
//        cout << a << " - " << calc(a, n) << '\n';
//        cout << b << " - " << calc(b, n) << '\n';
        ans += calc(a, n) + calc(b, n);
//        cout << ans << '\n';
    }

    cout << ans << '\n';

    return 0;
}
