#pragma GCC optimize("O3")

// Author: Dmitry Sabrekov

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <string>
#include <cstring>
#include <sstream>
#include <algorithm>
#include <ctime>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <list>
#include <queue>
#include <tuple>
// #include <random>
// #include <numeric>
// #include <chrono>
// #include <regex>
// #include <memory>

using namespace std;
// string name = "main";
// ifstream in(name + ".in");
// ofstream out(name + ".out");
ifstream in("input.txt");
ofstream out("output.txt");

#define read cin >>
#define wr  cout <<
#define ww  << ' ' <<
#define ws  << ' '
#define br  << '\n'
#define fl  << endl
#define wln wr '\n'
#define wfl wr endl
#define fori(st, en)            for(int i = (st); i < (en); ++i)
#define forj(st, en)            for(int j = (st); j < (en); ++j)
#define input(arr, n)           fori(0, (n)) {read (arr)[i];}
#define input2d(arr, n, m)      forj(0, (n)) {input((arr)[j], (m));}
#define print(arr, n, delim)    fori(0, (n)) {wr (arr)[i] << (delim);}
#define printobj(obj, delim)    for(auto it : (obj)) {wr it << (delim);}
#define print2d(a, row, col, d) forj(0, (row)) {print((a)[j], (col), (d)); wln;}
#define all(v)  (v).begin(), (v).end()
#define pb push_back
#define fast_io ios::sync_with_stdio(0)
#define long long long
#define ulong unsigned long

typedef pair<int, int> ipar;
typedef pair<long, long> lpar;
typedef vector<int> vi;
typedef vector<long> vl;
typedef vector<vi> vvi;
typedef vector<string> vstr;
const long mod = 1e9 + 7;

int k = 0;
int n;
string t;

void read_t() {
	read t;
	if (t[0] == 'W') {
		exit(0);
	}
}

void find_big(int i, int j) {
	k += j - i;
	for (;i < j; i++) {
		wr i ww i + 1 fl;
		read_t();
	}
}

void find_small(int i, int j) {
	k += j - i;
	for (;j > i; j--) {
		wr j - 1 ww j fl;
		read_t();
	}
}

void check(int pl, int pr) {
	vi a(n + 1);
	fori(0, n + 1) {
		a[i] = i;
	}

	int left_ch = 0;
	int right_ch = 0;

	fori(1, pl) {
		wr a[i] ww a[i + 1] fl;
		++k;
		read_t();
		if (t[1] == 'W') { //SWAPPED
			if (left_ch) {
				wr i - 1 ww i fl;
				++k;
				return;
			}

			swap(a[i], a[i + 1]);
			left_ch = i;
		}
	}

	fori(n - pr + 1, n) {
		wr a[i] ww a[i + 1] fl;
		++k;
		read_t();
		if (t[1] == 'W') { //SWAPPED
			if (right_ch) {
				wr i - 1 ww i fl;
				++k;
				return;
			}

			swap(a[i], a[i + 1]);
			right_ch = i;
		}
	}

	if (left_ch && right_ch) {
		wr left_ch + 1 ww right_ch - 1 fl;
		wr left_ch ww left_ch + 1 fl;
		wr right_ch - 1 ww right_ch fl;
		k += 3;
		read_t();
		read_t();
		read_t();
	} else if (left_ch) {
		wr left_ch + 1 ww n - pr + 1 fl;
		++k;
		read_t();
		if (t[1] == 'W') { //SWAPPED
			return;
		} else {
			find_small(pl, n - pr);
		}
	} else if (right_ch) {
		wr pl ww right_ch fl;
		++k;
		read_t();
		if (t[1] == 'W') { //SWAPPED
			return;
		} else {
			find_big(pl + 1, n - pr + 1);
		}
	} else {
		wr pl ww n - pr + 1 fl;
		++k;
		read_t();
	}
}

int main(){
    fast_io;
    read n;
    int n2 = 2 * n;

	find_big(1, n);
	find_small(1, n);

	while (k < n2) {
		wr 1 ww n fl;
		read_t();
		++k;
	}

	//random swap now

	bool find_max = 0;
	int pl = 1, pr = 1;

	while (k <= 9900) {
		check(pl, pr);
		find_max ? find_big(pl + 1, n - pr++) : find_small(pl++ + 1, n - pr);

		while (k % n2) {
			wr 1 ww n fl;
			read_t();
			++k;
		}
	}
}