#include "bits/stdc++.h"
#include <cassert>
#include <cstdio>

using namespace std;

#define all(v) v.begin(), v.end()
#define fori(i, n) for (int i = 0; i < n; i++)
#define fora(i, arr) for (auto i : arr)
typedef long long ll;
typedef long double ld;

void ASK(const vector<int> &pi) {
  cout << "? ";
  for (auto &i : pi) {
    cout << (i + 1) << " ";
  }
  cout << endl;
}

void GUESS(const vector<int> &pi) {
  cout << "! ";
  for (auto &i : pi) {
    cout << (i + 1) << " ";
  }
  cout << endl;
}

void READ(vector<int> &pi) {
  for (auto &i : pi) {
    cin >> i;
    --i;
  }
}

int main() {
  int t, n;
  cin >> t;
  for (int q = 0; q < t; ++q) {
    cin >> n;
    vector<int> pi(n), pi_(n), pi1(n), pi2(n);
    for (int i = 0; i < n; ++i) {
      pi1[i] = (i + 1) % n;
      pi2[i] = i;
    }
    pi2[0] = 1, pi2[1] = 0;
    ASK(pi1), READ(pi1);
    ASK(pi2), READ(pi2);
    int x = 0, y = 0;
    for (int i = 0; i < n; ++i) {
      if (pi2[i] != i) {
        x = i, y = pi2[i];
        break;
      }
    }
    if (pi1[x] == y) {
      pi_[0] = x, pi_[1] = y;
    } else {
      pi_[0] = y, pi_[1] = x;
    }
    for (int i = 2; i < n; ++i) {
      pi_[i] = pi1[pi_[i - 1]];
    }
    for (int i = 0; i < n; ++i) {
      pi[pi_[i]] = i;
    }
    GUESS(pi);
  }
  //
}
