#include <bits/stdc++.h>

using namespace std;
#ifdef MIA
    #define __int128 long long
    #define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
    #define err(...) 42
#endif
typedef long long ll;

#define multitest true

void solve();

int main() {
#ifdef MIAA
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    if (multitest) cin >> t;
    for (int it = 1; it <= t; ++it) solve();
    return 0;
}

// CONSTANTS HERE

vector<int> getO(const vector<int>& p) {
    vector<int> r(p.size());
    for (int i = 0; i < p.size(); ++i) {
        r[p[i]] = i;
    }
    return r;
}

vector<int> getC(const vector<int>& p, const vector<int>& f) {
    vector<int> r(p.size());
    for (int i = 0; i < p.size(); ++i) {
        r[i] = p[f[i]];
    }
    return r;
}

vector<int> get(const vector<int>& p, const vector<int>& f) {
    vector<int> po = getO(p);
    return getC(p, getC(f, po));
}

vector<int> res, res2, resO, res2O, f, f2, fO, f2O;

vector<int> getZ(vector<int> f) {
    vector<int> RES(f.size());
    cout << "? ";
    for (int i : f) cout << i + 1 << " ";
    cout << endl;
    for (int& i : RES) {
        cin >> i;
        --i;
    }
    return RES;
}

int n;
bool tr(vector<int>& p, vector<int>& po, int x) {
    if (x == n) {
        cout << "! ";
        for (int i : p) cout << i << " ";
        cout << endl;
        return true;
    }
    for (int j = 0; j < n; ++j) {
        if (p[j] == -1 && po[x] == -1 && po[resO[x]] == -1 && po[res2O[x]] == -1) {
            p[j] = x;
            po[x] = j;
            po[resO[x]] = fO[j];
            po[res2O[x]] = f2O[j];
            if (tr(p, po, x + 1)) {
                return true;
            }
            p[j] = po[x] = po[resO[x]] = po[res2O[x]] = -1;
        }
    }
    return false;
}

mt19937 rnd(time(0));
void solve() {
    cin >> n;

    f.resize(n);
    iota(f.begin(), f.end(), 0);
    shuffle(f.begin(), f.end(), rnd);
    f2.resize(n);
    iota(f2.begin(), f2.end(), 0);
    shuffle(f2.begin(), f2.end(), rnd);
    fO = getO(f);
    f2O = getO(f2);

    res = getZ(f), res2 = getZ(f2);
    resO = getO(res), res2O = getO(res2);

    vector<int> p(n, -1), po(n, -1);
    tr(p, po, 0);
}