n, k = map(int, input().split(' '))

mx = max(n, k) + 1

c = [[0 for i in range(mx)] for j in range(mx)]


for i in range(mx):
    c[i][i] = 1
    c[i][1] = i
    c[i][0] = 1

for n1 in range(1, mx):
    for k1 in range(1, mx):
        if n1 > k1:
            c[n1][k1] = c[n1 - 1][k1] + c[n1 - 1][k1 - 1]


def cnk(n2, k2):
    if k2 > n2:
        return 0
    return c[n2][k2]


def reflected(al, sim):
    return (al + sim) // 2


def sticks_with_k_black_without_reflected(k3):
    if k3 == 0:
        return 1
    al = cnk(n, k3)
    if n % 2 == 0 and k3 % 2 == 0:
        return reflected(al, cnk(n // 2, k3 // 2))
    if n % 2 == 0 and k3 % 2 == 1:
        return reflected(al, 0)
    if n % 2 == 1 and k3 % 2 == 0:
        return reflected(al, cnk((n - 1) // 2, k3 // 2))
    if n % 2 == 1 and k3 % 2 == 1:
        return reflected(al, cnk((n - 1) // 2, (k3 - 1) // 2))


sm = 0

for i in range(k + 1):
    if i <= n and k - i <= n:
        ad = sticks_with_k_black_without_reflected(i)
        if k % 2 == 0 and i == k / 2:
            ad *= 2
        sm += ad

print(sm)
