import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class TaskF {
    static double getD(double sum, int days) {
        return Math.sqrt(sum / days);
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String[] line = reader.readLine().split(" ");
        int d = Integer.parseInt(line[0]);
        double P = Double.parseDouble(line[1]);
        line = reader.readLine().split(" ");
        reader.close();
        double[] days = new double[d];
        for (int i = 0; i < d; i++) {
            days[i] = Double.parseDouble(line[i]);
        }
        int positive = 0;
        int negative = 0;

        for (int i = 3; i <= d; i++) {
            boolean isCounted = false;
            double sum = 0;
            double sumSqr = 0;
            int cnt = i - 1;
            for (int j = 0; j < d - cnt; j++) {
                if (!isCounted) {
                    for (int k = 0; k < cnt; k++) {
                        double v = days[k + 1] - days[k];
                        sum += v;
                        sumSqr += (v * v);
                    }
                    double A = sum / (cnt);
                    double sumD = sumSqr + cnt * A * A - 2 * A * sum;
                    double D = getD(sumD, cnt);
                    isCounted = true;
                    if (A == 0) {
                        continue;
                    }
                    if (D == 0) {
                        if (A > 0) {
                            positive++;
                        } else {
                            negative++;
                        }
                        continue;
                    }
                    double trend = A / D;
                    if (trend >= P) {
                        positive++;
                    }
                    if (trend <= -P) {
                        negative++;
                    }
                } else {
                    double new1 = days[j + i - 1] - days[j + i - 2];
                    double new2 = days[j] - days[j - 1];
                    sum += new1;
                    sum -= new2;
                    double A = sum / cnt;
                    sumSqr += (new1 * new1);
                    sumSqr -= (new2 * new2);
                    double sumD = sumSqr + cnt * A * A - 2 * A * sum;
                    double D = getD(sumD, cnt);
                    if (A == 0) {
                        continue;
                    }
                    if (D == 0) {
                        if (A > 0) {
                            positive++;
                        } else {
                            negative++;
                        }
                        continue;
                    }
                    double trend = A / D;
                    if (trend >= P) {
                        positive++;
                    }
                    if (trend <= -P) {
                        negative++;
                    }
                }
            }
        }
        System.out.println(positive + " " + negative);
    }
}
