#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#define __USE_MINGW_ANSI_STDIO 0
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include<stdio.h>
#include<iomanip>
#include<set>
#include<string>
#include<map>
#include <math.h>
#include<queue>
#include<complex>
#include<ctime>
#include<list>
#include<stack>
#include<chrono>
#include<random>
#define ll long long
#define lll __int128
#define fi first
#define ld long double
#define se second
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vi vector<int>
#define vll vector<ll>
#define vii vector<vector<int>>
#define vvld vector<vector<ld>>
#define vvll vector<vector<ll>>
const ll MAXN = 2e5+10;
const ll INF = 1e9+10;
const ll mod = 1e9+7;
const ld eps = 1e-5;
using namespace std;
//auto seed = chrono::high_resolution_clock :: now().time_since_epoch().count();
//mt19937 mt_rand(seed);

ld pref[4000];
ld prefsq[4000];
ld prefpr[4000];
ld c[4000];

void solve(int tt){
	ll d;
	ld P;
	cin>>d>>P;
	for(int i = 1; i <= d; i++)cin>>c[i];
	pref[0] = 0;
	prefsq[0] = 0;
	prefpr[0] = 0;
	for(int i = 1; i <= d; i++){
		pref[i] = pref[i-1] + c[i];
		prefsq[i] = prefsq[i-1] + c[i] * c[i];
		prefpr[i] = prefpr[i-1] + c[i] * c[i-1];
		//cout<<i<<" "<<pref[i]<<" "<<prefsq[i]<<" "<<prefpr[i]<<endl;
	}
	int cntpos = 0;
	int cntotr = 0;
	for(int l = 1; l <= d; l++){
		for(int r = l + 2; r <= d; r++){
			ld A = (c[r] - c[l])/(r - l);
			ld D = sqrt(
				(prefsq[r] - prefsq[l])
			 	+ (prefsq[r-1] - prefsq[l-1])
			 	- 2 * (prefpr[r] - prefpr[l])
			  	- 2 * (pref[r] - pref[l]) * A
			  	+ 2 * (pref[r-1] - pref[l-1]) * A
			  	+ A * A * (r - l)) / sqrt(r - l);
			//cout<<l<<" "<<r<<" "<<A<<" "<<D<<"|"<<prefsq[r]-prefsq[l]<<"+"<<(prefsq[r-1] - prefsq[l-1])<<" "<<endl;
			if(D != 0 && A / D >= P){
				//cout<<" 1"<<endl;
				cntpos ++;
			}
			if(D == 0 && A > 0){
				//cout<<" 1"<<endl;
				cntpos ++;
			}
			if(D != 0 && A / D <= -P){
				//cout<<" -1"<<endl;
				cntotr ++;
			}
			if(D == 0 && A < 0){
				//cout<<" -1"<<endl;
				cntotr++;
			}
		}
	}
	cout<<cntpos<<" "<<cntotr<<endl;
}

int main(){
	srand(time(NULL));
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
	freopen("in","r",stdin);
	freopen("out","w",stdout);
	#endif
	int t;
	t = 1;
	// cin >> t;
	for(int i =0;i < t;i++)
		solve(i+1);
	return 0;
}