// #pragma GCC optimize("O3")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
const int mod = 1e9 + 7;
const ld EPS = 1e-9;

ll pw(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

void solve() {
    int d;
    ld P;
    cin >> d >> P;
    vector<ld> a(d);
    for (int i = 0; i < d; i++) {
        cin >> a[i];
    }
    int pos = 0;
    int neg = 0;
    for (int i = 0; i < d; i++) {
        ld mean = 0;
        ld sd = 0;
        ld coef = 0;
        for (int j = i + 1; j < d; j++) {
            ld diff = a[j] - a[j - 1];
            mean += diff;
            sd += diff * diff;
            coef += -2 * diff;
            if (j - i >= 2) {
                int len = j - i;
                ld A = mean / len;
                ld D = sqrtl((sd + coef * A) / len + A * A);
                if (abs(D) < EPS) {
                    if (A > EPS) {
                        pos++;
                    }
                    if (A < -EPS) {
                        neg++;
                    }
                } else {
                    if (A / D > P - EPS) {
                        pos++;
                    }
                    if (A / D < -P + EPS) {
                        neg++;
                    }
                }
            }
        }
    }
    cout << pos << ' ' << neg << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case #" << tc << ": ";
        solve();
    }
    return 0;
}