#include <bits/stdc++.h>

using namespace std;

#define massert(expr)                                                                              \
    if (!(expr)) {                                                                                 \
        cerr << "massert failed: line " << __LINE__;                                               \
        exit(__LINE__ * 100);                                                                      \
    }

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);

    int n, k;
    cin >> n >> k;

    // if (k == 0) {
    //     cout << 2 << endl;
    //     exit(0);
    // }

    vector<vector<long long>> binom(n + 1, vector<long long>(k + 1, 0));
    for (int i = 0; i <= n; i++)
        binom[i][0] = 1;

    for (int N = 1; N <= n; N++) {
        for (int K = 1; K <= k; K++) {
            binom[N][K] = binom[N - 1][K - 1] + binom[N - 1][K];
        }
    }

    int m = min(n, k);
    vector<long long> palka(m + 1, 0);
    for (int t = 0; t <= m; t++) {
        if (t == 0) {
            palka[t] = 1;
            continue;
        }
        if (n % 2 == 0 && t % 2 == 1) {
            palka[t] = binom[n][t] / 2;
        } else {
            palka[t] = (binom[n][t] - binom[n / 2][t / 2]) / 2 + binom[n / 2][t / 2];
        }
    }

    // for (int i = 0; i <= n; i++) {
    //     for (int j = 0; j <= k; j++)
    //         cout << binom[i][j] << ' ';
    //     cout << endl;
    // }
    // cout << endl;
    // for (int t = 0; t <= m; t++)
    //     cout << palka[t] << ' ';
    // cout << endl;

    long long sum = 0;
    for (int t = 0; t <= m / 2; t++)
        sum += palka[t] + palka[m - t];

    cout << sum << endl;

    return 0;
}