//#include <bits/stdc++.h>
#include<vector>
#include<iostream>
#include<fstream>
#include<string>
#include<cassert>
#include<algorithm>
#include<random>
#include<map>
#include<set>
#include <bitset>
#include<queue>
#include<ctime>
#include<unordered_map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<char> vc;
typedef vector<string> vs;
typedef vector<vector<int>> vvi;
typedef vector<vector<char>> vvc;
typedef vector<vector<ll>> vvl;
typedef vector<pair<ll, ll>> vpll;
typedef vector<pair<ld, ld>> vpld;
typedef vector<pair<int, int>> vpi;
typedef pair<ld, ld> pld;
#define mp make_pair
#define pb push_back
#pragma GCC optimize "-O3"

//const int mod = 998244353;
const int mod = 1e9 + 7;

int sum(int a, int b)
{
	int c = a + b;
	if (c >= mod)
	{
		c -= mod;
	}
	return c;
}

int dif(int a, int b)
{
	int c = a - b;
	if (c < 0)
	{
		c += mod;
	}
	return c;
}

int mlt(int a, int b)
{
	ll c = a * 1LL * b;
	return c % mod;
}

int ibit(int n, int i)
{
	return ((n >> i) & 1);
}

void outp1(vl &ou, string s = " ")
{
	cerr << s << endl;
	for (int i = 0; i < ou.size(); i++)
	{
		cerr << ou[i] << ' ';
	}
	cerr << endl;
}

void outp1(vi &ou, string s = " ")
{
	cerr << s << endl;
	for (int i = 0; i < ou.size(); i++)
	{
		cerr << ou[i] << ' ';
	}
	cerr << endl;
}

void outp2(vector<vector<int>> &ou, string s = " ")
{
	cerr << s << endl;
	for (int i = 0; i < ou.size(); i++)
	{
		for (int j = 0; j < ou[i].size(); j++)
		{
			cerr << ou[i][j] << ' ';
		}
		cerr << '\n';
	}
}

int bp(int x, int y)
{
	if (y == 0)
	{
		return 1;
	}
	int a = 0;
	if (!(y % 2))
	{
		a = bp(x, y / 2);
	}
	return (y % 2) ? mlt(bp(x, y - 1), x) : mlt(a, a);
}

int obr(int x)
{
	return bp(x, mod - 2);
}

const int maxn = 301;
int fact[maxn], ofact[maxn];

void prec()
{
	fact[0] = 1;
	ofact[0] = 1;
	for (int i = 1; i < maxn; i++)
	{
		fact[i] = mlt(fact[i - 1], i);
	}
	//cerr << "sdsds" << endl;
	ofact[maxn - 1] = obr(fact[maxn - 1]);
	for (int i = maxn - 2; i > 0; i--)
	{
		ofact[i] = mlt(ofact[i + 1], i + 1);
	}
}

int c(int a, int b)
{
	return ((a <= b) && (a >= 0)) ? mlt(fact[b], mlt(ofact[a], ofact[b - a])) : 0;
}

const int rsto = bp(100, mod - 2);

void recalc(unordered_map<ll, int> &dyn, const vector<int> &probs, int t, vector<vvi> &trans)
{
	vector<int> goodsz;
	unordered_map<ll, int> newdyn;
	int n = probs.size();
	for (int mask = 0; mask < (1 << n); mask++)
	{
		int cnt = 0;
		for (int i = 0; i < n; i++)
			if (ibit(mask, i))
				cnt++;
		if (cnt == t)
			goodsz.pb(mask);
	}
//	outp1(goodsz, "GOODSZ ");
	for (int mask = 0; mask < (1 << n); mask++)
	{
		//cerr << "MASK " << mask << endl;
		int prb = 1;
		vector<int> added;
		for (int i = 0; i < n; i++)
		{
			if (ibit(mask, i))
			{
				added.pb(i);
				prb = mlt(prb, probs[i]);
			}
			else
				prb = mlt(prb, mod + 1 - probs[i]);
		}
		for (auto it = dyn.begin(); it != dyn.end(); it++)
		{
			ll va = it->first;
			vector<int> used(trans[t + 1].size());
			ll tp = 0;
			for (int i = 0; i < trans[t].size(); i++)
			{
				if (ibit(va, i))
				{
					for (auto pos:added)
					{
						int val = trans[t][i][pos];
						if (val != -1)
							tp |= (1LL << val);
					}
				}
			}
			ll cur = tp;
			if (!newdyn.count(cur))
				newdyn[cur] = mlt(prb, it->second);
			else
				newdyn[cur] = sum(newdyn[cur], mlt(prb, it->second));
		}
	}
	dyn = newdyn;
}

vector<vector<int>> enc;
vector<vector<vector<int>>> trans;

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int c;
	cin >> c;
	pair<int, int> pr(-1, -1);
	for (int i = 0; i <= c; i++)
		for (int j = 0; j <= c; j++)
			if (i * i + j * j == c)
				pr = {i, j};
	pair<int, int>p1={-1, -1};
	int x=pr.first, y=pr.second;
	if(pr==p1)
		cout<<"Impossible"<<endl;
	else
	{
		int cx=0, cy=0;
		cout<<cx<<' '<<cy<<endl;
		cx+=x;
		cy+=y;
		cout<<cx<<' '<<cy<<endl;
		cx-=y;
		cy+=x;
		cout<<cx<<' '<<cy<<endl;
		cx-=x;
		cy-=y;
		cout<<cx<<' '<<cy<<endl;
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	int tests = 1;
	//cin >> tests;
	for (int i = 0; i < tests; i++)
	{
		solve();
	}
}