#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rng(228);

int doomsday_counter, n;

bool restore(int pref) {
	string tmp;

	for (int i = 0; i < pref; i++) {
		doomsday_counter--;
		cout << i + 1 << ' ' << i + 2 << endl;
		cout.flush();
		cin >> tmp;
		if (tmp == "WIN") return true;
		if (tmp == "SWAPPED") {
			for (int j = i + 2; j < n; j++) {
				doomsday_counter--;
				cout << i + 1 << ' ' << j + 1 << endl;
				cout.flush();
				cin >> tmp;
				if (tmp == "WIN") return true;
				if (tmp == "SWAPPED") {
					doomsday_counter--;
					cout << i + 2 << ' ' << j + 1 << endl;
					cout.flush();
					cin >> tmp;
					if (tmp == "WIN") return true;
					return false;
				}
			}
			return false;
		}
	}
	if (pref > 0) {
		for (int j = pref; j < n; j++) {
			doomsday_counter--;
			cout << pref << ' ' << j + 1 << endl;
			cout.flush();
			cin >> tmp;
			if (tmp == "WIN") return true;
		}
	}
	return false;
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	cin >> n;

	doomsday_counter = 2 * n;

	string tmp;

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (doomsday_counter == 0) {
				doomsday_counter = 2 * n;
				if (restore(i)) return 0;
				j = i + 1;
			}
			doomsday_counter--;
			cout << i + 1 << ' ' << j + 1 << endl;
			cout.flush();
			cin >> tmp;
			if (tmp == "WIN") return 0;
		}
	}
}