#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rng(228);


int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int n, w, h, s;
	cin >> n >> w >> h >> s;

	char cd = ' ';
	int swt = -1;

	for (int i = 0; i < n; i++) {
		char ch;
		cin >> ch;
		for (int j = 0; j < h; j++) {
			string s;
			cin >> s;
			int switches = 0;
			for (int k = 1; k < w; k++) {
				if (s[k] != s[k - 1]) switches++;
			}
			if (s[0] == '#') switches++;
			if (s.back() == '#') switches++;
			if (switches > swt) {
				cd = ch;
				swt = switches;
			}
		}
	}

	cout << string((s + swt - 1) / swt, cd);
}