#ifdef ONPC
    #define _GLIBCXX_DEBUG
    #define deb(a) cerr << "========" << #a << " = " << a << endl;
#else
    #define deb(a)
#endif
#define sz(a) ((int)((a).size()))
#include <bits/stdc++.h>
#define char unsigned char

using namespace std;
mt19937 rnd(239);
// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;


const int N = 312345;

ll a[N], b[N], w[N], ins[N], outs[N];
int ind[N];

vector<pair<int, int>> g[N];
vector<int> fromc;
vector<int> notc;
ll c;


vector<int> ans;

void dfs(int v) {
    if (v == c) {
        if (!notc.empty()) {
            for (int i : notc) {
                ans.push_back(i);
            }
            notc.clear();
        }
    } else {
        if (!fromc.empty()) {
            for (int i : fromc) {
                ans.push_back(i);
            }
            fromc.clear();
        }
    }
    while (true) {
        if (ind[v] >= sz(g[v])) {
            break;
        }
        ans.push_back(g[v][ind[v]].second);
        ind[v]++;
        dfs(g[v][ind[v] - 1].first);
        break;
    }
}

int solve()
{
    int n;
    if (!(cin >> n))
        return 1;
    cin >> c;
    set<ll> qq;
    qq.insert(c);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> w[i];
        qq.insert(a[i]);
        qq.insert(b[i]);
    }
    map<ll, int> kek;
    int cntt = 0;
    for (ll i : qq) {
        kek[i] = cntt++;
    }
    c = kek[c];
    for (int i = 0; i < n; i++) {
        a[i] = kek[a[i]];
        b[i] = kek[b[i]];
    }
    for (int i = 0; i < cntt; i++) {
        ind[i] = 0;
        ins[i] = 0;
        outs[i] = 0;
        g[i].clear();
    }
    fromc.clear();
    notc.clear();
    for (int i = 0; i < n; i++) {
        if (w[i] == 1) {
            g[a[i]].push_back({b[i], i});
            ins[b[i]]++;
            outs[a[i]]++;
        } else {
            if (a[i] == c) {
                fromc.push_back(i);
            } else {
                notc.push_back(i);
            }
        }
    }
    bool ok = true;
    int cntkek = 0;
    for (int i = 0; i < cntt; i++) {
        if (i != c && outs[i] != ins[i]) {
            cntkek++;
            if (outs[i] != ins[i] - 1) {
                ok = false;
            }
            g[i].push_back({c, -1});
            ins[c]++;
            outs[i]++;
        }
    }
    if (cntkek > 1) {
        ok = false;
    }
    ans.clear();
    dfs(c);
    vector<int> ans2;
    int x = 0;
    while (x < sz(ans) && ans[x] != -1) {
        x++;
    }
    if (x < sz(ans) && ans[x] == -1) {
        for (int i = x + 1; i < sz(ans); i++) {
            ans2.push_back(ans[i]);
        }
        for (int i = 0; i < x; i++) {
            ans2.push_back(ans[i]);
        }
    } else {
        ans2 = ans;
    }
    ans = ans2;
    for (int i = 0; i < sz(ans); i++) {
        if (ans[i] == -1) {
            ok = false;
        }
    }
    if (ok && sz(ans) == n) {
        cout << "Yes\n";
        for (int i : ans) {
            cout << i + 1 << ' ';
        }
        cout << endl;
    } else {
        cout << "No" << endl;
    }
    return 0;
}

int32_t main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++)
    {
        if (solve())
            break;
        cout << '\n';
        #ifdef ONPC
            cout << "\n__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
