#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rnd(228);

//typedef __int128 ll;
//typedef long double ld;
 
const ll T = 1e18, Q = 18, K = 10;
 
void printd(ll k)
{
    vector<int> a;
    for (int i = 0; i < Q; i++)
    {
        a.push_back(k % K);
        k /= K;
    }
    for (int i = Q - 1; i >= 0; i--)
        cout << a[i];
}
 
struct Integer
{
    vector<ll> dig;
    ld xxx;
 
    Integer() 
    {
        dig = {0};
        xxx = 0;

    }
 
    
 
    Integer(ll p)
    {
        dig = {p};
        xxx = p;
    }


    Integer& operator=(const Integer& other) = default;
 
    void print()
    {
        cout << dig.back();
        for (int i = (int)dig.size() - 2; i >= 0; i--)
            printd(dig[i]);
        cout << '\n';
    }
 

    bool operator==(const ll &x) const
    {
        return dig.size() == 1 && dig[0] == x;
        //return (*this) == Integer(x);
    }
 


    bool operator<(const Integer &x) const
    {
        return xxx < x.xxx;
        if (x.dig.size() != dig.size())
            return ((x.dig.size() > dig.size()));
        for (int i = 0; i < sz(dig); i++)
            if (dig[i] != x.dig[i])
                return (dig[i] < x.dig[i]);
        return 0;
    }
 
    Integer operator+(Integer x)
    {
        int SZ = max(x.dig.size(), dig.size()) + 1;
        Integer ans;
        ans.dig.assign(SZ, 0);
        for (int i = 0; i < SZ; i++) {
            if (i < sz(x.dig)) {
                ans.dig[i] += x.dig[i];
            }
            if (i < sz(dig)) {
                ans.dig[i] += dig[i];
            }
            if (ans.dig[i] >= T) {
                ans.dig[i] -= T;
                ans.dig[i + 1]++;
            }
        }
        while (sz(ans.dig) > 0 && ans.dig.back() == 0) {
            ans.dig.pop_back();
        }
        ans.xxx = xxx + x.xxx;
        return ans;
    }
 
};

Integer conn[26][27][27];
char gr[27][27];
string rules[101];
string rules2[101];

int xx[27][27][27];

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int p;
	cin >> p;

    int indx = 0;
	for (int i = 0; i < p; i++) {
        rules[i].clear();
		string rule;
		cin >> rule;
		rules[i].pb(rule[0]);
		cin >> rule;
		cin >> rule;
		rules[i].pb(rule[0]);
		if (sz(rule) > 1) rules[i].pb(rule[1]);
        if (sz(rule) > 1) {
            rules2[indx++] = rules[i];
            for (int j = 0; j < rules2[indx - 1].size(); j++) {
                rules2[indx - 1][j] -= 'A';
            }
        }
	}

    shuffle(rules, rules + p, rnd);
    shuffle(rules2, rules2 + indx, rnd);

	int n, m, s, t;
	cin >> n >> m >> s >> t;
	s--, t--;

	for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            gr[i][j] = ' ';
        }
    }
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		char ch;
		cin >> ch;
		gr[a][b] = ch;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
//			if (gr[i][j] != ' ') conn[gr[i][j]][i][j] = Integer(1);
			for (int ii = 0; ii < p; ii++) {
                string rule = rules[ii];
                if (sz(rule) == 2 && rule[1] == gr[i][j]) conn[rule[0] - 'A'][i][j] = Integer(1);
            }
		}

	queue<pair<int, pair<int, int>>> que;
    vector<pair<int, pair<int, int>>> qqq;
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				qqq.push_back(mp(k, mp(i, j)));
                xx[k][i][j] = 1;
			}
		}
	}
    shuffle(qqq.begin(), qqq.end(), rnd);
    for (auto x : qqq) {
        que.push(x);
    }
    vector<int> aaa(n);
    for (int i = 0; i < n; i++) {
        aaa[i] = i;
    }
    shuffle(aaa.begin(), aaa.end(), rnd);
	while (!que.empty()) {
        if (clock() * 1.0 / CLOCKS_PER_SEC > 1.9) {
            break;
        }
		int k = que.front().first;
		int i = que.front().second.first;
		int j = que.front().second.second;
        xx[k][i][j] = 0;
		que.pop();

		for (int ii = 0; ii < indx; ii++) {
            string rule = rules2[ii];
			if (sz(rule) == 3 && !(conn[rule[1]][i][k] == 0) && !(conn[rule[2]][k][j] == 0)) {
				if (conn[rule[0]][i][j] == 0 || conn[rule[1]][i][k] + conn[rule[2]][k][j] < conn[rule[0]][i][j]) {
					conn[rule[0]][i][j] = conn[rule[1]][i][k] + conn[rule[2]][k][j];
					//for (int a = 0; a < n; a++) {
                    if (conn['S' - 'A'][s][t] == 0 || !(conn['S' - 'A'][s][t] < conn[rule[0]][i][j]))
                    for (int a : aaa) {
						if (!xx[j][i][a]) { que.push(mp(j, mp(i, a))); xx[j][i][a] = 1; }
						if (!xx[i][a][j]) { que.push(mp(i, mp(a, j))); xx[i][a][j] = 1; }
					}
				}
			}
		}
	}

	if (conn['S' - 'A'][s][t] == 0) cout << "NO" << endl;
	else {
        conn['S' - 'A'][s][t].print();
        cout << endl;
    }
//    myint xx = myint(123, 123);
//    xx.print();
}
