#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rng(228);


int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int n, k;
	cin >> n >> k;

	vector<vector<ll>> C(n + 1, vector<ll>(n + 1));
	C[0][0] = 1;
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j <= i; j++) {
			C[i][j] += C[i - 1][j];
			if (j > 0) C[i][j] += C[i - 1][j - 1];
		}
	}

	vector<vector<ll>> Csym(n + 1, vector<ll>(n + 1));
	Csym[0][0] = 1;
	Csym[1][0] = 1;
	Csym[1][1] = 1;
	for (int i = 2; i <= n; i++) {
		for (int j = 0; j <= i; j++) {
			Csym[i][j] += Csym[i - 2][j];
			if (j > 1) Csym[i][j] += Csym[i - 2][j - 2];
		}
	}

	ll ans = 0;
	for (int o = max(0, k - n); o <= min(n, k); o++) {
		ans += (C[n][o] - Csym[n][o]) / 2 + Csym[n][o];
	}
	if (k % 2 == 0) ans += (C[n][k / 2] - Csym[n][k / 2]) / 2 + Csym[n][k / 2];

	cout << ans << endl;
}