#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
//#define int ll

const int N = 2e5 + 10;
vector<int> g[N];
map<int, vector<int>> edge[N];
int p[N], s[N], out[N], in[N];
int a[N], b[N], type[N];
int find(int v) {
  return p[v] == v ? v : p[v] = find(p[v]);
}

bool merge(int a, int b) {
  a = find(a), b = find(b);
  if (a == b) {
    return false;
  }
  if (s[a] < s[b]) {
    swap(a, b);
  }
  p[b] = a;
  s[a] += s[b];
  return true;
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int m, init;
  cin >> m >> init;
  vector<int> srt;
  srt.pb(init);
  bool have_not_init = false;
  for (int i = 1; i <= m; i++) {
    cin >> a[i] >> b[i] >> type[i];
    srt.pb(a[i]);
    srt.pb(b[i]);
    if (type[i] == 1) {
      if (b[i] != init) {
        have_not_init = true;
      }
    }
  }  
  sort(all(srt));
  srt.resize(unique(all(srt)) - srt.begin());
  init = lower_bound(all(srt), init) - srt.begin() + 1;
  for (int i = 1; i <= m; i++) {
    a[i] = lower_bound(all(srt), a[i]) - srt.begin() + 1;
    b[i] = lower_bound(all(srt), b[i]) - srt.begin() + 1;
  }
  int sz = SZ(srt);
  for (int i = 1; i <= m; i++) {
    if (type[i] == 0 && a[i] == init && !have_not_init) {
      cout << "No\n";
      exit(0);
    }
  }
  for (int i = 1; i <= sz; i++) {
    p[i] = i;
    s[i] = 1;
  }
  for (int i = 1; i <= m; i++) {
    if (type[i] == 1) {
      g[a[i]].pb(b[i]);
      edge[a[i]][b[i]].pb(i);
      out[a[i]]++;
      in[b[i]]++;
      merge(a[i], b[i]);
    }
  }
  int comps = 0;
  for (int i = 1; i <= sz; i++) {
    if (i == find(i)) {
      if (s[i] > 1) {
        comps++;
      }
    }
  }
  if (comps > 1) {
    cout << "No\n";
    exit(0);
  }
  for (int i = 1; i <= m; i++) {
    if (type[i] == 1 && find(a[i]) != find(init)) {
      cout << "No\n";
      exit(0);
    }
  }
  if (comps == 0) {
    cout << "Yes\n";
    for (int i = 1; i <= m; i++) {
      cout << i << ' ';
    }
    cout << '\n';
    exit(0);
  }
  vector<int> from, to;
  for (int i = 1; i <= sz; i++) {
    if (in[i] != out[i]) {
      if (in[i] + 1 == out[i]) {
        from.pb(i);
      }
      else if (in[i] == out[i] + 1) {
        to.pb(i);
      }      
      else {
        cout << "No\n";
        exit(0);
      }
    }
  }
  if (SZ(from) > 1 || SZ(to) > 1) {
    cout << "No\n";
    exit(0);
  }
  if (SZ(from) == 1) {
    if (from[0] != init) {
      cout << "No\n";
      exit(0);
    }
  }
  else {
    from.pb(init);
  }
  vector<int> res;
  vector<int> st = from;
  while (!st.empty()) {
    int v = st.back();
    if (g[v].empty()) {
      st.pop_back();
      res.pb(v);
    }
    else {
      st.pb(g[v].back());
      g[v].pop_back();
    }
  }
  reverse(all(res));
  bool inserted_huy = false;
  vector<int> ans;
  for (int i = 1; i <= m; i++) {
    if (type[i] == 0 && a[i] != init) {
      ans.pb(i);
    }
  }
  for (int i = 0; i + 1 < SZ(res); i++) {
    ans.pb(edge[res[i]][res[i + 1]].back());
    edge[res[i]][res[i + 1]].pop_back();
    if (res[i + 1] != init && !inserted_huy) {
      inserted_huy = true;
      for (int j = 1; j <= m; j++) {
        if (type[j] == 0 && a[j] == init) {
          ans.pb(j);
        }
      }
    }
  }
  assert(SZ(ans) == m);
  cout << "Yes\n";
  for (auto it : ans) {
    cout << it << ' ';
  }
  cout << '\n';
} 

