#include <bits/stdc++.h>
#define int long long

using namespace std;

const int N = 57;
int cnk[N][N];
int fact[N];

void init() {
    memset(cnk, 0, sizeof(cnk));
    cnk[0][0] = 1;
    fact[0] = 1;
    for (int i = 1; i < N; i++) {
        fact[i] = fact[i - 1] * i;
        cnk[i][0] = 1;
        for (int j = 1; j < N; j++) {
            cnk[i][j] = cnk[i - 1][j - 1] + cnk[i - 1][j];
        }
    }
}

int cnt_all(int n, int k) {
    return cnk[n][k];
}

int cnt_symm(int n, int k) {
    if (n % 2 == 0 && k % 2 == 1)
        return 0;
    return cnk[n / 2][k / 2];
    /*if (n % 2 == 0 && k % 2 == 0) {
        return cnk[n / 2][k / 2];
    }
    if (n % 2 == 1 && k % 2 == 1) {
        return cnk[n / 2][k / 2];
    }*/
}

signed main() {
    init();
    int n, k;
    cin >> n >> k;
    int all = 0;
    vector <int> poss;
    for (int i = 0; i <= k; i++) {
        if (i <= n && (k - i) <= n)
            poss.push_back(i);
    }
    cout << poss.size() << endl;
    for (int elem : poss) {
        int a = cnt_all(n, elem), b = cnt_symm(n, elem);
        if (elem * 2 != k)
            all += (a - b) / 2 + b;
        else
            all += a + b;
    }
    cout << all << endl;
}
