#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
const int N = 110;
const int inf = 1e9;

vector<int> a, b, w;



vector<int> kek(vector<vector<int>> g, int n, int v, vector<int> id) {
    vector<int> ans;
    int num = 0;
    bool f = 0;
    vector<bool> used(id.size());
    vector<int> degout(n), degin(n);
    for (int i = 0; i < n; i++) {
        for (auto s : g[i]) {
            int j = id[s];
            degout[i]++;
            degin[j]++;
        }
    }


    for (int u = 0; u < n; u++) {

        if (u == v) {
            if (degout[u] == degin[u]) f = 1;
            else if (degout[u] != degin[u] + 1) return ans;
        }
        else {
            if (degout[u] != degin[u]) {
                if (degin[u] == degout[u] + 1) num++;
                else return ans;
            }
        }
    }

    if (f && num > 0) return ans;
    if (!f && num != 1) return ans;
    ans = {};
    stack<pair<int,int>> S;
    S.push({ v,-1 });  // S — стек
    while (!S.empty()) {
        auto p = S.top();
        int w = p.first;
        bool found_edge = false;
        for (int edge : g[w]) {
            if (!used[edge]) {
                int u = id[edge];  // нашли ребро, по которому ещё не прошли
                S.push({ u,edge });  // добавили новую вершину в стек
                used[edge] = true;
                found_edge = true;
                break;
            }

        }

        if (!found_edge) {
            S.pop(); // не нашлось инцидентных вершине w рёбер, по которым ещё не прошли
            ans.push_back(p.second);
        }

    }
    reverse(ans.begin(), ans.end());
    return ans;
}



int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n; cin >> n;
    int c; cin >> c;
    set<int> st;
    st.insert(c);

    a.resize(n);
    b.resize(n);
    w.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> w[i];
        st.insert(a[i]);
        st.insert(b[i]);
    }
    map<int, int> id;
    int sz = 0;
    for (auto x : st) {
        id[x] = sz++;
    }

    for (auto &x : a) x = id[x];
    for (auto &x : b) x = id[x];
    c = id[c];

    vector<vector<int>> g(sz);
    vector<int> idedges(n);
    for (int i = 0; i < n; i++) {
        if (w[i]) {
            int v1 = a[i];
            int v2 = b[i];
            g[v1].push_back(i);
            idedges[i] = v2;
        }
    }

    auto pth = kek(g, sz, c, idedges);

    if (pth.empty()) {
        cout << "No" << endl;
        return 0;
    }
    pth.erase(pth.begin());
    vector<int> ans;
    vector<int> used(n);
    vector<int> left;
    for (int i = 0; i < n; i++) {
        if (w[i] == 0) {
            if (a[i] != c) {
                ans.push_back(i);
                used[i] = 1;
            } else {
                left.push_back(i);
            }
        }
    }

    for (auto x : pth) {
        ans.push_back(x);

        if (b[x] != c && 1.0 * clock() / CLOCKS_PER_SEC < 1.5) {
            for (auto i : left) {
                if (w[i] == 0 && !used[i]) {
                    if (a[i] != b[x]) {
                        ans.push_back(i);
                        used[i] = 1;
                    }
                }
            }
        }

    }

    if (ans.size() == n) {
        cout << "Yes" << endl;
        for (auto x : ans) cout << x + 1 << " ";
        cout << endl;
        return 0;
    }

    cout << "No" << endl;
}

