#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int) 1e9 + 7;

struct vertex
{
	int dist, sost, from, to;
	vertex(int a = 0, int b = 0, int c = 0, int d = 0) {dist = a, sost = b, from = c, to = d;}
	bool operator < (const vertex &a) const
	{
	 	return (dist < a.dist) || (dist == a.dist && sost < a.sost) || (dist == a.dist && sost == a.sost && from < a.from)
	 		   || (dist == a.dist && sost == a.sost && from == a.from && to < a.to);
	}
};

bool matr[30][30];
vector <pair <int, pair <int, int> > > spis;
int dist[30][30][30];
set <vertex> opa;

int main()
{
 	//freopen("input.txt", "r", stdin);
 	//freopen("output.txt", "w", stdout);
 	ios_base::sync_with_stdio(0); cin.tie(0);
 	int p;
 	string t;
 	cin >> p;
 	getline(cin, t);
 	for (int i = 1; i <= p; i++)
 	{
 	 	string s;
 	 	getline(cin, s);
 	 	int lef = s[0] - 'A' + 1;
 	 	if (s[5] <= 'z' && s[5] >= 'a') matr[lef][s[5] - 'a' + 1] = true;
 	 	else spis.pb(mp(lef, mp(s[5] - 'A' + 1, s[6] - 'A' + 1)));
	}
	int Start = 'S' - 'A' + 1;

	int n, m, start, finish;
	cin >> n >> m >> start >> finish;
	for (int i = 1; i <= 26; i++)
		for (int j = 1; j <= n; j++)
			for (int z = 1; z <= n; z++)
				dist[i][j][z] = INF;
	
	for (int i = 1; i <= m; i++)
	{
	 	int u, v;
	 	char c;
	 	cin >> u >> v >> c;
	 	for (int j = 1; j <= 26; j++)
	 		if (matr[j][c - 'a' + 1]) dist[j][u][v] = 1, opa.insert(vertex(1, j, u, v));
	}
	
	while (!opa.empty())
	{
	 	vertex A = *opa.begin();
	 	opa.erase(opa.begin());
	 	for (int i = 1; i <= n; i++)
	 		for (int nx = 0; nx < (int) spis.size(); nx++)
	 		{
	 			int st1 = spis[nx].x, st2 = spis[nx].y.x, st3 = spis[nx].y.y;
	 			if (st2 == A.sost && dist[A.sost][A.from][A.to] + dist[st3][A.to][i] < dist[st1][A.from][i])
	 			{
	 			 	opa.erase(vertex(dist[st1][A.from][i], st1, A.from, i));
	 			 	dist[st1][A.from][i] = dist[A.sost][A.from][A.to] + dist[st3][A.to][i];
	 			 	opa.insert(vertex(dist[st1][A.from][i], st1, A.from, i));
	 			}
	 			if (st3 == A.sost && dist[st2][i][A.from] + dist[A.sost][A.from][A.to] < dist[st1][i][A.to])
	 			{
	 				opa.erase(vertex(dist[st1][i][A.to], st1, i, A.to));
	 			 	dist[st1][i][A.to] = dist[st2][i][A.from] + dist[A.sost][A.from][A.to];
	 			 	opa.insert(vertex(dist[st1][i][A.to], st1, i, A.to));
	 			}
	 	   	}
	}

	if (dist[Start][start][finish] == INF) cout << "NO\n";
	else cout << dist[Start][start][finish] << '\n';
 	return 0;
}