#include <bits/stdc++.h>

namespace Competitive {
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) begin(a), end(a)
#define len(a) (int)a.size()
#define pb push_back
#define eb emplace_back
#define em emplace
#define y0 withindarkness
#define y1 apinklotusbloomed
#define yn carryingapurplesoul
#define j1 togetherformingtheTeam

void useiostream() {
  ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
  cout.setf(ios::fixed), cout.precision(20);
}

void drop(char const* bu) {
  printf("%s", bu);
  exit(0);
}

ull gcd(ull a, ull b) { return b == 0 ? a : gcd(b, a % b); }

ll lcm(ll a, ll b) { return a / gcd(a, b) * b; }

ld const pi = acos(-1.0L);
ld const eps = 0.0001L;

template <typename T, typename TT>
bool mi(T& a, TT b) {
  return a > b ? (a = b, true) : false;
}
template <typename T, typename TT>
bool ma(T& a, TT b) {
  return a < b ? (a = b, true) : false;
}

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 ran(seed);

int Mod[2] = {1000000007, 1052339657};
int const mod = 1000000007;

}  // namespace Competitive

using namespace Competitive;

int n;

int curOperations = 0;

int ask(int a, int b) {
  curOperations++;
  cout << a << " " << b << endl;
  string re;
  cin >> re;
  if (re == "SWAPPED") {
    return 1;
  }
  if (re == "STAYED") {
    return 0;
  }
  if (re == "WIN") {
    exit(0);
  }
}

void solve() {
  cin >> n;
  for (int i = n - 1; i >= 1; i--) {
    ask(i, i + 1);
  }
  for (int i = n - 1; i >= 2; i--) {
    ask(i, i + 1);
  }
  while (curOperations % (2 * n)) {
    ask(1, 2);
  }
  ask(1, 2);
  for (int i = n - 1; i >= 2; i--) {
    ask(i, i + 1);
  }
  for (int k = 3; k <= n; k++) {
    for (int i = n - 1; i >= k; i--) {
      ask(i, i + 1);
    }
    while (curOperations % (2 * n)) {
      ask(1, 2);
    }
    // need to repair 1..k
    int left = -1;
    for (int i = 1; i < k; i++) {
      if (ask(i, i + 1)) {
        // swapped element i and something how to make sure that it is in 1..k?
        left = i;
        // now swapped thing in pos left + 1
        break;
      }
    }
    if (left == -1) continue;
    bool areTwo = 0;
    for (int j = k - 1; j >= left + 2; j--) {
      if (ask(j, j + 1)) {
        ask(left, j);
        ask(left + 1, j);
        ask(j, j + 1);
        areTwo = 1;
      }
    }
    if (!areTwo) {
      for (int i = left + 1; i < k; i++) {
        ask(i, i + 1);
      }
    }
  }
}

int main() {
  // freopen("lwdb.in", "r", stdin);
  // freopen("lwdb.out", "w", stdout);
  useiostream();
  int T = 1;
  // cin >> T;
  while (T--) {
    solve();
  }
  return 0;
}
