#include <bits/stdc++.h>

#include <utility>

using namespace std;

using ll = long long int;
using ld = long double;
using ui = unsigned int;
using ull = unsigned long long;
using pp = pair<int, int>;
using tt = tuple<int, int, int>;

const int inf = (int) 1e9 + 1;
//const int mod = (int) 1e9 + 7;
const int mod = 998244353;
//const ll inf = (ll) 1e18;

#define umap unordered_map
#define uset unordered_set
#define Power ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define pb push_back

template<typename T>
T gcd(T a, T b) {
  return b ? gcd(b, a % b) : a;
}

template<typename T>
T lcp(T a, T b) {
  return a * b / gcd(a, b);
}

mt19937_64 mers((random_device()) ());

void solve() {
  int n, c;
  cin >> n >> c;
  map<int, vector<pp>> f;
  map<int, vector<pp>> s;
  map<int, int> deg;
  for (int i = 0; i < n; i++) {
    int from, to, x;
    cin >> from >> to >> x;
    if (x == 0) {
      f[from].emplace_back(to, i);
    } else {
      s[from].emplace_back(to, i);
      deg[from]++;
      deg[to]--;
    }
  }

  int out = 0, in = 0;

  for (auto &[key, val] : deg) {
    if (abs(val) > 1) {
      cout << "No";
      return;
    }
    if (val > 0) {
      out++;
      if (key != c) {
        cout << "No";
        return;
      }
    } else if (val < 0) {
      in++;
    }
  }
  if (out != in || in > 1 || out > 1) {
    cout << "No";
    return;
  }

  vector<int> ans;
  ans.reserve(n);
  deque<pair<int, pp>> st;
  st.emplace_back(c, pp(-1, -1));
  while (!st.empty()) {
    int v = st.back().first;
    pp from = st.back().second;
    if (s[v].empty()) {
      map<int, vector<pp>> tmp(f);
      for (auto&[key, value] : tmp) {
        if (key != v) {
          for (auto &x : value) {
            ans.push_back(x.second);
          }
          f.erase(key);
        }
      }
      if (from.second != -1)
        ans.push_back(from.second);
      st.pop_back();
    } else {
      auto to = s[v].back();
      s[v].pop_back();
      st.emplace_back(to.first, pp(v, to.second));
    }
  }

  reverse(all(ans));

  if (ans.size() != n)
    cout << "No";
  else {
    cout << "Yes\n";
    for (auto it : ans)
      cout << it + 1 << " ";
  }

}

signed main() {

  Power;


#ifdef _DEBUG
  (void) freopen("input.txt", "r", stdin);
  (void) freopen("output.txt", "w", stdout);
#else
  //  (void)freopen("lwdb.in", "r", stdin);
  //  (void)freopen("lwdb.out", "w", stdout);
#endif

  int queue_counter = 1;
//  cin >> queue_counter;
  while (queue_counter--) {
    solve();
  }

  return 0;
}