#pragma GCC optimize("Ofast", "O3", "unroll-loops", "omit-frame-pointer", "inline")
#pragma GCC target("sse", "sse2", "sse3", "ssse3", "sse4", "popcnt", "abm", "mmx", "avx", "avx2")
#pragma GCC option("tune = native", "arch = native", "no-zero-upper")
#pragma comment(linker, "/stack:200000000")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

#define pb push_back
#define mp make_pair
#define st first
#define nd second
#define it insert
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pbb pair<bool, bool>
#define pll pair<ll, ll>
#define MNOGO ll(1e18)
#define INF int(1e9)
#define ret return
#define bn begin
#define ed end
#define SET tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, c;
	cin >> n >> c;
	SET compression;
	compression.it(c);
	vector<pii> edges(n);
	vector<bool> w(n);
	for (int i = 0; i < n; i++) {
		bool flag;
		cin >> edges[i].st >> edges[i].nd >> flag;
		w[i] = flag;
		compression.it(edges[i].st);
		compression.it(edges[i].nd);
	}
	c = compression.order_of_key(c);
	for (int i = 0; i < n; i++) {
		edges[i].st = compression.order_of_key(edges[i].st);
		edges[i].nd = compression.order_of_key(edges[i].nd);
	}
	vector < vector<int> > g(compression.size(), vector<int>(0));
	vector<int> not_from_c(0), from_c(0);
	int ok_from_c = 0;
	int path_max = 0;
	for (int i = 0; i < n; i++) {
		if (w[i]) {
			g[edges[i].st].pb(i);
			path_max++;
		}
		else if (edges[i].st != c) {
			not_from_c.pb(i);
		}
		else {
			from_c.pb(i);
		}
	}
	if (path_max == 0) {
		if (from_c.size() == 0) {
			cout << "Yes\n";
			for (int i = 0; i < n; i++)
				cout << i + 1 << ' ';
		}
		else {
			cout << "No";
		}
		ret 0;
	}
	if (g[c].size() == 0) {
		cout << "No";
		ret 0;
	}
	stack<int> path;
	vector<char> color(n, 0);
	while (path.size() != path_max) {
		if (path.empty()) {
			bool ok = 0;
			for (int i : g[c]) {
				if (color[i] == 0) {
					path.push(i);
					color[i] = 1;
					ok = 1;
					break;
				}
			}
			if (!ok) {
				cout << "No";
				ret 0;
			}
		}
		else {
			int cur_edge = path.top();
			if (edges[cur_edge].nd != c && ok_from_c == 0) {
				ok_from_c = path.size();
			}
			bool ok = 0;
			int cur_vert = edges[cur_edge].nd;
			for (int i : g[cur_vert]) {
				if (color[i] == 0) {
					path.push(i);
					color[i] = 1;
					ok = 1;
					break;
				}
			}
			if (!ok) {
				for (int i : g[cur_vert]) {
					if (color[i] == 2) {
						color[i] = 0;
					}
				}
				color[cur_edge] = 2;
				if (ok_from_c == path.size())
					ok_from_c = 0;
				path.pop();
			}
		}
	}
	if (!ok_from_c && from_c.size() != 0 || path.size() != path_max) {
		if (path.size() != path_max) {
			ret 100;
		}
		cout << "No";
		ret 0;
	}
	cout << "Yes\n";
	for (int i : not_from_c)
		cout << i + 1 << ' ';
	vector<int> path_arr(path_max);
	for (int i = 0; i < path_max; i++) {
		path_arr[path_max - i - 1] = path.top();
		path.pop();
	}
	for (int i = 0; i < path_max; i++) {
		cout << path_arr[i] + 1 << ' ';
		if (i + 1 == ok_from_c) {
			for (int j : from_c)
				cout << j + 1 << ' ';
		}
	}
	return 0;
}