#include <iostream> 
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <set>
#include <stack>
#include <queue> 
#include <cmath>
#include <ctime>
#include <climits>

#pragma GCC optimize("Ofast", "O3", "unroll-loops", "omit-frame-pointer", "inline")
#pragma GCC target("sse", "sse2", "sse3", "ssse3", "sse4", "popcnt", "abm", "mmx", "avx", "avx2")
#pragma GCC option("tune = native", "arch = native", "no-zero-upper")
#pragma comment(linker, "/stack:200000000")
using namespace std;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<int> s(n);
	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	s.push_back(0);
	sort(s.begin(), s.end());
	int i = 0, j = INT_MAX;
	for (int k = 1; k < s.size(); k++) {
		i = max(i, s[k] - s[k - 1]);
	}
	for (int k = 1; k < s.size() - 1; k++) {
		j = min(j, s[k + 1] - s[k - 1]);
	}
	if (j <= i) {
		cout << 0;
	}
	else {
		cout << i;
	}
}