import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class P2 {
    public static void main(String[] args) throws IOException {
        class Letter {
            private char n;
            private int[][] pixels;

            private Letter(char n, int w, int h) {
                this.n = n;
                this.pixels = new int[w][h];
            }
        }
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer input = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(input.nextToken());
        int w = Integer.parseInt(input.nextToken());
        int h = Integer.parseInt(input.nextToken());
        int s = Integer.parseInt(input.nextToken());
        String buffer;
        Letter[] a = new Letter[n];
        for (int i = 0; i < n; i++) {
            buffer = reader.readLine();
            a[i] = new Letter(buffer.charAt(0), h, w);
            for (int j = 0; j < h; j++) {
                buffer = reader.readLine();
                for (int k = 0; k < w; k++) {
                    a[i].pixels[j][k] = buffer.charAt(k) == '#' ? 1 : 0;
                }
            }
        }
        int max = -1;
        int maxBuf = -1;
        int bufferInt = 0;
        int x = 0;
        for (int i = 0; i < n; i++) {
            for (int k = 0; k < h; k++) {
                for (int l = 0; l < w; l++) {
                    if ((a[i].pixels[k][l] == 1 && (l == 0 || l == w - 1 || a[i].pixels[k][l + 1] == 0)) || (a[i].pixels[k][l] == 0 && l != w - 1 && a[i].pixels[k][l + 1] == 1)) {
                        if (a[i].pixels[k][l] == 1 && l == 0 && a[i].pixels[k][l + 1] == 0) {
                            bufferInt += 2;
                        } else {
                            bufferInt++;
                        }
                    }
                }
                if (bufferInt > maxBuf) {
                    maxBuf = bufferInt;
                }
                bufferInt = 0;
            }
            if (maxBuf > max) {
                max = maxBuf;
                x = i;
            }
            maxBuf = 0;
        }
        int q = s / max;
        boolean r = s % max != 0;
        StringBuilder string = new StringBuilder();
        string.append(String.valueOf(a[x].n).repeat(q));
        if (r) {
            string.append(a[x].n);
        }
        System.out.println(string.toString());
    }
}