#include <iostream>

using namespace std;

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);

    int n, w, h, s;
    cin >> n >> w >> h >> s;

    int max_switches = -1;
    char max_char = '0';

    for (int q = 0; q < n; ++q) {
        char c;
        cin >> c;
        for (int i = 0; i < h; ++i) {
            string str;
            cin >> str;

            int switches = 0;
            int state = 0;
            for (int j = 0; j < w; ++j) {
                if (str[j] == '.' && state == 1) {
                    state = 0;
                    ++switches;
                } else if (str[j] == '#' && state == 0) {
                    state = 1;
                    ++switches;
                }
            }
            if (state) ++switches;

            if (switches > max_switches) {
                max_switches = switches;
                max_char = c;
            }
        }
    }

    int switches = 0;
    while (switches < s) {
        switches += max_switches;
        cout << max_char;
    }

    return 0;
}
