#include <iostream>
#include <string>
#include <functional>
#include <map>

using namespace std;

using ll = long long;

struct op {
    ll a, b, w, id;
};


int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    ll n, c;
    cin >> n >> c;

    vector<op> ops;

    for (ll i = 0; i < n; ++i) {
        op o;
        cin >> o.a >> o.b >> o.w;
        o.id = i;
        ops.push_back(o);
    }

    vector<ll> k1, k2;
    map<ll, vector<op>> g;
    map<ll, ll> skip;

    for (auto &o : ops) {
        if (o.w == 1) {
            g[o.a].push_back(o);
            continue;
        }
        if (o.a == c) k2.push_back(o.id); else k1.push_back(o.id);
    }

    ll odd_deg = 0;
    for (auto [from, tov] : g) {
        if (tov.size() % 2 == 1) odd_deg++;
    }

    ll v = c;
    
    while (1) { 
        auto &tov = g[v];
        auto &sk = skip[v];
        if (v != c && !k2.empty()) {
            for (ll x : k2) {
                k1.push_back(x);
            }
            k2.clear();
        }
        if (sk < tov.size()) {
            k1.push_back(tov[sk].id);
            v = tov[sk].b;
            ++sk;
        } else {
            break;
        }
    }

    if (k1.size() == n) {
        cout << "Yes\n";
        for (ll x : k1) {
            cout << x + 1 << ' ';
        }
        cout << "\n";
    } else {
        cout << "No" << endl;
        return 0;
    }

    return 0;
}
