﻿//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <string>
#include <cmath>
#include <functional>
#include <algorithm>
#include <utility>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#include <iterator>
#include <fstream>
#include <iomanip>
#include <time.h>
#include <complex>
#include <chrono>
#include <random>
#include <cassert>

//#pragma comment(linker, "/STACK:16777216")

using namespace std;

typedef double C;
typedef complex<C> P;

#define X real()
#define Y imag()
#define Size(X) (int)X.size()
#define ui unsigned int
#define int long long
#define mp make_pair
#define timer fghge
#define y1 yjyjyju
#define all(X) (X).begin(), (X).end()
//#define endl '\n'
mt19937_64 rnd(std::chrono::system_clock::now().time_since_epoch().count());

int n, ctr = 0, global = 0;

string query(int l, int r) {
	if (l > r) swap(l, r);
	cout << l << " " << r << endl;

	global++;
	assert(l < r && l >= 1 && r <= n && global <= 10000);

	string s; cin >> s;
	if (s == "WIN")
		exit(0);
	ctr++;
	return s;
}

void repair(int suff) {
	int r = n - 1, l = n - suff;

	for (int i = 1; i < l; i++)
		query(i, i + 1);

	l = max(0LL, l - 1);

	vector<int> order;

	for (int j = l + 1; j <= r; j++) {
		string s = query(j, j + 1);

		if (s == "s")
			order.push_back(j);
	}
	if (order.size() < 2)
		return;

	order[1]--;
	if (order[0] == order[1])
		order[1]++;

	query(order[0] + 1, order[1] + 1);
	if (order[0] > 0)
		query(order[0], order[0] + 1);
	if (order[1] + 2 <= n)
		query(order[1] + 1, order[1] + 2);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("palindrome.out", "w", stdout);
	cin >> n;
	for (int suff = 0; suff <= n; suff++) {
		ctr = 0;
		if (suff > 0)
			repair(suff); //чиним суффикс

		for (int j = 1; j < n - suff; j++)
			query(j, j + 1);

		int old = ctr;
		for (int i = 0; i < 2 * n - old; i++) {
			int l = rnd() % n + 1, r = rnd() % n + 1;
			while (l == r)
				l = rnd() % n + 1, r = rnd() % n + 1;
			query(l, r);
		}
	}
	while (true)
		for (int i = 2; i <= n; i++)
			query(i - 1, i);
	return 0;
}