﻿//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <cstdio>
#include <vector>    
#include <set>
#include <queue>
#include <map>
#include <string>
#include <cmath>
#include <functional>
#include <algorithm>
#include <utility>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#include <iterator>
#include <fstream>
#include <iomanip>
#include <time.h>
#include <complex>
#include <chrono>
#include <random>
#include <cassert>
//#include "string.h"
//#pragma comment(linker, "/STACK:16777216")

using namespace std;

typedef double C;
typedef complex<C> P;

#define X real()
#define Y imag()
#define Size(X) (int)X.size()
#define ui unsigned int
//#define int long long
#define mp make_pair
#define timer fghge
#define y1 yjyjyju
#define all(X) (X).begin(), (X).end()
#define endl '\n'
mt19937_64 rnd(std::chrono::system_clock::now().time_since_epoch().count());

int n, c;

struct node {
	bool used = 0;
	vector<pair<pair<int, int>, bool>> edges;
};
vector<node> g;
vector<int> ans;

void dfs(int start, int last = -1) {
	while(!g[start].edges.empty()){
		auto cur = g[start].edges.back();
		if (cur.second) 
			continue;
	
		g[start].edges.pop_back();
		dfs(cur.first.first, cur.first.second);
	}
	if(last != -1)
	ans.push_back(last);
}

void check() {
	for (auto &i : g) {
		for (auto &j : i.edges) {
			if (j.second == 0) {
				cout << "No";
				exit(0);
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("palindrome.out", "w", stdout);
	cin >> n >> c;

	vector<pair<pair<int, int>, int>> cas(n);
	set<int> order;
	for (auto &i : cas)
		cin >> i.first.first >> i.first.second >> i.second;
	
	for (auto &i : cas) {
		order.insert(i.first.first);
		order.insert(i.first.second);
	}
	order.insert(c);

	unordered_map<int, int> to;
	int ind = 0;
	for (auto &i : order)
		to[i] = ind++;

	g.resize(order.size());

	for (auto &i : cas) {
		i.first.first = to[i.first.first];
		i.first.second = to[i.first.second];
	}

	for (int i = 0; i < n; i++) 
		if (cas[i].second == 1) 
			g[cas[i].first.first].edges.push_back({ {cas[i].first.second, i}, 0 });

	dfs(to[c]);
	check();
	reverse(all(ans));

	set<pair<int, int>> bad;
	for (int i = 0; i < n; i++)
		if(cas[i].second == 0)
			bad.insert({ cas[i].first.first, i });

	vector<int> out;

	int v = to[c];
	for (auto &i : ans) {
		if (v != cas[i].first.first) {
			cout << "No";
			return 0;
		}

		vector<pair<int, int>> cur;
		for (auto &j : bad)
			if (j.first != v)
				cur.push_back(j);

		for (auto &j : cur) {
			out.push_back(j.second);
			bad.erase(j);
		}

		out.push_back(i);
		v = cas[i].first.second;
	}
	vector<pair<int, int>> cur;
	for (auto &j : bad)
		if (j.first != v)
			cur.push_back(j);
	for (auto &j : cur) {
		out.push_back(j.second);
		bad.erase(j);
	}
	if (!bad.empty()) {
		cout << "No";
		return 0;
	}

	cout << "Yes" << endl;
	for (auto &i : out)
		cout << i + 1 << " ";
	return 0;
}
