#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;


int main(){
    int n;
    double P;

    cin >> n >> P;
    vector<double> a(n);
    for (int i=0; i<n; i++){
        scanf("%lf", &a[i]);
    }

    vector<double> pref_dif(n);
    vector<double> pref_square_dif(n);

    pref_dif[0] = 0.0;
    pref_dif[0] = 0.0;

    for (int i=1; i<n; i++){
        pref_dif[i] = pref_dif[i - 1] + (a[i] - a[i - 1]);
        pref_square_dif[i] = pref_square_dif[i - 1] + (a[i] - a[i - 1])*(a[i] - a[i - 1]);
        //cout << a[i] - a[i - 1] << " " << pref_dif[i] << " " << pref_square_dif[i] << endl;
    }

    for (int i=0; i<n; i++){
        cout << pref_dif[i] << " ";
    }
    cout << endl;
    for (int i=0; i<n; i++){
        cout << pref_square_dif[i] << " ";    
    }
    cout << endl;
    int c_pos = 0;
    int c_neg = 0;
    for (int l=0; l < n - 2;l++){
        for (int r = l + 2; r < n; r++){
            double dif = pref_dif[r] - pref_dif[l];
            double A =  dif / double(r - l);
            double sq_dif = pref_square_dif[r] - pref_square_dif[l];
            double D = sq_dif - 2.0*A*dif + double(r - l)*A*A;
            D = sqrt(D/double(r - l));
            cout << l << " " << r << " " << A << " " << D << " " << A/D << endl;
            if (A/D >= P){
                c_pos++;
            }
            if (A/D <= -P){
                c_neg++;
            }
        }
    }

    //cout << (pref_dif[4] - pref_dif[1]) << endl;
    cout << c_pos << " " << c_neg << endl;
}
