#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;

long long myceil(long long a, long long b){
	if(a % b == 0){
		return a / b;
	} else {
		return (a / b) + 1;
	}
}

int main(){
	//freopen("inpA.txt", "t", stdin);
	long long n, w, h, s;
	cin >> n >> w >> h >> s;
	vector<char> ltrs(n + 1);
	vector<vector<char>> ch(h, vector<char>(w));
	vector<vector<long long>> mg(n, vector<long long>(w, 0));
	for(int i = 0; i < n; i++){
		cin >> ltrs[i];
		string s;
		for(int ih = 0; ih < h; ih++){
			cin >> s;
			for(int jw = 0; jw < w; jw++){
				ch[ih][jw] = s[jw];
			}
		}
		for(int jw = 0; jw < w; jw++){
			for(int ih = 1; ih < h; ih++){
				if(ch[ih][jw] != ch[ih - 1][jw]){
					mg[i][jw]++;
				}
			}
			if(ch[0][jw] == '#'){
				mg[i][jw]++;
			}
			if(ch[h - 1][jw] == '#'){
				mg[i][jw]++;
			}
		}
	}
	long long maxx = -10;
	long long varmaxx = -1;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < w; j++){
			if(mg[i][j] > maxx){
				maxx = mg[i][j];
				varmaxx = i;
			}
		}
	}
	for(int i = 0; i < myceil(s, maxx); i++){
		cout << ltrs[varmaxx];
	}

}