#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;

long long myceil(long long a, long long b){
	if(a % b == 0){
		return a / b;
	} else {
		return (a / b) + 1;
	}
}

void printllv(vector<vector<long long>> v){
	for(int i = 0; i < v.size(); i++){
		for(int j = 0; j < v[i].size(); j++){
			cout << v[i][j] << " ";
		}
		cout << endl;
	}
}

int main(){
	//freopen("inpA.txt", "t", stdin);
	long long n, w, h, s;
	cin >> n >> w >> h >> s;
	vector<char> ltrs(n + 1);
	vector<vector<char>> ch(h, vector<char>(w));
	vector<vector<long long>> mg(n, vector<long long>(h, 0));
	for(int i = 0; i < n; i++){
		cin >> ltrs[i];
		string s;
		for(int ih = 0; ih < h; ih++){
			cin >> s;
			for(int jw = 0; jw < w; jw++){
				ch[ih][jw] = s[jw];
			}
		}
		for(int ih = 0; ih < h; ih++){
			for(int jw = 1; jw < w; jw++){
				if(ch[ih][jw] != ch[ih][jw - 1]){
					mg[i][ih]++;
				}
			}
			if(ch[ih][0] == '#'){
				mg[i][ih]++;
			}
			if(ch[ih][w - 1] == '#'){
				mg[i][ih]++;
			}
		}
	}
	long long maxx = -10;
	long long varmaxx = -1;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < h; j++){
			if(mg[i][j] > maxx){
				maxx = mg[i][j];
				varmaxx = i;
			}
		}
	}
	//printllv(mg);
	string ans = "";
	for(int i = 0; i < myceil(s, maxx); i++){
		ans += ltrs[varmaxx];
	}
	cout << ans;
}