#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#include <unordered_map>
#include <immintrin.h>
#include <functional>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <fstream>
#include <stdio.h>
#include <complex>
#include <iomanip>
#include <climits>
#include <bitset>
#include <math.h>
#include <string>
#include <random>
#include <vector>
#include <time.h>
#include <chrono>
#include <queue>
#include <deque>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <db, db> pdd;
typedef complex <double> cmpl;

const ll MOD = (ll)1e9 + 7;
const ll MOD1 = 2286661337;
const ll MOD2 = 998244353;
const int INF = (int)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)50;

struct node {
    int operation, num_var;

    node(int operation = -1, int num_var = -1) : operation(operation), num_var(num_var) {}
};

string s;
vector <vector <int>> G;
vector <node> a;
int mask, root;
vector <int> dis;
char ans[N][N];

bool cmp(pair <int, node> a, pair <int, node> b) {
    if (a.second.operation == b.second.operation) {
        return a.first > b.first;
    }
    return a.second.operation < b.second.operation;
}

int parse(int indl, int indr) {
    if (s[indl] == '(' && s[indr] == ')') {
        return parse(indl + 1, indr - 1);
    }
    if (indr == indl) {
        a.push_back(node(3, s[indl] - 'a'));
        G.push_back(vector <int>(0));
        return a.size() - 1;
    }
    string cur_s;
    int balance = 0;
    vector <pair <int, node>> list_of_operations;
    for (int i = indl; i <= indr; ++i) {
        if (balance == 0) {
            if (s[i] == ' ') {
                if (cur_s.size() == 1) {
                    list_of_operations.push_back(make_pair(i - 1, node(3, s[i] - 'a')));
                } else if (cur_s == "or") {
                    list_of_operations.push_back(make_pair(i - 2, node(0, -1)));
                } else if (cur_s == "and") {
                    list_of_operations.push_back(make_pair(i - 3, node(1, -1)));
                } else if (cur_s == "not") {
                    list_of_operations.push_back(make_pair(i - 3, node(2, -1)));
                }
                cur_s = "";
            } else {
                cur_s.push_back(s[i]);
            }
        }
        if (s[i] == '(') {
            ++balance;
        } else if (s[i] == ')') {
            --balance;
        }
    }
    if (s[indr] != ')') {
        if (cur_s.size() == 1) {
            list_of_operations.push_back(make_pair(indr - 1, node(3, s[indr] - 'a')));
        } else if (cur_s == "or") {
            list_of_operations.push_back(make_pair(indr - 2, node(0, -1)));
        } else if (cur_s == "and") {
            list_of_operations.push_back(make_pair(indr - 3, node(1, -1)));
        } else if (cur_s == "not") {
            list_of_operations.push_back(make_pair(indr - 3, node(2, -1)));
        }
    }
    sort(list_of_operations.begin(), list_of_operations.end(), cmp);
    a.push_back(node(list_of_operations[0].second));
    G.push_back(vector <int>(0));
    if (a.back().operation < 2) {
        G.back().push_back(parse(indl, list_of_operations[0].first - 2));
        G.back().push_back(parse(list_of_operations[0].first + a.back().operation + 3, indr));
    } else if (a.back().operation == 2) {
        G.back().push_back(parse(indl + 4, indr));
    }
    return a.size() - 1;
}

int func(int v) {
    if (a[v].operation == 0) {
        return func(G[v][0] | G[v][1]);
    } else if (a[v].operation == 1) {
        return func(G[v][0] & G[v][1]);
    } else if (a[v].operation == 2) {
        return !func(G[v][0]);
    } else {
        return (mask >> a[v].num_var & 1);
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    fastio;
    cin >> s;
    root = parse(0, s.size() - 1);
    for (mask = 0; mask < (1 << 8); ++mask) {
        if (func(root) == 0) {
            dis.push_back((1 << 8) - 1 - mask);
        }
    }
    vector <int> new_dis;
    vector <bool> deleted_(dis.size(), false);
    for (int i = 0; i < dis.size(); ++i) {
        if (deleted_[i]) {
            continue;
        }
        for (int j = i + 1; j < dis.size(); ++j) {
            if (deleted_[j]) {
                continue;
            }
            if ((dis[i] & dis[j]) == dis[i]) {
                deleted_[j] = true;
            } else if ((dis[i] & dis[j]) == dis[j]) {
                deleted_[i] = true;
            }
        }
    }
    for (int i = 0; i < deleted_.size(); ++i) {
        if (!deleted_[i]) {
            new_dis.push_back(dis[i]);
        }
    }
    dis = new_dis;
    //assert(dis.size() > 50);
    for (int i = 0; i < dis.size(); ++i) {
        for (int j = 0; j < N; ++j) {
            ans[i][j] = '-';
            if (j == 0 || j == N - 1) {
                ans[i][j] = '+';
            }
        }
    }
    for (int i = 0; i < dis.size(); ++i) {
        vector <int> cur_numb;
        for (int j = 0; j < 8; ++j) {
            if (dis[i] >> j & 1) {
                cur_numb.push_back('a' + j);
            }
        }
        for (int j = 0; j < cur_numb.size(); ++j) {
            ans[i][j + 1] = cur_numb[j];
        }
    }
    for (int i = 0; i < dis.size(); ++i) {
        for (int j = 0; j < N; ++j) {
            printf("%c", ans[i][j]);
        }
        printf("\n");
    }
    return 0;
}
