#include <cassert>
#include <utility>
#include <tuple>
#include <iostream>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cstring>

using namespace std;
typedef long long ll;

//#define int ll

#define sz(x) (int)x.size()
#define pb push_back
#define eb emplace_back
#define agn assign
#define DEBUG(x) cerr << #x << ": " << x << "\n";
#define F first
#define S second

#define BOUNDS_1(x, n) (x >= 0 && x < n)
#define BOUNDS_2(x, n) (x > 0 && x <= n)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<double, int> pdi;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int INF = 1000 * 1000 * 1000 + 10;
//const int M = 1000 * 1000 * 1000 + 7;
const ll INFLL = 1000ll * 1000 * 1000 * 1000 * 1000 * 1000;

typedef tuple<int, int, int> tiii;
typedef vector<tiii> vtiii;

const int N = 1e5 + 5;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n;
    double P;
    cin >> n >> P;

    vi c(n);
    for (int &t : c)
        cin >> t;

    int a = 0, b = 0;
    for (int i = 0; i < n; ++i) {
        ll Dsq = 0, Dsum = 0;
        for (int j = i + 1; j < n; ++j) {
            Dsq += (c[j] - c[j - 1]) * (c[j] - c[j - 1]);
            Dsum += (c[j] - c[j - 1]);

            if (j >= i + 2) {
                ll k = (j - i);
                ll An = (c[j] - c[i]);
                ll Dn3 = Dsq * k * k + k * An * An - 2 * An * k * Dsum;

//                ll Dn3_2 = 0;
//                for (int q = i + 1; q <= j; ++q) {
//                    ll f = (n * (c[q] - c[q - 1]) - An);
//                    ll h = k * (c[q] - c[q - 1]);
////                    Dn3_2 += f * f;
//                    Dn3_2 += - 2 * An * h;
//                }
//                Dn3_2 += k * k * Dsq + An * An * k;

                if (Dn3 == 0) {
                    if (An > 0)
                        ++a;
                    else if (An < 0)
                        ++b;
                } else {
                    if (An * sqrt(k) >= P * sqrt(Dn3) - 9e-9)
                        ++a;
                    else if (An * sqrt(k) <= -P * sqrt(Dn3) + 9e-9)
                        ++b;
                }
            }
        }

    }
    cout << a << " " << b << "\n";
}
