#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
using namespace std;

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	vector <int> q(n);
	for (int i = 0; i < n; ++i) {
		cin >> q[i];
	}
	sort(q.begin(), q.end());
	int max1 = q[0];
	for (int i = 1; i < q.size(); ++i) {
		if (max1 < q[i] - q[i - 1]) {
			max1 = q[i] - q[i - 1];
		}
	}
	for (int i = 2 ; i < q.size(); ++i) {
		if (max1 >= q[i] - q[i - 2]) {
			cout << 0 << endl;
			return 0;
		}
	}
	cout << max1 << endl;
	return 0;
}
