#include <bits/stdc++.h>
#define int unsigned long long

using namespace std;

int binominal[51][51];
int basic_m[51][51];
int symmetry_m[51][51];
int special_m[51][51];

signed main()
{
    for (int i = 0; i < 51; i++)
        for(int j = 0; j < 51; j++)
            binominal[i][j] = basic_m[i][j] = symmetry_m[51][51] = special_m[51][51] = 0;
    
    //precount binominal
    for (int i = 1; i < 51; i++)
        binominal[i][0] = binominal[i][i] = 1;
    for (int i = 2; i < 51; i++)
        for(int j = 1; j <= i; j++)
            binominal[i][j] = binominal[i - 1][j - 1] + binominal[i - 1][j];
    
    
    
    //count M(n, k)
    for(int i = 0; i < 51; i++)
        basic_m[i][0] = 1;

    for (int i = 0; i < 51; i++)
        for (int j = 1; j <= i; j++)
            basic_m[i][j] = basic_m[i][j - 1] + binominal[i][j]; 
    
    //count S(n, k)
    for(int i = 0; i < 51; i++)
        symmetry_m[i][0] = 1;

    for (int i = 1; i < 51; i++)
        if (i % 2 == 1)
        {
            symmetry_m[i][i] = symmetry_m[i - 1][i - 1] + 1;
            for (int j = 1; j < i; j++)
                symmetry_m[i][j] = symmetry_m[i - 1][j - 1] + symmetry_m[i - 1][j];
        }
        else //if (i % 2 == 0)
            for(int j = 0; j <= i; j++)
                symmetry_m[i][j] = basic_m[i / 2][j / 2];
    //special_m
    for (int i = 0; i < 50; i++)
        special_m[i][0] = 1; 
    for (int i = 1; i < 51; i++)
        for(int j = 1; j < 51; j++)
            special_m[i][j] = (basic_m[i][j] + symmetry_m[i][j]) / 2;
     
    int n, k;
    cin >> n >> k;
    //for (int i = 0; i <= n; i++)
    //{
    //    for (int j = 0; j <= i; j++)
    //    {
    //        cout << basic_m[i][j] << " ";
    //   }
    //    cout << endl;
    //} 
    if (k > n)
        k = 2*n - k;
    int ans = special_m[n][k];
    if (k == 0)
        ans = 2;
    else if (k % 2 == 0)
        ans += special_m[n][k / 2] - special_m[n][k / 2 - 1];
    cout << ans;
    return 0;
}
