#pragma GCC target("avx2")

#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
// gp_hash_table<int, int>
tree<int, null_type, greater<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

int n, w, h, s;
vector<pair<char, vector<vector<char>>>> a;
vector<vector<int>> b;

/*
3 4 5 16
I
.#..
#.#.
.#..
.#..
###.
C
.##.
#..#
#...
#..#
.##.
P
###.
#..#
###.
#...
#...

*/

void solve() {
    cin >> n >> w >> h >> s;
    a.resize(n);
    char x;

    for (int i = 0; i < n; ++i) {
        cin >> x;
        a[i].first = x;
        a[i].second = vector<vector<char>>(h, vector<char>(w));
        for (int j = 0; j < h; ++j) {
            for (int k = 0; k < w; ++k) {
                cin >> a[i].second[j][k];
            }
        }
    }

    b.resize(n, vector<int>(h));
    int max_char_ind = -1;
    int switches_in_a_row = 0;

    for (int i = 0; i < n; ++i) {
        for (int k = 0; k < h; ++k) {
            char last = '.';
            int res = 0;
            for (int j = w - 1; j >= 0; --j) {
                if (last == a[i].second[k][j]) {
                    continue;
                }
                res += 1;
                last = a[i].second[k][j];
            }
            if (last != '.') {
                res += 1;
            }
            b[i][k] = res;
            if (res > switches_in_a_row) {
                switches_in_a_row = res;
                max_char_ind = i;
            }
        }
    }

    while (s > 0) {
        s -= switches_in_a_row;
        /*for (int i = 0; i < h; ++i) {
            for (int j = 0; j < w; ++j) {
                cout << a[max_char_ind].second[i][j];
            }
            cout nl;
        }*/
        cout << a[max_char_ind].first;
    }
}
