import java.io.BufferedReader
import java.io.InputStream
import java.io.InputStreamReader
import java.util.*
import kotlin.collections.HashMap


private val hashMap = HashMap<Int, String>().apply {
    put(1995, "ITMO")
    put(1996, "SPbSU")
    put(1997, "SPbSU")
    put(1998, "ITMO")
    put(1999, "ITMO")
    put(2000, "SPbSU")
    put(2001, "ITMO")
    put(2002, "ITMO")
    put(2003, "ITMO")
    put(2004, "ITMO")
    put(2005, "ITMO")
    put(2006, "PetrSU, ITMO")
    put(2007, "SPbSU")
    put(2008, "SPbSU")
    put(2009, "ITMO")
    put(2010, "ITMO")
    put(2011, "ITMO")
    put(2012, "ITMO")
    put(2013, "SPbSU")
    put(2014, "ITMO")
    put(2015, "ITMO")
    put(2016, "ITMO")
    put(2017, "ITMO")
    put(2018, "SPbSU")
    put(2019, "ITMO")
}

fun main() {
    val scanner = FastReader(System.`in`)
    val year = scanner.nextInt()
    if(year >= 1995 || year <= 2019)
        println(hashMap[year])
}

internal class FastReader(input: InputStream?) {
    var br: BufferedReader
    var st: StringTokenizer? = null
    operator fun next(): String? {
        while (st == null || !st!!.hasMoreElements()) {
            st = try {
                StringTokenizer(br.readLine())
            } catch (e: Exception) {
                return null
            }
        }
        return st!!.nextToken()
    }

    fun nextInt(): Int {
        return next()!!.toInt()
    }

    fun nextLong(): Long {
        return next()!!.toLong()
    }

    init {
        br = BufferedReader(InputStreamReader(input))
    }
}