import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class M {
    public static void main(String[] args) throws FileNotFoundException {
        FastReader scanner = new FastReader(System.in);
        int n = scanner.nextInt();
        TreeSet<Integer> cards = new TreeSet<>();
        TreeSet<Integer> delta = new TreeSet<>();
        TreeSet<Integer> cardsCopy = new TreeSet<>();
        cards.add(0);
        cardsCopy.add(0);
        for (int i = 0; i < n; i++) {
            int temp = scanner.nextInt();
            cards.add(temp);
            cardsCopy.add(temp);
        }
        n++;
        for (int i = 0; i < n / 2; i++) {
            int first = cards.first();
            cards.remove(cards.first());
            int second = cards.first();
            cards.remove(cards.first());
            delta.add(second - first);
        }
        int maxDelta = delta.last();
        for (int i = 0; i < n / 3; i++) {
            int first = cardsCopy.first();
            cardsCopy.remove(cardsCopy.first());
            int second = cardsCopy.first();
            cardsCopy.remove(cardsCopy.first());
            int third = cardsCopy.first();
            cardsCopy.remove(cardsCopy.first());
            if (first + maxDelta >= third) {
                System.out.println(0);
                return;
            }
        }
        System.out.println(maxDelta);
    }

    static class FastReader {
        BufferedReader br;
        StringTokenizer st;

        FastReader(InputStream input) throws FileNotFoundException {
            br = new BufferedReader(new InputStreamReader(input));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (Exception e) {
                    return null;
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }
}
