import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class M {
    public static void main(String[] args) throws FileNotFoundException {
        FastReader scanner = new FastReader(System.in);
        int n = scanner.nextInt();
        TreeSet<Integer> cards = new TreeSet<>();
        TreeSet<Integer> cardsCopy = new TreeSet<>();
        cards.add(0);
        cardsCopy.add(0);
        for (int i = 0; i < n; i++) {
            int temp = scanner.nextInt();
            cards.add(temp);
            cardsCopy.add(temp);
        }
        int now = 0;
        int maxDelta = 0;
        while (!cards.isEmpty()) {
            if (cards.first() - now > maxDelta)
                maxDelta = cards.first() - now;
            now = cards.first();
            cards.remove(now);
        }
        while (!cardsCopy.isEmpty()) {
            now = cardsCopy.first();
            cardsCopy.remove(cardsCopy.first());
            if (cardsCopy.isEmpty())
                break;
            int second = cardsCopy.first();
            cardsCopy.remove(second);
            if (cardsCopy.isEmpty())
                break;
            int third = cardsCopy.first();
            cardsCopy.remove(third);
            if (cardsCopy.isEmpty())
                break;
            if (now + maxDelta >= third) {
                System.out.println(0);
                return;
            }
            cardsCopy.add(second);
            cardsCopy.add(third);
        }
        System.out.println(maxDelta);
    }

    static class FastReader {
        BufferedReader br;
        StringTokenizer st;

        FastReader(InputStream input) throws FileNotFoundException {
            br = new BufferedReader(new InputStreamReader(input));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (Exception e) {
                    return null;
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }
}

/*
10
1 4 7 10 13 16 19 22 24 25
 */