#include <iostream>
#include <vector>
#include <queue>
#include <iomanip>
#include <algorithm>

using namespace std;

const int MAXN = 100;
const int MAXW = 33;

bool a[MAXN][MAXW][MAXW];

char v[MAXN];
int cnt[MAXW][MAXW];

int main() {
#ifdef LOCAL
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
#endif
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, w, h, s;
    cin >> n >> w >> h >> s;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        for (int j = 0; j < h; ++j) {
            for (int k = 0; k < w; ++k) {
                char c;
                cin >> c;
                a[i][j][k] = c == '#';
            }
        }
    }
    int min_len = 1e9 + 7;
    int num_min = 0;
    for (int i = 0; i < h; ++i) {
        int mx = 0;
        int num = 0;
        for (int k = 0; k < n; ++k) {
            int ct = 0;
            bool cur = 0;
            for (int j = 0; j <= w; ++j) {
                if (cur != a[k][i][j]) {
                    cur ^= 1;
                    ct++;
                }
            }
            if (ct > mx) {
                mx = ct;
                num = k;
            }
        }
        if (mx == 0)
            continue;
        int len = s / mx + (s % mx != 0);
        if (len < min_len) {
            min_len = len;
            num_min = num;
        }
    }
    for (int i = 0; i < min_len; ++i)
        cout << v[num_min];
}
