#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

#ifdef ISDEBUG
#else
#define endl '\n'
#endif

void solve()
{
    int n;
    long double p;
    cin >> n >> p;
    vector<int> v_(n);
    for (int i = 0; i < n; ++i)
        cin >> v_[i];
    vector<long long> v(n - 1);
    for (int i = 0; i < n - 1; ++i)
        v[i] = v_[i + 1] - v_[i];
//    cout << "v itself: " << endl;
//    for (auto i : v)
//        cout << i << ' ';
//    cout << endl;
    vector<long long> pref1(n), pref2(n);
    for (int i = 1; i < pref1.size(); ++i) {
        pref1[i] = pref1[i - 1] + v[i - 1];
        pref2[i] = pref2[i - 1] + (long long)v[i - 1] * v[i - 1];
    }
//    cout << "pref1" << endl;
//    for (auto i : pref1)
//        cout << i << ' ';
//    cout << endl;
//    cout << "pref2" << endl;
//    for (auto i : pref2)
//        cout << i << ' ';
//    cout << endl;
    int cp = 0, cn = 0;
    cerr.precision(6);
    for (int i = 0; i < n; ++i)
        for (int j = i + 2; j < n; ++j) {
            int len = j - i;
            if (pref1[j] - pref1[i] != 0) {
                long double A = ((long double)pref1[j] - pref1[i]) / len;
//                cerr << "[" << i << ", " << j << "]" << endl;
//                cerr << "len = " << len << endl;
//                cerr << "A = " << A << endl;
                long double D = sqrt(((long double)pref2[j] - pref2[i] - 2 * A * (pref1[j] - pref1[i]) + len * A * A) / len);
//                cerr << "D = " << D << endl;
                if (fabs(D) < 1e-10) {
                    if (A > 0)
                    {
                        ++cp;
//                        cerr << "plus!" << endl;
                    }
                    else if (A < 0)
                    {
                        ++cn;
//                        cerr << "minus!" << endl;
                    }
                } else {
                    if (A /D>= p)
                    {
                        ++cp;
//                        cerr << "plus!" << endl;
                    }
                    else if (A/D <= p * (-1))
                    {
                        ++cn;
//                        cerr << "minus!" << endl;
                    }
//                    else cerr << "NONE" << endl;
                }
//                cerr << "----------" << endl;
            }
        }
    cout << cp << ' ' << cn << endl;
    exit(0);
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    solve();
    return 0;
}
