#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

#ifdef ISDEBUG
#else
#define endl '\n'
#endif

void solve()
{
    int n;
    cin >> n;
    cout << "? ";
    for (int i = 0; i < n - 1; ++i)
        cout << i + 2 << ' ';
    cout << 1 << endl;
    cout.flush();
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    cout << "? " << 1 << ' ';
    for (int i = 1; i < n-1; ++i)
        cout << i + 2 << ' ';
    cout << 2 << endl;
    cout.flush();
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
    }
    int fix = -1;
    for (int i = 0;i < n;++i)
    {
        if (b[i] == i)
        {
            fix = i;
            break;
        }
    }
    assert(fix != -1);
//    cerr << "fix = " << fix << endl;
    int now = fix;
    int cur = 0;
    vector<int> ans(n);
    do {
//        cerr << "cur now " << cur << ' ' << now << endl;
        ans[cur] = now;
        now = a[now];
        ++cur;
    } while (now != fix);
    cout << "! ";
    for (auto i:ans)
        cout << i+1 << ' ';
    cout << endl;
    cout.flush();
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t-- > 0)
        solve();
    return 0;
}
