#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <vector>
#include <queue>
#include <map>
#include <set>
using namespace std;

typedef long long ll;
typedef long double ld;

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    int n, w, h, s;
    cin >> n >> w >> h >> s;

    vector < vector <char> > state(h, vector <char> (w));

    int max_switches = 0;
    int letter_number = -1;

    vector <char> letter(n);

    for (int q = 0; q < n; ++q) {
        cin >> letter[q];

        for (int h1 = 0; h1 < h; ++h1) {
            for (int w1 = 0; w1 < w; ++w1) {
                cin >> state[h1][w1];
            }
        }

        int mx = 0;
        for (int row = 0; row < h; ++row) {
            bool prev = false;
            int sum = 0;

            for (int column = 0; column < w; ++column) {
                bool current = (state[row][column] == '#' ? true : false);
                if (current != prev) {
                    ++sum;
                }
                prev = current;
            }

            if (prev) {
                ++sum;
            }
            mx = max(mx, sum);
        }

        if (mx > max_switches) {
            max_switches = mx;
            letter_number = q;
        }
    }

    for (int i = 0; i < (s + max_switches - 1) / (max_switches); ++i) {
        cout << letter[letter_number];
    }

    return 0;
}
///..#....##..###...##..
///.#.#..#..#.#..#.#..#.
///..#...#....###..#....
///..#...#..#.#....#..#.
///.###...##..#.....##..
