#include <bits/stdc++.h>

/*
░░░░░░▄▀▒▒▒▒░░░░▒▒▒▒▒▒▒▒▒▒▒▒▒█
░░░░░█▒▒▒▒░░░░▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒█
░░░░█▒▒▄▀▀▀▀▀▄▄▒▒▒▒▒▒▒▒▒▄▄▀▀▀▀▀▀▄
░░▄▀▒▒▒▄█████▄▒█▒▒▒▒▒▒▒█▒▄█████▄▒█
░█▒▒▒▒▐██▄████▌▒█▒▒▒▒▒█▒▐██▄████▌▒█
▀▒▒▒▒▒▒▀█████▀▒▒█▒░▄▒▄█▒▒▀█████▀▒▒▒█
▒▒▐▒▒▒░░░░▒▒▒▒▒█▒░▒▒▀▒▒█▒▒▒▒▒▒▒▒▒▒▒▒█
▒▌▒▒▒░░░▒▒▒▒▒▄▀▒░▒▄█▄█▄▒▀▄▒▒▒▒▒▒▒▒▒▒▒▌
▒▌▒▒▒▒░▒▒▒▒▒▒▀▄▒▒█▌▌▌▌▌█▄▀▒▒▒▒▒▒▒▒▒▒▒▐
▒▐▒▒▒▒▒▒▒▒▒▒▒▒▒▌▒▒▀███▀▒▌▒▒▒▒▒▒▒▒▒▒▒▒▌
▀▀▄▒▒▒▒▒▒▒▒▒▒▒▌▒▒▒▒▒▒▒▒▒▐▒▒▒▒▒▒▒▒▒▒▒█
▀▄▒▀▄▒▒▒▒▒▒▒▒▐▒▒▒▒▒▒▒▒▒▄▄▄▄▒▒▒▒▒▒▄▄▀
▒▒▀▄▒▀▄▀▀▀▄▀▀▀▀▄▄▄▄▄▄▄▀░░░░▀▀▀▀▀▀
▒▒▒▒▀▄▐▒▒▒▒▒▒▒▒▒▒▒▒▒▐
*/

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pill = pair<int, ll>;

const int INF = 1e9 + 69;

void solve() {
    int n; double p;
    cin >> n >> p;

    vector<int> costs(n);
    for(int i = 0; i < n && cin >> costs[i]; ++i);

    int pos = 0, neg = 0;
    double d;
    for (int i = 0; i + 3 <= n; ++i) {
        d = 0;
        double a = (costs[i + 2] - costs[i]) / 2.0;
        for (int j = i + 1; j < i + 3; ++j) {
            double b = (costs[j] - costs[j - 1] - a);
            d += b * b;
        }

        if (d == 0.) {
            if (a > 0) { ++pos;}
            else if (a < 0) { ++neg; }
//            cout << a << endl;

        } else {
            double ds = sqrt(d / 2.0);
            double res = a / ds;

//            cout << res << endl;

            if (res >= p) { ++pos; }
            else if (res <= -p) { ++neg; }
        }

        for (int l = 4; i + l <= n; ++l) {
            auto dl = (double) l;
            double an = (double) (costs[i + l - 1] - costs[i]) / (dl - 1);
            double d1 = costs[i + l - 1] - costs[i + l - 2] - an;
            double diff = 2 * (costs[i + l - 2] - costs[i]) * (a - an) + (dl - 2) * (an * an - a * a) + d1 * d1;
            double dn = d + diff;

            if (dn == 0.) {
                if (an > 0) { ++pos;}
                else if (an < 0) { ++neg; }

//                cout << an << endl;

            } else {
                double ds = sqrt(dn / (dl - 1));
                double res = an / ds;

//                cout << res << endl;


                if (res >= p) { ++pos; }
                else if (res <= -p) { ++neg; }
            }

            d = dn;
            a = an;
        }
    }

    cout << pos << " " << neg;
}


signed main() {
#ifdef LOCAL
    const string FILENAME = "local";
    freopen((FILENAME + ".in").c_str(), "r", stdin);
    freopen((FILENAME + ".out").c_str(), "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}


