#include <iostream>
#include <cmath>
using namespace std;
int compare(const void* a, const void* b);
int main() {
    int size;
    cin >> size;
    if (size == 0) {
        cout << 0;
        return 0;
    }
    else if (size == 1) {
        long long card;
        cin >> card;
        cout << card;
        return 0;
    }
    long long* arr = new long long[size];
    for (int i = 0; i < size; i++) cin >> arr[i];
    qsort(arr, size, sizeof(long long), compare);
    long long min = arr[0];
    long long max;
    if (size >= 2) max = arr[1] - arr[0];
    if (max < min) {
        cout << 0;
        return 0;
    }
    else if (max == min) {
        for (int i = 1; i < size; i++) {
            if (arr[i] - arr[i - 1] > max) {
                cout << 0;
                return 0;
            }
        }
    }
    else {
        for (long long i = min; i <= max; i++) {
            bool result_ok = true;
            for (int j = 1; j < size; j++) {
                if (arr[j] - arr[j - 1] > i) {
                    result_ok = false;
                    break;
                }
            }
            if (result_ok) {
                cout << i;
                return 0;
            }
        }
        cout << 0;
    }
    return 0;
}

int compare(const void* a, const void* b) {
    long long x = *(long long*)a;
    long long y = *(long long*)b;
    if (x < y) return -1;
    else if (x == y) return 0;
    else if (x > y) return 1;
}