
#include <bits/stdc++.h>
#include <istream>

#define forn(n) for (int i = 0; i < n; i++)
#define fori(b, n, i) for (int i = b; i < n; i++)
#define forrange(b, e) for (int i = b; i < e; i++)
#define f first
#define s second
#define print_d(a) std::cout<<std::setprecision(15)<<a
#define pii pair<int,int>

template<typename T, typename K> std::istream& operator>> (std::istream &stream, std::pair<T,  K> &pair){
    stream >> pair.first >> pair.second;
    return stream;
}

template<typename T, typename K> std::ostream& operator<< (std::ostream &stream, std::pair<T,  K> &pair){
    stream << '(' << pair.first << ' ' << pair.second << ')';
    return stream;
}

template<typename T> void pr_vec(std::vector<T> &a, std::ostream &stream = std::cerr){
    for (T e: a){
        stream<< e<< ' ';
    }
}

template<typename T> void r_vec(std::vector<T> &a, std::istream &stream = std::cin){
    for (T &e: a){
        stream>>e;
    }
}

template<typename T> void debug(T &e, std::string label = "D"){
    std::cerr<<"["<<label<<"] "<<e<<std::endl;
}

typedef long long ll;
typedef long double ld;

using namespace std;

int run(){
    int n;
    cin>>n;
    vector<int> a(n+1, 0);
    forn(n){
        int b;
        cin>>b;
        a[i+1] = b;
    }
    sort(a.begin(), a.end());
    int max_d = a[2], min_d = a[1];
    for(int i = 1; i <=n-2; i++){
        int rasn = a[i+1] - a[i], double_rasn = a[i+2] - a[i];
        if (rasn >= max_d){
            cout<<0;
            return 1;
        }
        if (double_rasn < min_d){
            cout<<0;
            return 1;
        }
        if (rasn == double_rasn){
            cout<<0;
            return 1;
        }
        min_d = max(min_d, rasn);
        max_d = min(double_rasn, max_d);
    }
    if (a[n] - a[n-1] >= max_d){
        cout<<0;
        return 1;
    }
    min_d = max(min_d, a[n] - a[n-1]);
    if (min_d >= max_d){
        cout<<0;
        return 1;
    }
    cout<<min_d;
    return 1;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin>>t;
    
    forn(t){
        int b = run();
        if (b == 0) return 0;
    }
    return 0;
}
