#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <map>
using namespace std;
struct bukva{
    vector<string> table;
    char key;
    int sw = 0;
    bukva(int size){
        cin>>key;
        table= vector<string>(size);
        for(int i = 0;i<size; i++){
            cin>>table[i];
        }
        sw = switches();
    }
    bool operator<(bukva& other){
        return sw>other.sw;
    }
    int switches(){
        int ans = 0;
        for(int i = 0; i< table.size(); i++){
            char last = '.';
            int locans = 0;
            for(int j = 0;j< table[i].size();j++){
                if(table[i][j] != last){
                    locans++;
                }
                last = table[i][j];
            }
            if(last !='.'){
                locans++;
            }
            ans = max(ans, locans);
        }
        return ans;
    }


};
int main() {
    int n, w, h, s;
    cin>>n>>w>>h>>s;
    //bukva test = bukva(h);
    vector<bukva> pismo;
    for(int i = 0;i< n;i++){
        pismo.push_back(h);
    }
    sort(pismo.begin(), pismo.end());
    int k = pismo[0].sw;
    for(int i = 0; i< (s+k-1)/k; i++){
        cout<<pismo[0].key;
    }
    return 0;
}