#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <map>
#include<unordered_map>
#include<cmath>
using namespace std;
unordered_map<int, vector<pair<int, int>>> gr;
vector<pair<int, int>> unsuccess;
vector<int> all;
vector<int> path;
vector<bool> used;
unordered_map<int, int> deg;
void findEuler(int v){
    if(gr.find(v) ==gr.end()){
        return;
    }
    for(auto e: gr[v]){
        if(!used[e.second-1]){
            used[e.second-1] = true;
            path.push_back(e.second);
            findEuler(e.first);
        }
    }
}
int main() {
    int n, start;
    cin>>n>>start;
    for(int i = 0;i< n;i++){
        int f, t, w;
        cin>>f>>t>>w;
        used.push_back(false);
        all.push_back(f);
        deg[f]=0;
        deg[t] = 0;
        if(w == 1){
            if(gr.find(f) == gr.end()){
                gr[f] = {};
            }
            gr[f].push_back({t, i+1});
        }else{
            unsuccess.push_back({f, i+1});
        }
    }
    int check = 0;
    for(auto i:gr){
        for(auto u: i.second){
            deg[u.first]++;
        }
    }
    int tmp1 = 0, tmp2 = 0;
    for(auto i: deg){
        if(i.second != gr[i.first].size()){
            check++;
            if(abs(i.second - static_cast<int>(gr[i.first].size())) != 1){
                cout<<"No";
                return 0;
            }else{
                tmp1+=i.second - static_cast<int>(gr[i.first].size());
            }
        }
    }
    if((check != 0 && check != 2) || tmp1 != 0){
        cout<<"No";
        return 0;
    }
    findEuler(start);
    vector<int> ans;

    for(int i = 0;i< unsuccess.size();i++){
        if(unsuccess[i].first != start){
            ans.push_back(unsuccess[i].second);
        }
    }
    bool inserted = false;
    for(int i = 0;i< path.size();i++){
        if(all[path[i]-1] != start && !inserted){
            inserted = true;
            for(int i = 0;i< unsuccess.size();i++){
                if(unsuccess[i].first == start){
                    ans.push_back(unsuccess[i].second);
                }
            }
        }
        ans.push_back(path[i]);
    }
    cout<<"Yes"<<endl;
    for(int i = 0;i< n;i++){
        cout<<ans[i]<<" ";
    }
    return 0;
}