#include <cstdio>
#include <cassert>
#include <vector>
#include <iostream>
#include <algorithm>
#include <queue>
#include <set>
#include <unordered_map>
#include <cmath>

#define all(a) a.begin(), a.end()
#define beg() begin()
#define srt(a) sort(all(a))
#define ll long long
#define ld double
#define f first
#define s second
#define io cin.sync_with_stdio(false);cout.sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define EPS 1e-9
#define point pair<ll, ll>

using namespace std;

int main() {
    io;
    int n, w, h, s;
    cin >> n >> w >> h >> s;
    vector<char> c(n);
    vector<vector<vector<bool>>> bb(n, vector<vector<bool>>(h, vector<bool>(w)));
    vector<vector<int>> hy(n, vector<int> (h));
    for(int i = 0; i < n; i++) {
        cin >> c[i];
        for(int u = 0; u < h; u++) {
            for(int j = 0; j < w; j++) {
                char cc;
                cin >> cc;
                if(cc == '#')
                    bb[i][u][j] = true;
            }
        }
    }
    vector<char> ans;
    for(int gg = 0; gg < h; gg++) {
        for(int i = 0; i < n; i++) {
            for(int j = 1; j < w; j++) {
                if(bb[i][gg][j] != bb[i][gg][j - 1]) {
                    hy[i][gg]++;
                }
            }
        }
        vector<vector<int>> dp(2);
        vector<vector<pair<int, int>>> p(2);
        dp[0].push_back(0);
        dp[1].push_back(-1e9);
        p[0].push_back({-1, -1});
        p[1].push_back({-1, -1});
        while(true) {
            dp[0].push_back(-1e9);
            dp[1].push_back(-1e9);
            p[0].push_back({-1, -1});
            p[1].push_back({-1, -1});
            for(int i = 0; i < n; i++) {
                dp[bb[i][gg].back()].back() = max(dp[bb[i][gg].back()].back(), dp[!bb[i][gg].front()][dp[0].size() - 2] + hy[i][gg] + 1);
                if(dp[bb[i][gg].back()].back() == dp[!bb[i][gg].front()][dp[0].size() - 2] + hy[i][gg] + 1) {
                    p[bb[i][gg].back()].back() = {!bb[i][gg].front(), i};
                }
                dp[bb[i][gg].back()].back() = max(dp[bb[i][gg].back()].back(), dp[bb[i][gg].front()][dp[0].size() - 2] + hy[i][gg]);
                if(dp[bb[i][gg].back()].back() == dp[bb[i][gg].front()][dp[0].size() - 2] + hy[i][gg]) {
                    p[bb[i][gg].back()].back() = {bb[i][gg].front(), i};
                }
            }
            if(!ans.empty() && ans.size() < dp.size())
                break;
            if(dp[0].back() <= 0 && dp[1].back() <= 0) {
                goto flag;
            }
            if(dp[0].back() >= s) {
                break;
            }
            if(dp[1].back() >= s) {
                break;
            }
        }
        if(ans.empty() || ans.size() > dp[0].size() - 1) {
            int curp, curi = dp[0].size() - 1;
            if(dp[0].back() > dp[1].back()) {
                curp = 0;
            } else {
                curp = 1;
            }
            vector<char> new_ans;
            while(curi > 0) {
                new_ans.push_back(c[p[curp][curi].s]);
                curp = p[curp][curi].f;
                curi--;
            }
            swap(ans, new_ans);
        }
        flag:;
    }
    reverse(all(ans));
    for(auto cc: ans)
        cout << cc;
}