#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <cmath>
#include <iomanip>
#include <map>
#include <stack>
#include <set>
#include <queue>
#include <unordered_map>
#include <stdio.h>
#include <memory.h>
#include <bitset>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(a) (a)*(a)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const ll mod = 998244353;
const int inf = 1e9;
const ll biginf = 1e18;
const ld pi = acosl(-1);
const ld eps = 1e-9;
const int maxn = 1e5+1;
const ll negativeInf = -1e18;

void solve() {
	int n;
	cin >> n;
	vector<int> v(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	v[n] = 0;
	sort(all(v));
	int maxd = 0;
	for (int i = 1; i <= n; i++) {
		maxd = max(maxd, v[i] - v[i - 1]);
	}
	for (int i = 2; i <= n; i++) {
		if (v[i] - v[i - 2] <= maxd) {
			cout << 0 << "\n";
			return;
		}
	}
	cout << maxd << "\n";
}

void multisolve(){
	int t;
	cin >> t;
	while(t--){
		solve();
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed;
	solve();
}