//#pragma GCC optimize("Ofast")
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <stack>
          
// continue push_back setprecision __builtin_popcount
          
using namespace std;
          
typedef long long ll;
typedef unsigned long long ull;
          
mt19937 rnd(228);
          
const double EPS = 1e-7;
const double PI = acos(-1);
          
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define size(a) (int)a.size()
#define f first
#define s second    
          
void solve();
          
signed main()
{
    #ifdef HOME
        freopen("home.in", "r", stdin);
        freopen("home.out", "w", stdout);
    #else
        // freopen("censored.in", "r", stdin);
        // freopen("censored.out", "w", stdout);
    #endif
    ios_base::sync_with_stdio(false);
    #ifdef HOME
        clock_t start = clock();
    #endif
          
    solve();    
              
    #ifdef HOME
        cout << "\n\n\nTIME: " << float(clock() - start) / CLOCKS_PER_SEC << endl;
        // system("pause");
    #endif
              
    exit(0);
}

void solve() 
{
	int n, c;
	cin >> n >> c;
	c--;

	vector<int> wc, wnc;
	map<int, vector<pair<int, int>>> g;
	vector<int> pos(n, 0);
	vector<int> cnt(n, 0);
	for (int i = 0; i < n; i++) {
		int a, b, w;
		cin >> a >> b >> w;
		a--, b--;
		if (w == 0) {
			if (a == c) {
				wc.push_back(i + 1);
			} else {
				wnc.push_back(i + 1);
			}
		} else {
			g[a].push_back({b, i + 1});
			cnt[a]++;
			cnt[b]--;
		}
	}

	bool ok = true;
	int p1 = 0, p2 = 0, start;
	for (int i = 0; i < n; i++) {
		if (cnt[i] != 0) {
			if (cnt[i] == 1) {
				p1++;
				start = i;
			} else if (cnt[i] == -1) {
				p2++;
			} else {
				ok = false;
			}
		}
	}

	ok = (ok & ((p1 == 0 && p2 == 0) || (p1 == 1 && p2 == 1 && start == c)));

	if (!ok) {
		cout << "No";
		return;
	}

	vector<int> ans, ans1;
	while (!wnc.empty()) {
		ans.push_back(wnc.back());
		wnc.pop_back();
	}

	stack<pair<int, int>> st;
	st.push({c, -1});

	while (!st.empty()) {
		int v = st.top().f;

		if (v != c) {
			while (!wc.empty()) {
				ans1.push_back(wc.back());
				wc.pop_back();
			}
		}

		if (size(g[v]) == pos[v]) {
			if (st.top().s != -1) {
				ans1.push_back(st.top().s);
			}
			st.pop();
		} else {
			st.push(g[v][pos[v]++]);
		}
	}

	reverse(all(ans1));

	if (size(ans) + size(ans1) != n) {
		cout << "No";
		return;
	}

	cout << "Yes\n";

	for (int i : ans) {
		cout << i << ' ';
	}

	for (int i : ans1) {
		cout << i << ' ';
	}
}