#include <iostream>
#include <set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <cassert>

#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define fileio freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout)
#define pll pair<ll, ll>
#define pii pair<int, int>
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;
typedef long double ld;
const ll mod = 1e9;
const ll inf = 1e17;

int rem = 0;

string q(int i, int j) {
    cout << i + 1 << ' ' << j + 1 << endl;
    string s;
    --rem;
    cin >> s;
    return s;
}

bool win(string &s) {
    return s == "WIN";
}

bool swapped(string &s) {
    return s == "SWAPPED";
}

int main() {
    int n;
    cin >> n;
    string s;
    for (int k = 0; k < n; ++k) {
        rem = n;
        for (int i = 1; i < k; ++i) {
            s = q(i - 1, i);
            if (win(s)) {
                return 0;
            }
            if (swapped(s)) {
                for (int j = i + 1; j < k; ++j) {
                    s = q(i - 1, j);
                    if (win(s)) {
                        return 0;
                    }
                    if (swapped(s)) {
                        s = q(i, j);
                        if (win(s)) {
                            return 0;
                        }
                        break;
                    }
                }
                for (int j = k; j < n; ++j) {
                    s = q(i, j);
                    if (win(s)) {
                        return 0;
                    }
                    if (swapped(s)) {
                        s = q(i - 1, i);
                        if (win(s)) {
                            return 0;
                        }
                        break;
                    }
                }
                break;
            }
        }
        while (rem) {
            s = q(0, 1);
            if (win(s)) {
                return 0;
            }
        }
        rem = n;
        for (int i = k + 1; i < n; ++i) {
            s = q(k, i);
            if (win(s)) {
                return 0;
            }
        }
        while (rem) {
            s = q(0, 1);
            if (win(s)) {
                return 0;
            }
        }
    }
    rem = n;
    for (int i = 1; i < n; ++i) {
        s = q(i - 1, i);
        if (win(s)) {
            return 0;
        }
        if (swapped(s)) {
            for (int j = i + 1; j < n; ++j) {
                s = q(i - 1, j);
                if (win(s)) {
                    return 0;
                }
                if (swapped(s)) {
                    s = q(i, j);
                    if (win(s)) {
                        return 0;
                    }
                    break;
                }
            }
            for (int j = n; j < n; ++j) {
                s = q(i, j);
                if (win(s)) {
                    return 0;
                }
                if (swapped(s)) {
                    s = q(i - 1, i);
                    if (win(s)) {
                        return 0;
                    }
                    break;
                }
            }
            break;
        }
    }
}
