#include <iostream>
#include <set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <cassert>

#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define fileio freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout)
#define pll pair<ll, ll>
#define pii pair<int, int>
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;
typedef long double ld;
const ll mod = 1e9;
const ll inf = 1e17;

int rem = 0;
int n;
string s;

string q(int i, int j) {
    cout << i + 1 << ' ' << j + 1 << endl;
    --rem;
    cin >> s;
    return s;
}

bool win() {
    return s == "WIN";
}

bool swapped() {
    return s == "SWAPPED";
}

bool check_line(int k) {
    rem = n;
    for (int i = k + 1; i < n; ++i) {
        s = q(k, i);
        if (win()) {
            return true;
        }
    }
    return false;
}

bool do_rem() {
    while (rem) {
        s = q(0, 1);
        if (win()) {
            return true;
        }
    }
    return false;
}

int main() {
    cin >> n;
    if (check_line(0)) {
        return 0;
    }
    if (do_rem()) {
        return 0;
    }
    if (check_line(1)) {
        return 0;
    }
    if (do_rem()) {
        return 0;
    }
    for (int k = 2; k < n; ++k) {
        rem = n;
        for (int i = 1; i < k; ++i) {
            s = q(i - 1, i);
            if (win()) {
                return 0;
            }
            bool skip = false;
            if (swapped()) {
                skip = true;
                for (int j = i + 1; j < k; ++j) {
                    s = q(i - 1, j);
                    if (win()) {
                        return 0;
                    }
                    if (swapped()) {
                        s = q(i, j);
                        if (win()) {
                            return 0;
                        }
                        break;
                    }
                }
                bool flag = false;
                for (int j = k; j < n; ++j) {
                    s = q(i, j);
                    if (win()) {
                        return 0;
                    }
                    if (swapped()) {
                        flag = true;
                    }
                }
                if (flag) {
                    s = q(i - 1, i);
                    if (win()) {
                        return 0;
                    }
                }
            }
            if (do_rem()) {
                return 0;
            }
            if (skip) {
                break;
            }
        }
        if (check_line(k)) {
            return 0;
        }
        if (do_rem()) {
            return 0;
        }
    }
    rem = n;
    for (int i = 1; i < n; ++i) {
        s = q(i - 1, i);
        if (win()) {
            return 0;
        }
        if (swapped()) {
            for (int j = i + 1; j < n; ++j) {
                s = q(i - 1, j);
                if (win()) {
                    return 0;
                }
                if (swapped()) {
                    s = q(i, j);
                    if (win()) {
                        return 0;
                    }
                    break;
                }
            }
            for (int j = n; j < n; ++j) {
                s = q(i, j);
                if (win()) {
                    return 0;
                }
                if (swapped()) {
                    s = q(i - 1, i);
                    if (win()) {
                        return 0;
                    }
                    break;
                }
            }
            break;
        }
    }
}
