#include <iostream>
#include <set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>

#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define fileio freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout)
#define pll pair<ll, ll>
#define pii pair<int, int>
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;
typedef long double ld;
const ll mod = 1e9;
const ll inf = 1e17;

int main() {
   int n;
   ld P;
   cin >> n >> P;
   vector<ll> c(n);
   for (int i = 0; i < n; ++i) {
       cin >> c[i];
   }
   vector<ll> prefsq(n, 0);
   for (int i = 1; i < n; ++i) {
       prefsq[i] = prefsq[i - 1] + (c[i] - c[i - 1]) * (c[i] - c[i - 1]);
   }
   ll pos = 0, neg = 0;
   for (int i = 0; i < n; ++i) {
       for (int len = 2; i + len < n; ++len) {
           int j = i + len;
           ld A = (ld) (c[j] - c[i]) / len;
           ll nom = prefsq[j] - prefsq[i];
           nom -= 2 * (c[j] - c[i]) * A;
           nom += A * A * len;
           if (A > 0 && nom == 0) {
               ++pos;
           } else if (A < 0 && nom == 0) {
               ++neg;
           } else if (A != 0 && A * sqrtl(len) >= P * sqrtl(nom)) {
               ++pos;
           } else if (A != 0 && A * sqrtl(len) <= - P * sqrtl(nom)) {
               ++neg;
           }
       }
   }
   cout << pos << ' ' << neg;
}
