#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <set>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

#define printvi(arr) for (int x : arr) cout << x << ' '; cout << '\n';
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)

const int N = 256;

int calc(int mask, string s);

int calc1(int mask, vector<string> spl) {
    if (spl.empty()) return 0;
    if (spl.size() == 1) {
        if (spl[0][0] == '(') return calc(mask, spl[0].substr(1, spl[0].length() - 2));
        return min(1, mask & (1 << (7 - spl[0][0] + 'a')));
    }
    forn(i, spl.size()) {
        if (spl[i] == "or") {
            vector<string> spl1, spl2;
            forn(j, spl.size()) {
                if (j < i) spl1.push_back(spl[j]);
                if (j > i) spl2.push_back(spl[j]);
            }
            return calc1(mask, spl1) | calc1(mask, spl2);
        }
    }
    forn(i, spl.size()) {
        if (spl[i] == "and") {
            vector<string> spl1, spl2;
            forn(j, spl.size()) {
                if (j < i) spl1.push_back(spl[j]);
                if (j > i) spl2.push_back(spl[j]);
            }
            return calc1(mask, spl1) & calc1(mask, spl2);
        }
    }
    forn(i, spl.size()) {
        if (spl[i] == "not") {
            vector<string> spl1, spl2;
            forn(j, spl.size()) {
                if (j < i) spl1.push_back(spl[j]);
                if (j > i) spl2.push_back(spl[j]);
            }
            return 1 - calc1(mask, spl2);
        }
    }
    return 0;
}

int calc(int mask, string s) {
    s += " ";
    int br = 0;
    string curr;
    vector<string> spl;
    for (int i = 0; i < s.length(); ++i) {
        if (s[i] == '(') br++;
        if (s[i] == ')') br--;
        if (br > 0 || s[i] != ' ') {
            curr += s[i];
        } else {
            if (curr.length() > 0) {
                spl.push_back(curr);
                curr = "";
            }
        }
    }
    stack<int> st;
    return calc1(mask, spl);
}

int main() {
    string s;
    set<char> C;
    getline(cin, s);
    for (char c : s) C.insert(c);
    vi f(N);
    forn(i, N) f[i] = calc(i, s);
    forn(i, N) {
        forn(j, 8) {
            if ((i & (1 << j)) && f[i] == 0 && f[i ^ (1 << j)] == 1) {
                cout << "Impossible\n";
                return 0;
            }
        }
    }
    vb used(N);
    vector<string> ans(20);
    forn(i, 20) {
        forn(j, 50) ans[i] += ' ';
    }
    ans[0][0] = ans[0][49] = '+';
    ans[0][1] = '-';
    int I = 2;
    forn(i, N) {
        if (f[i] == 0) continue;
        bool flag = true;
        forn(j, N) {
            if ((j & i) == j && used[j]) {
                flag = false;
                break;
            }
        }
        if (flag) {
            used[i] = 1;
            if (i == 0) continue;
            int z = 0;
            vi K;
            forn(k, 8) {
                if ((i & (1 << (7 - k))) == 0) continue;
                K.push_back(k);
            }
            forn(j, K.size()) {
                char c = 'a' + K[j];
                ans[z][I] = ans[z][I + 2] = '+';
                ans[z++][I + 1] = c;
                if (j + 1 < K.size()) {
                    ans[z][I] = ans[z][I + 2] = '|';
                    z++;
                }
            }
            I += 2;
        }
    }
    if (I == 2) I = 1;
    for (int i = I + 1; i <= 48; ++i) ans[0][i] = '-';
    for (string s : ans) cout << s << '\n';
}