#include <iostream>
#include <fstream>
#include <algorithm>
#include <iomanip>
#include <random>
#include <ctime>
#include <bitset>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <stack>
#include <vector>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define ld long double
#define ull unsigned long long
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define pll pair<ll, ll>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fast_io cout.tie(0), cin.tie(0), ios_base::sync_with_stdio(0)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("Ofast")
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
ld eps = (ld)1 / 1e6;
ll inf = 1e18, mod1 = 1e9 + 7, mod2 = 998244353;
ll sqr(ll a) { return a * a; }
ll qb(ll a) { return a * a * a; }
ll gcd(ll a, ll b) { return !a ? b : gcd(b % a, a); }
ll binpow(ll a, ll b, ll mod) { return b ? (b % 2 ? (a * (sqr(binpow(a, b / 2, mod)) % mod)) % mod : sqr(binpow(a, b / 2, mod)) % mod) : 1; }
ll binmult(ll a, ll b, ll mod) { return b ? (b % 2 ? (2 * binmult(a, b / 2, mod) + a) % mod : (2 * binmult(a, b / 2, mod)) % mod) : 0; }
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ll C[51][51], P[51][51], K[51][51];

int main()
{
    fast_io;
    ll i, j, n, k, answer = 0;
    cin >> n >> k;
    C[0][0] = 1;
    for (i = 1; i <= 50; i++)
        for (j = 0; j <= i; j++)
            C[j][i] = C[j][i - 1] + C[j - 1][i - 1];
    P[0][1] = P[1][1] = 1;
    for (i = 2; i <= 50; i++)
    {
        for (j = 0; j <= i; j++)
        {
            if (j % 2 == 0)
            {
                if (i % 2 == 0) P[j][i] = C[j / 2][i / 2];
                else P[j][i] = P[j][i - 1];
            } 
            else
            {
                if (i % 2 == 0) P[j][i] = 0;
                else P[j][i] = P[j - 1][i - 1];
            }
        }
    }
    for (i = 0; i <= 50; i++)
        for (j = 0; j <= 50; j++)
            K[i][j] = (C[i][j] + P[i][j]) / 2;
    for (i = 0; i <= min(n, k); i++)
    {
        if (k - i > n) continue;
        answer += K[i][n];
    }
    if (k % 2 == 0) answer += K[k / 2][n];
    cout << answer;
    return 0;
}