#include <bits/stdc++.h>
 
#include <iostream>
 
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define ef emplace_back
#define x first
#define y second
#define sz(x) (int)x.size()
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define FOR(i, a, b) for (int i = (a); i < (b); i++)
#define RFOR(i, b, a) for (int i = (b)-1; i >= (a); i--)
 
using namespace std;
 
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ld, ld> pld;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;
 
const int INF_I = 1e9;
const ll INF_LL = 1e18;
const int MOD = 1000000007;
const double eps = 1e-6;
//(clock() * 1.0 / CLOCKS_PER_SEC)
 
unordered_map<int, list<pi>> a, b;
unordered_set<int> used;
unordered_set<int> se;
unordered_map<int, int> M_count;
list<int> res;
 
void dfs1(int v) {
  if (M_count.find(v) != M_count.end()) return;
  M_count[v] = 0;
  for (pi to : a[v]) {
    dfs1(to.x);
    M_count[v]++;
    M_count[to.x]--;
  }
}
 
void dfs2(int v, int index) {
  for (auto to = a[v].begin(); to != a[v].end(); ){
    if (used.find(to->y) != used.end()) continue;
    used.emplace(to->y);
    pi cur = *to;
    to = a[v].erase(to);
    dfs2(cur.x, cur.y);
    
  }
  if (se.find(v) != se.end()) {
    if (index != -1) res.emplace_back(index);
    return;
  }
  se.emplace(v);
  for (auto it1 = b.begin(); it1 != b.end();) {
    auto cur = it1;
    if (cur->x == v) {
      it1++;
      continue;
    }
    for (auto it = cur->y.begin(); it != cur->y.end(); it++)
      res.emplace_back(it->y);
    it1 = b.erase(it1);
  }
  if (index != -1) res.emplace_back(index);
}
 
void solve() {
  int n, c;
  cin >> n >> c;
  for (int i = 0; i < n; i++) {
    int f, t, w;
    cin >> f >> t >> w;
    if (w == 0)
      b[f].emplace_back(t, i + 1);
    else {
      a[f].emplace_back(t, i + 1);
    }
  }
  dfs1(c);
  int count1 = 0;
  vector<int> errors;
  for (pi cur : M_count)
    if (cur.y != 0) {
      errors.emplace_back(cur.y);
    }
  if (sz(errors) > 2) {
    cout << "No\n";
    return;
  }
  sort(all(errors));
  if (sz(errors) == 0 ||
 
      sz(errors) == 2 && errors[0] == -1 && errors[1] == 1)
    true;
  else {
    cout << "No\n";
    return;
  }
  for (auto cur : a) {
    if (M_count.find(cur.x) == M_count.end()) {
      cout << "No\n";
      return;
    }
    for (pi to : cur.y)
      if (M_count.find(to.x) == M_count.end()) {
        cout << "No\n";
        return;
      }
  }
  dfs2(c, -1);
  if (sz(b) != 0) {
    cout << "No\n";
    return;
  }
  cout << "Yes\n";
  for (auto it = res.rbegin(); it != res.rend(); it++) cout << *it << ' ';
}
 
int main() {
  // freopen("garland.in", "r", stdin);
  // freopen("garland.out", "w", stdout);
  // freopen("input.txt", "r", stdin);
  // freopen("output.txt", "w", stdout);
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
 
  int t = 1;
  while (t--) solve();
 
  return 0;
}