// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define rALL(s) (s).rbegin(), (s).rend()
#define sz(s) (s).size()
#define sqr(s) ((s) * (s))
#define pos(x) (2 * (x))
#define neg(x) (2 * (x) + 1)

using ll = long long;
using namespace std;

int main() {
	ios::sync_with_stdio(false); cin.tie(0);
	// cout.precision(9); cout << fixed;
#ifdef EUGENE
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
#else
	// freopen("nfc.in", "r", stdin);
	// freopen("nfc.out", "w", stdout);
#endif

	uint64_t n, k;
	cin >> n >> k;
	k = min(k, 2 * n - k);

	vector<vector<uint64_t>> c(n + 1, vector<uint64_t>(n + 1));
	c[0][0] = 1;
	for (size_t i = 1; i <= n; i++) {
		for (size_t j = 0; j <= n; j++) {
			c[i][j] = c[i - 1][j];
			if (j > 0)
				c[i][j] += c[i - 1][j - 1];
		}
	}

	auto cnt = [&](uint64_t a, uint64_t b) -> uint64_t {
		return c[a][b];
	};

	auto sym = [&](uint64_t a, uint64_t b) -> uint64_t {
		if (a % 2 == 0) {
			if (b % 2 != 0)
				return 0;
			return cnt(a / 2, b / 2);
		}
		return cnt(a / 2, b / 2);
	};

	uint64_t ans = 0;
	for (size_t i = 0; i <= k; i++) {  // i blacks
		ans += cnt(n, i) + sym(n, i);
	}
	if (k % 2 == 0) {
		ans += cnt(n, k / 2) + sym(n, k / 2);
	}
	ans /= 2;

	cout << ans << endl;
}
