#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

const double eps = 1e-9;

void solve() {
    int d;
    double p;
    cin >> d >> p;

    vector<int> c(d);
    for (int i = 0; i < d; i++) cin >> c[i];

    ll pos = 0;
    ll neg = 0;

    for (int i = 0; i < d; i++) {
        ll sd = 0;
        ll s2d = 0;
        for (int j = i + 1; j < d; j++) {
            ll cur = c[j] - c[j - 1];
            sd += cur;
            s2d += cur * cur;

            if (j - i >= 2 && c[i] != c[j]) {
                int len = j - i;
                double A = sd * 1.0 / len;

                if (abs(A * A * (j - i) + s2d - 2.0 * sd * A) < eps) {
                    pos += (c[j] > c[i]);
                    neg += (c[j] < c[i]);
                } else {
                    double D = sqrt((A * A * (j - i) + s2d - 2.0 * sd * A) / len);
                    if (A > 0 && A / D >= p - eps) {
                        pos++;
                    }
                    if (A < 0 && A / D <= -p + eps) {
                        neg++;
                    }
                }
            }
        }
    }
    cout << pos << " " << neg;
}
