#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
#ifdef SIR
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

double prob(vector<int> &s) {
    int m = s.size();
    double p = 1;
    double res = 0;
    int c = 0;
    for (int i = 0; i < m; i++) {
        if (s[i] == 1) {
            res += p;
            break;
        }
        if (s[i] == 0) {
            double t = 1.0 / (c + 2);
            res += t * p;
            p *= 1 - t;
            c++;
        }
        p *= 0.5; // win
    }
    return 1 - res;
}

vector<set<int>> vertex;
vector<map<int, int> > preorder;

void solve() {
    int k, n;
    cin >> k >> n;
    vertex.resize(k);
    vertex[k - 1].insert(0);
    preorder.resize(k);
    double res = 0;
    for (int i = 0; i < n; i++) {
        int s, m;
        cin >> s >> m;
        s--, m--;
        preorder[s][m] = i;
        for (int j = s; j < k; j++) {
            vertex[j].insert(m);
            m /= 2;
        }
    }


    for (int i = 0; i < k; i++) {
        for (int v : vertex[i]) {
            vector<int> s;
            int V = v;
            for (int j = i; j < k; j++) {
                s.push_back(preorder[j].count(v));
                if (preorder[i].count(V) && preorder[j].count(v) && preorder[i][V] < preorder[j][v]) {
                    s.back() = -1;
                }
                v /= 2;
            }
            v = V;
            {
                auto w = s;
                w.erase(w.begin());
                for (auto &qq : w) {
                    if (qq == 0) {
                        qq = -1;
                    }
                }
                double p = prob(w);
                res += p;
            }
            for (auto &qq : s) {
                if (qq == -1) qq = 1;
            }
            if (i > 0) {
                for (int u : {v * 2, v * 2 + 1}) {
                    if (!vertex[i - 1].count(u)) {
                        auto w = s;
                        for (int h = 0; h < i; h++) {
                            double p = prob(w);
                            double cnt = pow(2.0, h);
                            res += p * cnt;
                            w.insert(w.begin(), 0);
                        }
                    }
                }
            }
        }
    }

    cout.precision(20);
    cout << fixed << res;
}
