import java.util.Scanner;

public class TaskD {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        final int n = sc.nextInt();
        final int w = sc.nextInt();
        final int h = sc.nextInt();
        final int s = sc.nextInt();

        char BEST = ' ';
        int BEST_SWITCHES = 0;

        for (int i = 0; i < n; i++) {
            char curLetter = sc.next().charAt(0);
            int maxLine = 0;
            for (int j = 0; j < h; j++) {
                String line = sc.next();
                int switches = 0;
                char state = '.';
                for (int k = 0; k < w; k++) {
                    if (line.charAt(k) != state) {
                        switches++;
                        state = line.charAt(k);
                    }
                }
                if (line.charAt(w-1) != '.') {
                    switches++;
                }
                if (switches > maxLine) {
                    maxLine = switches;
                }
            }

            if (maxLine > BEST_SWITCHES) {
                BEST_SWITCHES = maxLine;
                BEST = curLetter;
            }
        }
        for (int i = 0; i < s/BEST_SWITCHES; i++) {
            System.out.print(BEST);
        }
    }
}
