import java.math.BigInteger;
import java.util.Scanner;

public class TaskN {
    private static BigInteger[] factorials;

    private static void computeFactor(int max) {
        factorials = new BigInteger[max + 1];
        factorials[0] = BigInteger.ONE;
        for (int i = 1; i <= max; i++) {
            factorials[i] = factorials[i - 1].multiply(BigInteger.valueOf(i));
        }
    }

    private static BigInteger combinations(int n, int k) {
        return factorials[n].divide(factorials[k]).divide(factorials[n-k]);
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        final int n = sc.nextInt();
        final int k = sc.nextInt();
        computeFactor(n);

        /*BigInteger ans = combinations(n, k/2).;

        for (int ks = k/2-1; ks >= 0; ks--) {
            BigInteger pali;
            if (n % 2 == 0) {
                if (k % 2 == 0) {
                    pali = combinations(n / 2, ks / 2);
                } else {
                    pali = BigInteger.ZERO;
                }
            } else {
                pali = combinations(n / 2, ks / 2);
            }
            BigInteger cur = combinations(n, ks).divide(BigInteger.TWO).add(pali);
            ans = ans.add(cur);
        }
        for (int ks = k/2+1; ks <= k; ks++) {
            BigInteger pali;
            if (n % 2 == 0) {
                if (k % 2 == 0) {
                    pali = combinations(n / 2, ks / 2);
                } else {
                    pali = BigInteger.ZERO;
                }
            } else {
                pali = combinations(n / 2, ks / 2);
            }
            BigInteger cur = combinations(n, ks).divide(BigInteger.TWO).add(pali);
            ans = ans.add(cur);
        }*/

        BigInteger ans = BigInteger.ZERO;

        for (int ks = Math.max(0, k-n); ks <= Math.min(n, k); ks++) {
            BigInteger pali;

            if (n % 2 == 0 && ks % 2 == 1) {
                pali = BigInteger.ZERO;
            } else {
                pali = combinations(n / 2, ks / 2);
            }

            BigInteger cur;
            if (ks * 2 != k) {
                cur = combinations(n, ks).subtract(pali).divide(BigInteger.TWO).add(pali);
            } else {
                cur = combinations(n, ks).add(pali);
            }
            ans = ans.add(cur);
        }


        System.out.println(ans);
    }
}
