#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
int const INF = 1e9 + 7;
ll const LLINF = 1e18 + 7;
ld const eps = 1e-8;
int const mod = 998244353;

typedef double fptype;

template <typename T>
T my_fmax(T a, T b) {
    assert(false);
}

template <>
float my_fmax(float a, float b) {
    return fmaxf(a, b);
}

template <>
double my_fmax(double a, double b) {
    return fmax(a, b);
}

template <>
ld my_fmax(ld a, ld b) {
    return fmaxl(a, b);
}

template <typename T>
T my_fmin(T a, T b) {
    assert(false);
}

template <>
float my_fmin(float a, float b) {
    return fminf(a, b);
}

template <>
double my_fmin(double a, double b) {
    return fmin(a, b);
}

template <>
ld my_fmin(ld a, ld b) {
    return fminl(a, b);
}

template <typename T>
T my_fabs(T a) {
    assert(false);
}

template <>
float my_fabs(float a) {
    return fabsf(a);
}

template <>
double my_fabs(double a) {
    return fabs(a);
}

template <>
ld my_fabs(ld a) {
    return fabsl(a);
}

int calcd(const vector <vector <int>>& a, const vector <vector <int>>& b, int w, int h) {
    int res = 0;
   for (int p = 0; p < w * h; p++) {
        int cur = 0;
        int myx = p / w;
        int myw = p % w;
        int curx = a[myx][myw];
        for (int i = myx + 1; i < h; i++) {
            cur += (curx ^ a[i][myw]);
            curx ^= a[i][myw];
        }
        for (int i = 0; i <= myx; i++) {
            cur += (curx ^ b[i][myw]);
            curx ^= b[i][myw];
        }
        res = max(res, cur);
    }
   return res;
}

vector <char> sy;
vector <vector <vector <int>>> show;
int n, w, h, s;

string get(int p, int q, int s) {
    vector <vector <int>> emp(h, vector <int>(w, 0));
    s -= calcd(emp, show[p], w, h);
    int d1 = calcd(show[p], show[q], w, h);
    int d2 = calcd(show[q], show[p], w, h);
    string str; str += sy[p];
    int i = 1;
    while(s > 0) {
        if (i % 2 == 1) {
            str += sy[q];
            s -= d1;
        } else {
            str += sy[p];
            s -= d2;
        }
        i++;
    }
    return str;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin >> n >> w >> h >> s;
    show.resize(n);
    sy.assign(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> sy[i];
        show[i].assign(h, vector <int>(w, 0));
        for (int j = 0; j < h; j++) {
            for (int k = 0; k < w; k++) {
                char x;
                cin >> x;
                show[i][j][k] = (x == '#');
            }
        }
    }
    vector <vector <int>> dist(n, vector<int>(n, 0));
    string text = get(0, 0, s);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (text.size() > get(i, j, s).size()) {
                text = get(i, j, s);
            }
        }
    }
    cout << text;
    return 0;
}