#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
int const INF = 1e9 + 7;
ll const LLINF = 1e18 + 7;
ld const eps = 1e-8;
int const mod = 998244353;

typedef double fptype;

template <typename T>
T my_fmax(T a, T b) {
    assert(false);
}

template <>
float my_fmax(float a, float b) {
    return fmaxf(a, b);
}

template <>
double my_fmax(double a, double b) {
    return fmax(a, b);
}

template <>
ld my_fmax(ld a, ld b) {
    return fmaxl(a, b);
}

template <typename T>
T my_fmin(T a, T b) {
    assert(false);
}

template <>
float my_fmin(float a, float b) {
    return fminf(a, b);
}

template <>
double my_fmin(double a, double b) {
    return fmin(a, b);
}

template <>
ld my_fmin(ld a, ld b) {
    return fminl(a, b);
}

template <typename T>
T my_fabs(T a) {
    assert(false);
}

template <>
float my_fabs(float a) {
    return fabsf(a);
}

template <>
double my_fabs(double a) {
    return fabs(a);
}

template <>
ld my_fabs(ld a) {
    return fabsl(a);
}

int calcd(const vector <vector <int>>& a, const vector <vector <int>>& b, int w, int h) {
    int res = 0;
   for (int p = 0; p < w * h; p++) {
        int cur = 0;
        int myx = p / w;
        int myw = p % w;
        int curx = a[myx][myw];
        for (int i = myx + 1; i < h; i++) {
            cur += (curx ^ a[i][myw]);
            curx ^= a[i][myw];
        }
        for (int i = 0; i <= myx; i++) {
            cur += (curx ^ b[i][myw]);
            curx ^= b[i][myw];
        }
        res = max(res, cur);
    }
   return res;
}

vector <char> sy;
vector <vector <vector <int>>> show;
int n, w, h, s;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin >> n >> w >> h >> s;
    show.resize(n);
    sy.assign(n, 0);
    int res = -1;
    int id = -1;
    for (int i = 0; i < n; i++) {
        cin >> sy[i];
        show[i].assign(h, vector <int>(w, 0));
        for (int j = 0; j < h; j++) {
            for (int k = 0; k < w; k++) {
                char x;
                cin >> x;
                show[i][j][k] = (x == '#');
            }
        }

        int tmp = 0;
        for (int j = 0; j < h; j++) {
            int cur = 0;
            int curx = show[i][j][0];
            for (int k = 1; k < w; k++) {
                cur += (curx ^ show[i][j][k]);
                curx ^= show[i][j][k];
            }
            cur += (curx);
            tmp = max(tmp, cur);
        }
        if (res < tmp) {
            res = tmp;
            id = i;
        }
    }
    while (s > 0) {
        s -= res;
        cout << sy[id];
    }
    return 0;
}