
#include <bits/stdc++.h>

using namespace std;

const double EPS = 1e-9;

int main() {
    ios_base::sync_with_stdio(false);
    int n;
    double P;
    cin >> n >> P;
    vector<int> v(n);

    for (auto&x : v) {
        cin >> x;
    }

    int ans_pos = 0;
    int ans_neg = 0;

    for (int i = 0; i + 2 < n; i++) {
        int64_t sum = 0;
        int64_t sum_squares = 0;
        for (int j = i + 1; j < n; j++) {
            sum += v[j] - v[j - 1];
            sum_squares += (v[j] - v[j - 1]) * (v[j] - v[j - 1]);

            int count = j - i + 1;

            if (count >= 3) {
                count -= 1;
                double mean = double(sum) / count;
                double standard = sqrt(1. / count * (sum_squares - 2 * sum * mean + mean * mean * count));

                if (abs(mean) > EPS) {
                    if (abs(standard) < EPS) {
                        if (mean < 0) {
                            ans_neg++;
                        } else {
                            ans_pos++;
                        }
                    } else {
                        double ratio = mean / standard;
                        if (ratio + EPS > P) {
                            ans_pos += 1;
                        }
                        if (ratio - EPS < -P) {
                            ans_neg += 1;
                        }
                    }
                }
                
            }
        }
    }
    cout << ans_pos << ' ' << ans_neg << endl;
}