import math


def combinations(n, k):
    return math.factorial(n) // math.factorial(k) // math.factorial(n - k)


def f(n, k):
    if n % 2 == 0 and k % 2 == 1:
        return combinations(n, k)
    return combinations(n, k) + combinations(n // 2, k // 2)





def main():
    n, k = map(int, input().split())

    k = min (k, 2 * n - k)

    ans = 0
    for t in range(k // 2 + 1):
        left = t
        right = k - t

        if left == right:
            ans += f(n, left)
        else:
            ans += f(n, left) // 2 + f(n, right) // 2
    print(ans)
main()