﻿#include <iostream>
#include <random>
#include <vector>
#include <optional>
#include <cassert>
#include <cmath>
#include <cstddef>
#include <memory>
#include <thread>
#include <algorithm>

typedef long long ll;
typedef long double ld;
using namespace std;

int cnt = 0;
int cnt_all = 0;

int query(int pos_i, int pos_j) {
    ++cnt;
    ++cnt_all;
    if (cnt_all > 9900) {
        exit(1);
    }
    cout << pos_i << " " << pos_j << endl;
    string ans;
    cin >> ans;
    if (ans == "SWAPPED") {
        return 0;
    } else if (ans == "STAYED") {
        return 1;
    } else {
        exit(0);
    }
}

void solver(int n) {
    cnt = 0;
    cnt_all = 0;

    for (int i = 2; i <= n; ++i) {
        for (int j = i - 1; j >= 1; --j) {

            if (query(j, j + 1) == 1) {
                break;
            }
        }
        while (true) {
            if (cnt > 2 * n) {
                exit(1);
            }
            while (cnt < 2 * n) {
                query(1, 2);
            }
            cnt = 0;
            int sw1 = -1;
            int sw2 = -1;
            for (int j = 1; j < i; ++j) {
                if (query(j, j + 1) == 0) {
                    if (sw1 == -1) {
                        sw1 = j + 1;
                        break;
                    }
                }
            }

            if (sw1 != -1) {
                for (int j = i - 1; j >= 1; j--) {
                    if (query(j, j + 1)) {
                        sw2 = j;
                        break;
                    }
                }
            }

            if (sw2 != -1) {
                query(sw1, sw2);
                break;
            } else if (sw1 == -1) {
                break;
            } else {
                for (int j = sw1; j < i; ++j) {
                    if (query(j, j + 1) == 1) {
                        break;
                    }
                }
                for (int j = sw1 - 1; j >= 1; --j) {
                    if (query(j, j + 1) == 1) {
                        break;
                    }
                }
            }
        }
    }
}


int main() {
    int n;
    cin >> n;
    solver(n);
    return 0;
}
