﻿#include <iostream>
#include <stdio.h>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <functional>
#include <complex>
#include <assert.h>
#include <chrono>
#pragma comment(linker, "/STACK:256000000")
using namespace std;

#define in(s) freopen(s, "r", stdin)
#define out(s) freopen(s, "w", stdout)
#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

typedef long long ll;
typedef double ld;

struct edge {
	int a, b, t;
};

vector < vector< pair<int, int> > > g;
vector <int> ans;
vector <bool> marked;

void dfs(int v) {
	while (!g[v].empty()) {
		int to = g[v].back().first;
		int num = g[v].back().second;
		g[v].pop_back();
		dfs(to);
		ans.push_back(num);
		marked[num] = true;
	}
}

int main()
{
	//in("input.txt");
	//out("output.txt");
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(1373737);

	int n, cs;
	cin >> n >> cs;

	vector <edge> arr(n);
	vector <int> have(2 * n);
	forn(i, n) {
		cin >> arr[i].a >> arr[i].b >> arr[i].t;
		have[2 * i] = arr[i].a;
		have[2 * i + 1] = arr[i].b;
	}
	have.push_back(cs);

	sort(have.begin(), have.end());
	have.resize(unique(have.begin(), have.end()) - have.begin());

	forn(i, n) {
		arr[i].a = lower_bound(have.begin(), have.end(), arr[i].a) - have.begin();
		arr[i].b = lower_bound(have.begin(), have.end(), arr[i].b) - have.begin();
	}
	cs = lower_bound(have.begin(), have.end(), cs) - have.begin();

	g.resize(have.size());
	marked.resize(n);

	vector <int> din(have.size());
	vector <int> dout(have.size());

	vector <int> bad;

	forn(i, n) {
		if (arr[i].t == 1) {
			g[arr[i].a].push_back(mp(arr[i].b, i));
			dout[arr[i].a]++;
			din[arr[i].b]++;
		}
		else {
			bad.push_back(i);
		}
	}

	int cnt0 = 0, cntp = 0, cntn = 0;
	forn(i, (int)g.size()) {
		if (i == cs || (din[i] == 0 && dout[i] == 0))
			continue;
		if (abs(din[i] - dout[i]) > 1) {
			cout << "No";
			return 0;
		}
		if (din[i] == dout[i])
			cnt0++;
		if (din[i] - dout[i] == -1)
			cntn++;
		if (din[i] - dout[i] == 1)
			cntp++;
	}

	if (din[cs] == dout[cs]) {
		if (cnt0 > 0) {
			cout << "No";
			return 0;
		}
	}
	else {
		if (din[cs] - dout[cs] == -1 && (cntn != 0 || cntp != 1)) {
			cout << "No";
			return 0;
		}
		if (din[cs] - dout[cs] == 1 && (cntn != 1 || cntp != 0)) {
			cout << "No";
			return 0;
		}
	}

	dfs(cs);

	for (int i = 0; i < n; i++) {
		if (arr[i].t == 1 && !marked[i]) {
			cout << "No";
			return 0;
		}
	}

	vector <int> res;
	int cur = cs;

	reverse(ans.begin(), ans.end());
	for (int i = 0; i < (int)bad.size(); i++) {
		if (arr[bad[i]].a != cs) {
			res.push_back(bad[i]);
			marked[bad[i]] = true;
		}
	}
	bool flag = true;
	for (int i = 0; i < (int)ans.size(); i++) {
		res.push_back(ans[i]);
		cur = arr[ans[i]].b;
		if (cur != cs && flag) {
			for (int j = 0; j < (int)bad.size(); j++) {
				if (arr[bad[j]].a == cs) {
					res.push_back(bad[j]);
					marked[bad[j]] = true;
				}
			}
			flag = false;
		}
	}

	for (int i = 0; i < n; i++) {
		if (!marked[i]) {
			cout << "No";
			return 0;
		}
	}

	if ((int)res.size() != n)
		throw 38;

	cout << "Yes\n";
	forn(i, (int)res.size())
		cout << res[i] + 1 << ' ';

	return 0;
}