#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

using ll = long long int;
using ld = long double;

int main() {
    ll n;
    ld p;
    cin >> n >> p;
    vector<ll> c(n);
    for (ll i = 0; i < n; i++) {
        cin >> c[i];
    }

    vector<vector<ld>> sq_cost_change(n, vector<ld>(n, 0));
    vector<vector<ld>> deviat(n, vector<ld>(n, 0));

    for (ll i = 0; i + 2 < n; i++) {
        ld a = c[i + 1] - c[i];
        ld sqa = a * a;
        sq_cost_change[i][i + 1] = sqa;

        for (ll j = i + 2; j < n; j++) {
            a += c[j] - c[j - 1];
            sqa += (c[j] - c[j - 1]) * (c[j] - c[j - 1]);
            sq_cost_change[i][j] = sqa;
        }
    }

    ll pos = 0, neg = 0;

    for (ll i = 0; i + 2 < n; i++) {
        for (ll j = i + 2; j < n; j++) {
            ld cc = (c[j] - c[i]);
            ld a = cc / (j - i);
            //cout << sq_cost_change[i][j] << '\n';
            deviat[i][j] = sq_cost_change[i][j] - 2 * a * cc + (j - i) * a * a;
            // cout << deviat[i][j] << '\n';
            deviat[i][j] = sqrtl(deviat[i][j]/(j - i));

            // cout << i << ' ' << j << ": " << sq_cost_change[i][j] << ' ' << a << ' ' << deviat[i][j] << '\n';
            if (a == 0) continue;

            if (deviat[i][j] == 0) {
                if (a > 0) pos++;
                else neg++;
                continue;
            }

            ld coef = a / deviat[i][j];
            if (coef >= p) pos++;
            if (coef <= -p) neg++;
        }
    }
    cout << pos << ' ' << neg;
}
