#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <limits>
#include <ctime>
#include <cassert>
#include <map>
#include <set>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <fstream>
#include <sstream>
#include <stack>
#include <queue>
#include <numeric>
#include <iterator>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
 
using namespace std;
 
#define sz(c) ((int)c.size())
#define pb push_back
#define pf push_front
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

#define x first
#define y second
 
typedef long double ld;
typedef long long ll;
typedef pair <int, int> pii;
 
const int N = int(1e6) + 111;
const int INF = int(1e9) + 111;
const ll LINF = ll(1e18) + 111;
const ld EPS = 1e-7;
const ld PI = 3.141592653589793238462643;
const ll MOD = ll(1e9) + 7;
const int M = int(1e6) + 111;
const int P = int(1e6) + 3;
 
template<class T> void chmin(T& a, const T& b) { if (a > b) a = b; }
template<class T> void chmax(T& a, const T& b) { if (a < b) a = b; }
 
template<class T> T gcd(T a, T b) { return b ? gcd(b, a % b) : a; }
template<class T> T lcm(T a, T b) { return a / gcd(a, b) * b; }
template<class T> T abs(T a) { return a >= 0 ? a : -a; }
 
// @author: MeowMr

int n, w, h, s;
bool a[40][40][100];
int d[100][100][40][40];
int st[40][40][100];
int used[100];
int cnt[100];
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
	cin >> n >> w >> h >> s;
	for (int it = 0; it < n; it++) {
		char c;
		cin >> c;
		used[int(c) - 33] = 1;
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				char x;
				cin >> x;
				if (x == '#') {
					a[i][j][int(c) - 33] = 1;				
				}
			}
		}        
	}
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			for (int k1 = 0; k1 < 100; k1++) {
				bool state = false;
				for (int j2 = 0; j2 <= j; j2++) {
					if (a[i][j2][k1] != state) {
						state = !state;
						st[i][j][k1]++;
					}
				}
			}
		}
	}                             
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			for (int k1 = 0; k1 < 100; k1++) {
				for (int k2 = 0; k2 < 100; k2++) {
					if (!used[k1] || !used[k2]) continue;
					bool state = a[i][j][k1];
					for (int j2 = j + 1; j2 < w; j2++) {
						if (a[i][j2][k1] != state) {
							state = !state;
							d[i][j][k1][k2]++;
	                    }
                    }
                    if (state) {
						d[i][j][k1][k2]++;                    	
                    }
                    state = false;
                    d[i][j][k1][k2] += st[i][j][k2];
                    //for (int j2 = 0; j2 < w; j2++) {
                   // 	if (a[i][j2][k2] != state) {
                   // 		state = !state;
                   // 		d[i][j][k1][k2]++;
                   // 	}
                    //}
				}
			}
		}
	}
	int ans = INF;
	int l, r;
	for (int k1 = 0; k1 < 100; k1++) {
		for (int k2 = 0; k2 < 100; k2++) {
			for (int i = 0; i < h; i++) {
				for (int j = 0; j < w; j++) {
					if (used[k1] && used[k2]) {
						if (st[i][j][k1] >= s) {
							ans = 1;
							l = k1;
							r = k2;
							continue;
						}
						int cur = (s - st[i][j][k1]) / (d[i][j][k1][k2] + d[i][j][k2][k1]);
						int ct = st[i][j][k1] + cur * (d[i][j][k1][k2] + d[i][j][k2][k1]);
						cur = 2 * cur + 1;
						if (ct + a[i][j][k1] >= s) {
							if (cur < ans) {
								ans = cur;
								cout << "KEK";
								l = k1;
								r = k2;
							}	
							continue;
						}
						if (ct < s) {
							cur++;
						}
						if (cur < ans) {
							ans = cur;
							l = k1;
							r = k2;
						}
					}
				}
			}
		}
	}                                  

	for (int i = 0; i < ans; i++) {
		if (i % 2 == 0) {
			cout << char(l + 33);
		} else {
			cout << char(r + 33);
		}
	}
	return 0;
}