#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;


double eps = 1e-7;

bool is_integer(double x) {
    return fabs(x - (int)x) < eps;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int s;
    cin >> s;

    double len = sqrt(s);

    for (int ax = -s; ax <= s; ax++) {
        double ay_d = sqrt(s - ax * ax);
        if (!is_integer(ay_d)) {
            continue;
        }

        int ay = (int) ay_d;

        int by = -ax;
        int bx = ay;


        int cx = ax + bx;
        int cy = ay + by;

        cout << ax << " " << ay << "\n";
        cout << "0 0\n";
        cout << bx << " " << by << "\n";
        cout << cx << " " << cy << "\n";
        return 0;
    }

    cout << "Impossible\n";
    return 0;
}
