#include <iostream>
#include <cmath>

using namespace std;

typedef long long ll;

ll sqr(ll a) {
    return a * a;
}

const long double EPS = 1e-9;

int main() {
    ll n;
    long double p;
    cin >> n >> p;
    ll c[n];
    ll d[n];
    d[0] = 0;
    for (ll i = 0; i < n; ++i)
    {
        cin >> c[i];
    }

    for (ll i = 1; i < n; ++i) {
        d[i] = d[i - 1] + sqr(c[i] - c[i - 1]);
    }

    ll cnt1 = 0, cnt2 = 0;
    for (ll l = 0; l < n; ++l) {
        for (ll r = l + 2; r < n; ++r) {
            long double sz = r - l;
            long double A = (c[r] - c[l]) / sz;
            long double D = d[r] - d[l] - A * A * sz;
            D /= sz;
            D = sqrt(D);
            if (c[r] == c[l]) continue;
            if (abs(D) < EPS && c[r] > c[l])
            {
                cnt1++;
                continue;
            }
            if (abs(D) < EPS && c[r] < c[l])
            {
                cnt2++;
                continue;
            }
            long double tmp = A / D;
            if (tmp >= p) {
                cnt1++;
            }
            if (tmp <= -p) {
                cnt2++;
            }
        }
    }
    cout << cnt1 << ' ' << cnt2;
    return 0;
}
