#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define len(x) int(x.size())

typedef long long ll;
namespace std {
    template<>
    struct hash<std::pair<int, int>> {
        inline size_t operator()(const std::pair<int, int>& v) const {
            std::hash<int> int_hasher;
            return int_hasher(v.first) ^ int_hasher(v.second);
        }
    };
}

const int N = 3010;
const double EPS = 1e-9;

ll c[N], x[N];

int main() {
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#endif  // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    double p;
    cin >> n >> p;
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        if (i + 1 < n) {
            x[i] = c[i + 1] - c[i];
        }
    }
    int pos = 0, neg = 0;
    int m = n - 1;  // ((x_i) ^ 2 - 2x_i * a_r + (a_r)^2)
    /*for (int i = 0; i < m; i++) {
        cout << x[i] << ' ';
    }
    cout << "\n";*/
    // cout.precision(9);
    // cout << std::fixed;
    for (int l = 0; l < m - 1; l++) {
        ll seg_sum = x[l];
        ll x_sum = x[l] * x[l];
        for (int r = l + 1; r < m; r++) {
            double len = r - l + 1;
            seg_sum += x[r];
            x_sum += x[r] * x[r];
            double a_sum = 1.0 * seg_sum * seg_sum / len;
            // double xa_sum = -2.0 * seg_sum * seg_sum / len;
            double cur_sum = (x_sum - a_sum) / len;
            double D = sqrt(cur_sum);
            double A = 1.0 * seg_sum / len;
            double dp = D * p;
            if (fabs(A) <= EPS && fabs(D) <= EPS) {
                continue;
            }
            if (fabs(D) <= EPS && A >= -EPS) {
                pos++;
                continue;
            }
            if (fabs(D) <= EPS && A <= +EPS) {
                neg++;
                continue;
            }
            if (A >= dp + EPS) {
                pos++;
            } else if (A <= -dp + EPS) {
                neg++;
            }

            //  cout << A << ' ' << D << "\n";
        }
    }
    cout << pos << ' ' << neg;
    return 0;
}