#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define len(x) int(x.size())

typedef long long ll;
namespace std {
    template<>
    struct hash<std::pair<int, int>> {
        inline size_t operator()(const std::pair<int, int>& v) const {
            std::hash<int> int_hasher;
            return int_hasher(v.first) ^ int_hasher(v.second);
        }
    };
}

const ll N = 100;

ll C[N][N];

int main() {
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#endif  // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    C[0][0] = 1;
    C[0][1] = 0;
    C[1][0] = 1;
    C[1][1] = 1;
    for (int i = 1; i <= 50; i++) {
        C[i][0] = 1;
        C[i][i] = 1;
        //  cout << C[i][0] << ' ';
        for (int j = 1; j <= 50; j++) {
            C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
            //  cout << C[i][j] << ' ';
        }
        //  cout << "\n";
    }

    int n, k;
    cin >> n >> k;

    ll ans = 0;
    for (int i = 0; i <= k; i++) {
        ll not_otrazilo = 0;
        if (n % 2 == 0) {
            if (i % 2 == 0) {
                // .#..#.
                not_otrazilo = C[n / 2][i / 2];
            }
        } else {
            if (i % 2 == 0) {
                // .#...#.
                not_otrazilo = C[(n - 1) / 2][i / 2];
            } else if (i % 2 == 1) {
                // .#.#.#.
                not_otrazilo = C[(n - 1) / 2][(i - 1) / 2];
            }
        }
        ll cur_count = (C[n][i] - not_otrazilo) / 2 + not_otrazilo;
        // cout << not_otrazilo << ' ' << cur_count << "\n";
        if (2 * i == k) {
            ans += cur_count;
        }
        ans += cur_count;
    }
    cout << ans;
    return 0;
}