#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <iterator>
#include <iomanip>
#include <map>
#include <stack>
#include <cctype>
#include <queue>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mp(a, b) make_pair(a, b)
#define pb(a) push_back(a)

typedef long long ll;
typedef pair<int, int> pii;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;

	int iter = 1;
	int sorted_suff = 0;
	string s;

	while (true) {
		for (int i = 0; i < n - 1 - sorted_suff; ++i) {
			cout << n - 1 - sorted_suff + 1 << " " << i + 1 << endl;
			if (i != n - 2 - sorted_suff) {
				cin >> s;
				if (s == "WIN") {
					return 0;
				}
			}
		}

		if (sorted_suff >= 2) {
			bool foundFirst = false;
			int fir = -1, sec = -1;
			for(int i = n - 1; i >= max(1, n - sorted_suff); --i) {
				int u = i - 1;
				int v = i;
				cout << u + 1 << " " << v + 1 << endl;
				cin >> s;
				if (s == "WIN") {
					return 0;
				}
				if (s == "SWAPPED") {
					if (!foundFirst) {
						fir = u;
						sec = v;
						foundFirst = true;
					} else {
						cout << v + 1 << " " << fir + 1 << endl;
						cin >> s;
						if (s == "WIN") {
							return 0;
						}
						cout << u + 1 << " " << v + 1 << endl;
						cin >> s;
						if (s == "WIN") {
							return 0;
						}
						cout << fir + 1 << " " << sec + 1 << endl;
						cin >> s;
						if (s == "WIN") {
							return 0;
						}
					}
				}
			}
		}

		++sorted_suff;



		cin >> s;
		if (s == "WIN") {
			return 0;
		}
	}

	return 0;
}