#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <iterator>
#include <iomanip>
#include <map>
#include <stack>
#include <cctype>
#include <queue>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define pb(a) push_back(a)

typedef long long ll;
typedef pair<int, int> pii;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;

	vector<int> a(n);
	forn(i, n) {
		cin >> a[i];
	}
	sort(all(a));
	int d = 0;
	forn(i, n - 1) {
		d = max(d, a[i + 1] - a[i]);
	}

	forn(i, n - 2) {
		if (a[i + 2] - a[i] < d) d = 0;
	}

	cout << d;
	return 0;
}
