//
// Created by tycoon on 14.11.2020.
//
#include <bits/stdc++.h>

using namespace std;

vector<vector<int64_t> > choose_val;

int64_t choose(int64_t n, int64_t k) {
    if (n < k || k < 0) {
        return 0;
    }
    if (k > (n - k)) {
        k = n - k;
    }
    return choose_val[n][k];
}

int64_t calc(int64_t a, int64_t n) {
    int64_t sim, asim, all;
    if (n % 2 == 0) {
        if (a % 2 == 0) {
            sim = choose(n / 2, a / 2);
        } else {
            sim = 0;
        }
    } else {
        if (a % 2 == 0) {
            sim = choose((n - 1) / 2, a / 2);
        } else {
            sim = choose((n - 1) / 2, (a - 1) / 2);
        }
    }
    all = choose(n, a);
    asim = (all - sim) / 2;
    return sim + asim;
}

int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    int64_t n, k;
    cin >> n >> k;

    choose_val.resize(60, vector<int64_t>(60, 0));

    choose_val[0][0] = 1;
    choose_val[1][0] = 1;
    choose_val[1][1] = 1;
    for (size_t i = 2; i < 60; ++i) {
        choose_val[i][0] = 1;
        choose_val[i][i] = 1;
        for (size_t j = 1; j < i; ++j) {
            choose_val[i][j] = choose_val[i-1][j-1] + choose_val[i-1][j];
        }
    }

    int64_t ans = 0;
    for (int64_t a = 0; a * 2 <= k; ++a) {
        int64_t b = k - a;
        if (a > n || b > n) {
            continue;
        }
        ans += calc(a, n) + calc(b, n);
    }

    cout << ans << '\n';

    return 0;
}
