#include <bits/stdc++.h>

using namespace std;
#ifdef MIA
    #define __int128 long long
    #define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
    #define err(...) 42
#endif
typedef long long ll;
typedef long double ld;

#define multitest false

void solve();

int main() {
#ifdef MIA
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    if (multitest) cin >> t;
    for (int it = 1; it <= t; ++it) solve();
    return 0;
}

// CONSTANTS HERE

vector<ll> getP(const vector<int>& d) {
    vector<ll> p(d.size() + 1, 0);
    for (int i = 0; i < (int)d.size(); ++i) {
        p[i + 1] = p[i] + d[i];
    }
    return p;
}

ll sum(const vector<ll>& p, int i, int j) {
    return p[j] - p[i];
}

ld eps = 1e-9;

void solve() {
    int n; cin >> n;
    ld P; cin >> P;
    vector<int> a(n);
    for (int& i : a) cin >> i;
    vector<int> diff(n - 1);
    for (int i = 1; i < n; ++i) diff[i - 1] = a[i] - a[i - 1];
    vector<int> diff2(n - 1);
    for (int i = 0; i < n - 1; ++i) diff2[i] = diff[i] * diff[i];

    vector<ll> pDiff = getP(diff), pDiff2 = getP(diff2);
    int cntP = 0, cntN = 0;
    cout.precision(5);
    for (int i = 0; i <= n - 3; ++i) {
        for (int j = i + 3; j <= n; ++j) {
            ld A = sum(pDiff, i, j - 1) * (ld)1 / (j - i - 1);
            ld D = (A * A * (j - i - 1) + sum(pDiff2, i, j - 1) - 2 * A * sum(pDiff, i, j - 1)) / (j - i - 1);
//            cout << fixed << i << " " << j << " " << A << " " << D << " " << A / sqrt(D) << "\n";
            if ((abs(D) < eps && A > eps) || A / sqrt(D) >= P) {
                cntP++;
            }
            if ((abs(D) < eps && A < -eps) || A / sqrt(D) <= -P) {
                cntN++;
            }
        }
    }
    cout << cntP << " " << cntN << "\n";
}