#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>

#define FILE 0
#define RANDOM 0

using namespace std;

#if RANDOM
const unsigned seed = (unsigned)chrono::system_clock::now().time_since_epoch().count();
mt19937 rnd(seed);
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef ll typ;
typedef unsigned int ui;

const int N = 1e5 + 10, K = 26, M = 2010;
const ll INF = 5e18 + 3;
const ld EPS = 1e-9, PI = acos(-1);
const int MOD = 1e9 + 7, INFI = 2e9 + 7;
const ull A = 1000, P = 1e9 + 9;

int d, c[N], s[N];
ld p;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#if FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> d >> p;
    for (int i = 0; i < d; i++) {
        cin >> c[i];
        if (i) {
            s[i] = s[i - 1] + (c[i] - c[i - 1]) * (c[i] - c[i - 1]);
        }
    }
    int x = 0, y = 0;
    for (int i = 0; i + 2 < d; i++) {
        for (int j = i + 2; j < d; j++) {
            ld a = (ld)(c[j] - c[i]) / (j - i);
            ld b = (ld)(s[j] - s[i]) / (j - i) - a * a;
            ld q = (b < EPS ? (a > 0 ? (ld)INF : -(ld)INF) : a / sqrt(b));
            if (q > 0 && q > p) {
                x++;
            } else if (q < 0 && q < -p) {
                y++;
            }
        }
    }
    cout << x << ' ' << y << endl;

#if FILE
    fclose(stdin);
    fclose(stdout);
#endif

    return 0;
}