#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>

#define FILE 0
#define RANDOM 0

using namespace std;

#if RANDOM
const unsigned seed = (unsigned)chrono::system_clock::now().time_since_epoch().count();
mt19937 rnd(seed);
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef ll typ;
typedef unsigned int ui;

const int N = 1e5 + 10, K = 26, M = 2010;
const ll INF = 5e18 + 3;
const ld EPS = 1e-9, PI = acos(-1);
const int MOD = 1e9 + 7, INFI = 2e9 + 7;
const ull A = 1000, P = 1e9 + 9;

int n, d;
int a[N], b[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#if FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a, a + n);
    d = b[0] = a[0];
    for (int i = 1; i < n; i++) {
        b[i] = a[i] - a[i - 1];
        d = max(d, b[i]);
    }
    if (n == 1) {
        cout << d << endl;
        return 0;
    }
    for (int i = 0; i < n - 1; i++) {
        if (b[i] + b[i + 1] <= d) {
            cout << 0 << endl;
            return 0;
        }
    }
    cout << d << endl;

#if FILE
    fclose(stdin);
    fclose(stdout);
#endif

    return 0;
}
