// #pragma GCC optimize("O3")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
const int mod = 1e9 + 7;
const ld EPS = 1e-9;

ll pw(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

void solve() {
    int n;
    string s;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            cout << i << ' ' << j << endl;
            cin >> s;
            if (s == "WIN") {
                return;
            }
        }
    }
    while (true) {
        int pos = -1;
        for (int j = 1; j < n; j++) {
            cout << j << ' ' << j + 1 << endl;
            rem--;
            cin >> s;
            if (s == "WIN") {
                return;
            }
            if (s == "SWAPPED" && pos == -1) {
                pos = j;
            }
            if (s == "STAYED" && pos != -1) {
                for (int k = j - 1; k > pos; k--) {
                    cout << k - 1 << ' ' << k << endl;
                    cin >> s;
                    if (s == "WIN") {
                        return;
                    }
                }
                break;
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case #" << tc << ": ";
        solve();
    }
    return 0;
}