﻿#pragma GCC optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <numeric>
#include <iomanip>
#include <tuple>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <bitset>
#include <cmath>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

const int inf = 1e9 + 228;

int n, w, h, _s;
char a[94][30][30];
vector<char> ch;

void read(istream& cin) {
	cin >> n >> w >> h >> _s;
	for (int k = 0; k < n; k++) {
		char c;
		cin >> c;
		ch.push_back(c);
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				cin >> a[k][i][j];
			}
		}
	}
}

void umax(int& x, int y, char& c, char z) {
	if (x < y) {
		x = y;
		c = z;
	}
}

int cost[2][2];
char chs[2][2];
string s;

void solve(ostream& cout) {
	string ans;
	for (int i = 0; i < h; i++) {
		cost[0][0] = cost[0][1] = cost[1][0] = cost[1][1] = -inf;
		bool any = false;
		for (int k = 0; k < n; k++) {
			int num = 0;
			for (int j = 1; j < w; j++) {
				num += (a[k][i][j - 1] != a[k][i][j]);
			}
			for (int j = 0; j < w; j++) {
				any |= (a[k][i][j] == '#');
			}
			int x = a[k][i][0] == '#';
			int y = a[k][i][w - 1] == '#';
			umax(cost[x][y], num, chs[x][y], ch[k]);
		}
		if (!any) {
			continue;
		}
		s.clear();
		int dp = 0;
		while (true) {
			int a = cost[0][0], b = cost[0][1], c = cost[1][0] + 1, d = cost[1][1] + 1;
			int mx = max({ a, b, c, d });
			if (dp + mx >= _s) {
				if (a == mx) {
					s.push_back(chs[0][0]);
				}
				else if (b == mx) {
					s.push_back(chs[0][1]);
				}
				else if (c == mx) {
					s.push_back(chs[1][0]);
				}
				else {
					s.push_back(chs[1][1]);
				}
				break;
			}
			else {
				a = cost[0][0], b = cost[0][1] + 1, c = cost[1][0] + 1, d = cost[1][1] + 2;
				mx = max({ a, b, c, d });
				dp += mx;
				if (a == mx) {
					s.push_back(chs[0][0]);
				}
				else if (b == mx) {
					s.push_back(chs[0][1]);
				}
				else if (c == mx) {
					s.push_back(chs[1][0]);
				}
				else {
					s.push_back(chs[1][1]);
				}
			}
		}
		if (ans.empty() || s.size() < ans.size()) {
			ans = s;
		}
	}
	cout << ans << '\n';
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int t = 1;
	// cin >> t;
	while (t--) {
		read(cin);
		solve(cout);
	}
}
