﻿#pragma GCC optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <numeric>
#include <iomanip>
#include <tuple>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <bitset>
#include <cmath>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

int n;

void read(istream& cin) {
	cin >> n;
}

vector<int> get() {
	vector<int> ret(n);
	for (auto& x : ret) {
		cin >> x;
	}
	return ret;
}

void solve(ostream& cout) {
	cout << "? ";
	cout << 1 << ' ';
	for (int i = 2; i <= n; i++) {
		if (i < n) {
			cout << i + 1 << ' ';
		}
		else {
			cout << 2 << endl;
		}
	}
	auto resp = get();
	int dst1 = -1;
	for (int i = 0; i < n; i++) {
		if (resp[i] == i + 1) {
			if (dst1 == -1) {
				dst1 = i + 1;
			}
			else {
				assert(false);
			}
		}
	}
	cout << "? ";
	for (int i = 1; i <= n; i++) {
		if (i < n) {
			cout << i + 1 << ' ';
		}
		else {
			cout << 1 << endl;
		}
	}
	resp = get();
	vector<int> ord;
	int x = 0;
	do {
		ord.push_back(x + 1);
		x = resp[x] - 1;
	} while (x != 0);
	int i = 0;
	while (ord[i] != dst1) {
		i++;
	}
	rotate(ord.begin(), ord.begin() + i, ord.end());
	cout << "! ";
	for (int x : ord) {
		cout << x << ' ';
	}
	cout << endl;
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int t = 1;
	cin >> t;
	while (t--) {
		read(cin);
		solve(cout);
	}
}
