// #pragma GCC optimize("O3")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
const int mod = 1e9 + 7;

ll pw(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

ull cnk(int n, int k) {
    ull cnk = 1;
    int d = 2;
    for (int i = n - k + 1; i <= n; i++) {
        cnk *= i;
        while (d <= k && cnk % d == 0) {
            cnk /= d;
            d++;
        }
    }
    return cnk;
}

void solve() {
    int n, k;
    cin >> n >> k;
    if (k > n) {
        k = 2 * n - k;
    }
    ull ans = 0;
    for (int i = 0; i <= k; i++) {
        ull cnt = cnk(n, i);
        if (n % 2 || (n % 2 == 0 && i % 2 == 0))
            cnt += cnk(n / 2, i / 2);
        if (i * 2 == k) {
            ans += cnt;
            // cout << cnt << endl;
        } else {
            ans += cnt / 2;
            // cout << cnt / 2 << endl;
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case #" << tc << ": ";
        solve();
    }
    return 0;
}