#include <bits/stdc++.h>
using namespace std;

using lld = long double;

inline lld countDelta2(lld numa, lld numb) {
  return (numa - numb) * (numa - numb);
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  int d;
  lld p;
  cin >> d >> p;
  vector<lld> c(d);
  for (int i = 0; i < d; ++i) cin >> c[i];

  long long cntPos = 0;
  long long cntNeg = 0;

  for (int seglen = 3; seglen <= d; ++seglen) {
    // count for i = 0
    lld sumDelta2 = 0;
    for (int i = 1; i <= seglen - 1; ++i)
      sumDelta2 += countDelta2(c[i], c[i - 1]);

    for (int i = 0; i <= d - seglen; ++i) {
      int n = seglen - 1;
      if (i != 0)
        sumDelta2 = sumDelta2 - countDelta2(c[i], c[i - 1]) +
                    countDelta2(c[i + seglen - 1], c[i + seglen - 2]);
      lld asegs = c[i + seglen - 1] - c[i];
      lld wseg = sumDelta2 - asegs * asegs / n;
      lld f = asegs / sqrtl(wseg * n);
      if (f >= p)
        cntPos += 1;
      if (f <= -p)
        cntNeg += 1;
      //cout << setprecision(4) << fixed << f << " " << p << "\n";
    }
  }
  cout << cntPos << " " << cntNeg << "\n";
  return 0;
}
