﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <cstdlib>

using namespace std;

#define show(a) cout << #a << " = " << a << '\n';


using line = vector <int>;
using matrix = vector <line>;

int main() {
    //
    ios::sync_with_stdio(false);

    int n;
    double p;

    cin >> n >> p;
    line c(n);
    
    for (auto& i : c)
        cin >> i;

    // разности
    for (int i(n-1); i > 0; i--) {
        c[i] -= c[i - 1];
    }
    c[0] = 0;

    // частичные суммы
    line ps(n);
    ps[0] = c[0];

    for (int i(1); i < n; i++)
        ps[i] = ps[i-1] + c[i];


    // a
    int pos(0), neg(0);

    for (int i(1); i < n; i++) {
        for (int j(i + 1); j < n; j++) {
            double dx = ps[j] - ps[i - 1];

            double A = 1 / (j - i) * dx;
            double D = sqrt(1 / (j - i) * (dx - A)*(dx - A));

            if (D < 10e-9) {
                if (A > 0) pos++;
                else neg++;
            }
            else {
                if (A / D > p) pos++;
                else neg++;
            }
        }
    }

    cout << pos << " " << neg;

}