import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        int num;
        int rand;
        boolean bool = true;
        Scanner in = new Scanner(System.in);
        System.out.print("Input a number or cards(from 2 to 50): ");
        num = in.nextInt();
        while (num < 2 || num > 50) {
            System.out.print("Wrong input! The number or cards should be in interval from 2 to 50. Try again: ");
            num = in.nextInt();
        }
        System.out.println("Number of cards = " + num);
        int arr[] = new int[num];
        for (int i = 0; i < num; i++) {
            arr[i] = i + 1;
        }
        for (int i = arr.length - 1; i >= 1; i--) {
            int j = (int) Math.random() * 10 + num - 1;
            var temp = arr[j];
            arr[j] = arr[i];
            arr[i] = temp;
        }
        for (int i = 0; i < arr.length - 1; i++) {
            if (arr[i] > arr[i + 1]) {
                var temp = arr[i];
                arr[i] = arr[i + 1];
                arr[i + 1] = temp;
            }
        }
        int count = 0;
        String operation;
        boolean win = true;
        while (win) {
            win = false;
            for (int i = 1; i < arr.length; i++) {
                System.out.println(arr[i] + " " + arr[i - 1]);
                operation = in.nextLine();
                if(operation.equals("SWAPPED")){
                    swap(arr, i, i-1);
                    win = true;
                }
                count++;
                if(count%num == 0){
                    int pos1 = (int) Math.random() * 10 + num - 1;
                    int pos2 = (int) Math.random() * 10 + num - 1;
                    swap(arr, pos1, pos2);
                }
            }
        }
        System.out.println("WIN");
    }
    private static void swap(int[] array, int ind1, int ind2) {
        int tmp = array[ind1];
        array[ind1] = array[ind2];
        array[ind2] = tmp;
    }
}
