#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	const string spbsu = "SPbSU", itmo = "ITMO", petrsu = "PetrSU";

	const vector<string> winners = {itmo, spbsu, spbsu, itmo, itmo, spbsu, itmo, itmo, itmo, itmo, itmo,
	                                petrsu + ", " + itmo, spbsu, spbsu, itmo, itmo, itmo, itmo, spbsu,
	                                itmo, itmo, itmo, itmo, spbsu, itmo};

	const int start = 1995, fin = 2019;
	assert(int(winners.size()) == (fin - start + 1));

	int y;
	cin >> y;
	cout << (winners[y - start]) << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
