#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	vector<vector<int>> plans = {{-1, -1, 30}, {-1, -1, 45}};
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < 2; j++)
			cin >> plans[i][j];

	int t;
	cin >> t;
	for (int i = 0; i < 2; i++)
	{
		int ans = plans[i][0];
		ans += 21 * max(0, t - plans[i][2]) * plans[i][1];

		cout << ans;
		cout << " \n"[i == 1];
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
