#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const int mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

mt19937 rng(228);


int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int d;
	cin >> d;

	ld P;
	cin >> P;

	vector<int> days(d);
	for (int i = 0; i < d; i++) cin >> days[i];

	int pos = 0, neg = 0;

	for (int s = 0; s < d; s++) {
		ll avg = 0, var = 0;

		for (int e = s + 1; e < d; e++) {
			avg += days[e] - days[e-1];
			var += (days[e] - days[e-1]) * (days[e] - days[e - 1]);

			if (e == s + 1) continue;
			if (avg > 0 && var * (e - s) - avg * avg == 0) pos++;
			else if (avg < 0 && var * (e - s) - avg * avg == 0) neg++;
			else if (avg / sqrt(var * (e - s) - avg * avg) >= P) pos++;
			else if (avg / sqrt(var * (e - s) - avg * avg) <= -P) neg++;
		}
	}

	cout << pos << ' ' << neg << endl;
}