#ifdef ONPC
    #define _GLIBCXX_DEBUG
    #define deb(a) cerr << "========" << #a << " = " << a << endl;
#else
    #define deb(a)
#endif
#define sz(a) ((int)((a).size()))
#include <bits/stdc++.h>
#define char unsigned char

using namespace std;
mt19937 rnd(239);
// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

int solve()
{
    int n;
    if (!(cin >> n))
        return 1;
    vector<ll> a(n);
    for (ll &i : a)
        cin >> i;
    sort(a.begin(), a.end());
    ll mx = a[0];
    for (int i = 1; i < sz(a); i++)
        mx = max(mx, a[i] - a[i - 1]);
    bool ok = true;
    if (a[1] <= mx) {
        ok = false;
    }
    for (int i = 2; i < sz(a); i++) {
        if (a[i] - a[i - 2] <= mx) {
            ok = false;
        }
    }
    if (ok) {
        cout << mx << endl;
    } else {
        cout << 0 << endl;
    }
    return 0;
}

int32_t main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++)
    {
        if (solve())
            break;
        cout << '\n';
        #ifdef ONPC
            cout << "\n__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
