#include <bits/stdc++.h>

using namespace std;

#define ld long double

const int maxN = 3005;
const ld eps = 1e-9;

ld arr[maxN];
ld psum[maxN];
ld pscuare[maxN];

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    ld P;
    cin >> n >> P;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    n--;
    for (int i = 0; i < n; i++) {
        arr[i] = arr[i + 1] - arr[i];
    }

    psum[0] = 0;
    for (int i = 1; i <= n; i++) {
        psum[i] = psum[i - 1] + arr[i - 1];
    }
    pscuare[0] = 0;
    for (int i = 1; i <= n; i++) {
        pscuare[i] = pscuare[i - 1] + arr[i - 1] * arr[i - 1];
    }

    int cntP = 0;
    int cntN = 0;
    for (int l = 0; l < n; l++) {
        for (int r = l + 2; r <= n; r++) {
            int len = r - l;
            ld A = (psum[r] - psum[l]) / len;
            ld D = (pscuare[r] - pscuare[l]) / len - 2 * (psum[r] - psum[l]) * A / len + A * A;

            if (D < 0) D = 0;
            D = sqrt(D);

            if (abs(A) < eps) continue;
            if (D < eps) {
                if (A < 0) cntN++;
                else cntP++;
            }
            else {
                if (abs(A / D) > P - eps) {
                    if (A < 0) cntN++;
                    else cntP++;
                }
            }
        }
    }

    cout << cntP << " " << cntN << endl;

    return 0;
}
