#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll linf = (ll)1e18 + 10;
const int iinf = (int)1e9 + 10;
const int mod = 998244353;
const ld PI = acos(-1);
#define all(x) x.begin(), x.end()

const int maxn = 30;
ll dp[maxn][maxn][maxn];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int p; cin >> p;
    vector <vector <pair<int, int>>> a(26);

    string tmp; getline(cin, tmp);

    for (int i = 0; i < p; i++){
        string s;
        getline(cin, s);
        if (s.length() == 7) {
            a[s[0] - 'A'].push_back({s[5] - 'A', s[6] - 'A'});
        }
        else{
            a[s[0] - 'A'].push_back({s[5] - 'a', -1});
        }
    }

    int s, t, n, m;
    cin >> n >> m >> s >> t; s--; t--;
    vector <vector<pair<int, int>>> gr(n);
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v; u--; v--;
        char c; cin >> c;
        gr[u].push_back({v, c - 'a'});
    }


    for (int i = 0; i < maxn; i++){
        for (int j = 0; j < maxn; j++){
            for (int k = 0; k < maxn; k++){
                dp[i][j][k] = linf;
            }
        }
    }

    for (int i = 0; i < 26; i++){
        for (auto rule : a[i]) {
            if (rule.second == -1) {
                for (int u = 0; u < n; u++) {
                    for (auto e : gr[u]) {
                        if (e.second == rule.first) {
                            dp[i][u][e.first] = 1ll;
                        }
                    }
                }
            }
        }
    }

    for (int cnt = 0; cnt < 200; cnt++) {
        for (int i = 0; i < 26; i++) {
            for (auto rule : a[i]) {
                if (rule.second != -1) {
                    for (int j = 0; j < n; j++) {
                        for (int u = 0; u < n; u++) {
                            for (int v = 0; v < n; v++) {
                                dp[i][u][v] = min(dp[i][u][v], dp[rule.first][u][j] + dp[rule.second][j][v]);
                            }
                        }
                    }
                }
            }
        }
    }

    ll res = dp['S' - 'A'][s][t];
    if (res == linf) cout << "NO\n";
    else cout << res << "\n";

    return 0;
}