#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll linf = (ll)1e18 + 10;
const int iinf = (int)1e9 + 10;
const int mod = 998244353;
const ld PI = acos(-1);
#define all(x) x.begin(), x.end()

/*int getnumm(int s, int m, int k){
    int res = 0;
    while (s <= k){
        if (m % 2 != 0){
            res += (1 << s) - 1;
        }
        m /= 2;
        s++;
    }
    return res;
}*/

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);

    int k, n;
    cin >> k >> n;
    vector <int> s(n), m(n);
    set <pair<int, int>> sm;
    vector <pair<int, int>> v;

    ld ans = 0;
    for (int i = 0; i < n; i++){
        cin >> s[i] >> m[i]; m[i]--;
        int ss = s[i], mm = m[i];

        ld mult = 1;
        while (true){
            mm /= 2;
            ss++;
            if (sm.count({ss, mm})){
                ans += 1 - mult;
                break;
            }
            mult *= 0.5;
            if (ss == k+1){
                ans += 1;
                break;
            }
        }

        sm.insert({s[i], m[i]});
        v.push_back({s[i], m[i]});
    }
    sort(all(v));
    reverse(all(v));


    vector <int> nums(k+1, 0), numsr(k+1);
    for (int i = 1; i <= k; i++) numsr[i] = 1 << (i-1);

    sm.clear();
    for (int i = 0; i < n; i++){
        int ss = v[i].first, mm = v[i].second;

        int kk = k+1;
        while (ss <= k){
            mm /= 2;
            ss++;
            if (sm.count({ss, mm})){
                kk = ss;
                break;
            }
        }
        ss = v[i].first, mm = v[i].second;

        for (int j = 1; j < ss; j++){
            nums[j] += 1 << j;
        }
        if (kk != k + 1) {
            for (int j = 0; j < ss; j++) {
                nums[j + (kk - ss)] -= 1 << j;
            }
        }
        else{
            for (int j = 0; j < ss; j++) {
                numsr[j + (kk - ss)] -= 1 << j;
            }
        }

        sm.insert(v[i]);
    }

    /*for (int i = 0; i < n; i++) {
        int numm = getnumm(s[i], m[i], k);
        auto it = ind.lower_bound(numm + 1);
        auto it2 = ind.lower_bound(numm + ((1 << (s[i] - 1))));
        if (it == it2) {
            for (int j = 1; j < s[i]; j++) {
                nums[j] += 1 << j;
            }
            for (int j = 0; j < s[i]; j++) {
                nums[j + (k + 1 - s[i])] -= 1 << j;
            }
        }
    }*/
    //cout << ans << endl;

    for (int i = 1; i <= k; i++){
        ld cur = 1, res = 0;
        for (int j = 0; j <= i - 2; j++){
            res += ((ld)1) / ((ld)(j + 1)*(j + 2))  * (1 - cur);
            cur *= 0.5;
        }
        ld res1 = res + ((ld)1) / ((ld)i) * (1-cur);
        ld res2 = res + ((ld)1) / ((ld)i);
        //cout << res << endl;

        ans += res1 * nums[i] + res2 * numsr[i];
        //cout << i << " " << nums[i] << endl;
    }

    cout << ans;


    return 0;
}