#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int MAXN = 51;

unsigned long long c[MAXN][MAXN];

int n;

void precalc() {
	for (int i = 0; i < MAXN; i++)
		c[i][0] = c[i][i] = 1;
	
	for (int i = 0; i < MAXN; i++)
		for (int j = 1; j < i; j++) {
			c[i][j] = c[i - 1][j] + c[i - 1][j - 1];
		}
}

unsigned long long kek(int k) {
	unsigned long long symm = c[n / 2][k / 2];
	unsigned long long all = c[n][k];
	
	if (k % 2 == 1 && n % 2 == 0) {
		return all / 2;
	}
	return (all + symm) / 2;
}

int32_t main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(false);
	
	precalc();
	
	int k; cin >> n >> k;
	unsigned long long res = 0;
	for (int i = max(0ll, k - n); i <= min(n, k); i++) {
		res += kek(i);
		if (2 * i == k) {
			res += kek(i);
		}
	}
	
	cout << res << endl;
	
	return 0;
}
