#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <chrono>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
#define int ll

using namespace std;
typedef long double ld;
typedef long long ll;

ld eps = 1e-9;

ld sq(ld x) { return x * x; }

bool pos(ld av, ld sums, int n, ld p) {
	if(av == 0) 
		return 0;
	if(sums < 0) 
		sums = eps;
	if(abs(sums) < eps && av > 0) 
		return 1;
	if(av / sqrtl(sums / n) >= p) 
		return 1;
	return 0;
}

bool otr(ld av, ld sums, int n, ld p) {
	if(av == 0) 
		return 0;
	if(sums < 0) 
		sums = eps;
	if(abs(sums) < eps && av < 0) 
		return 1;
	if(av / sqrtl(sums / n) <= -p)
		return 1;
	return 0;
}

signed main() {
	#ifdef PC
		freopen("in.txt", "r", stdin);
		freopen("out.txt", "w", stdout);
	#endif	
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n;
	ld p;
	cin >> n >> p;
	vector<int> c(n);
	vector<int> a(n - 1);
	vector<int> pref(n + 1, 0);
	int poss = 0, otrr = 0;
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < n - 1; i++) {
		a[i] = c[i + 1] - c[i];
		pref[i + 1] = pref[i] + a[i];
	}



	for (int i = 0; i < n - 1; i++) {
		if(i + 1 >= n - 1) 
			break;
		ld sum = 0, sums = 0, avp = 0, av = 0;
		av = (a[i + 1] + a[i]) * 1.0 / 2, avp = av, sum = (a[i] + a[i + 1]) - 2*av, sums = sq(a[i] - av) + sq(a[i + 1] - av);
		if(pos(av, sums, 2, p)) 
			poss++;
		if(otr(av, sums, 2, p))
			otrr++;
		for (int j = 2;;j++) {
			if(i + j >= n - 1) 
				break;
			av = (pref[i + j + 1] - pref[i]) * 1.0 / (j + 1);
			ld dx = av - avp;
			sums = sums - 2 * sum * dx + sq(dx) * j;
			sum = sum - dx * j;
			sum += (a[i + j] - av);
			sums += sq(a[i + j] - av);
			if(pos(av, sums, j + 1, p))
				poss++;
			if(otr(av, sums, j + 1, p))
				otrr++;
			avp = av;
		}
	}		
	cout << poss << " " << otrr << endl;
}
