#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
const int N = 110;
const int inf = 1e9;

vector<int> a, b, w;



vector<int> kek(vector<vector<int>> g, int n, int v, vector<int> id) {
    vector<int> ans;
    int num = 0;
    bool f = 0;
    vector<bool> used(id.size());
    vector<int> degout(n), degin(n);
    for (int i = 0; i < n; i++) {
        for (auto s : g[i]) {
            int j = id[s];
            degout[i]++;
            degin[j]++;
        }
    }


    for (int u = 0; u < n; u++) {

        if (u == v) {
            if (degout[u] == degin[u]) f = 1;
            else if (degout[u] != degin[u] + 1) return ans;
        }
        else {
            if (degout[u] != degin[u]) {
                if (degin[u] == degout[u] + 1) num++;
                else return ans;
            }
        }
    }

    if (f && num > 0) return ans;
    if (!f && num != 1) return ans;
    ans = {};
    stack<pair<int,int>> S;
    S.push({ v,-1 });  // S — стек
    while (!S.empty()) {
        auto p = S.top();
        int w = p.first;
        bool found_edge = false;
        for (int edge : g[w]) {
            if (!used[edge]) {
                int u = id[edge];  // нашли ребро, по которому ещё не прошли
                S.push({ u,edge });  // добавили новую вершину в стек
                used[edge] = true;
                found_edge = true;
                break;
            }

        }

        if (!found_edge) {
            S.pop(); // не нашлось инцидентных вершине w рёбер, по которым ещё не прошли
            ans.push_back(p.second);
        }

    }
    reverse(ans.begin(), ans.end());
    return ans;
}



int main() {
    int n; cin >> n;
    int c; cin >> c;
    set<int> st;
    st.insert(c);

    a.resize(n);
    b.resize(n);
    w.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> w[i];
        if (w[i]) {
            st.insert(a[i]);
            st.insert(b[i]);
        }
    }
    map<int, int> id;
    int sz = 0;
    for (auto x : st) {
        id[x] = sz++;
    }

    vector<vector<int>> g(sz);
    vector<int> idedges(n);
    for (int i = 0; i < n; i++) {
        if (w[i]) {
            int id1 = id[a[i]];
            int id2 = id[b[i]];
            g[id1].push_back(i);
            idedges[i] = id2;
        }
    }

    auto pth = kek(g, sz, id[c], idedges);

    if (pth.size() == 0) {
        cout << "No" << endl;
        return 0;
    }

    pth.erase(pth.begin());
    vector<int> ans;
    vector<int> left;

    for (int i = 0; i < n; i++) {
        if (!w[i]) {
            if (a[i] != c) {
                ans.push_back(i);
            } else {
                left.push_back(i);
            }
        }
    }
    for (auto x : pth) {
        int vs = b[x];
        ans.push_back(x);
        if (vs != c) {
            for (auto y : left) {
                ans.push_back(y);
            }
            left.clear();
        }
    }

    if (!left.empty()) {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    for (auto x : ans)
        cout << x + 1 << " ";
    cout << endl;
}
/*
4 1
1 2 0
1 2 1
2 3 1
3 4 0
 */

/*
0 4 1
4 5 1
1 2 0
5 7 1
7 7 1
0 3 0
7 5 1
5 0 1
5 6 0
0 1 1
7 8 0







 */
