#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
const int N = 110;
const int inf = 1e9;
ld eps = 1e-10;


int main() {
    int n; cin >> n;
    ld P; cin >> P;

    vector<ll> c(n);
    for (auto &x : c) cin >> x;

    vector<ll> pq(n);
    pq[0] = 0;
    for (int i = 0; i + 1 < n; i++) {
        int dt = c[i + 1] - c[i];
        pq[i + 1] = pq[i] + dt * dt;
    }

    auto subsm = [&] (int l, int r) {
        return pq[r] - pq[l - 1];
    };

    auto get_s1 = [&] (int l, int r) {
        return c[r] - c[l];
    };

    auto get_A = [&] (int l, int r) {
        ld res = 1;
        res *= get_s1(l, r);
        res /= (r - l);
        return res;
    };


    auto get_s2 = [&] (int l, int r) {
        ld res = 0;
        ld A = get_A(l, r);
        ld S1 = get_s1(l, r);

        res += subsm(l + 1, r);
        res += (r - l) * A * A;
        res -= 2 * A * S1;

        return res;
    };
    auto get_D2 = [&] (int l, int r) {
        return get_s2(l, r) / (r - l);
    };

    int pos = 0;
    int neg = 0;

    auto calc = [&] (int l, int r) {
        ld A = get_A(l, r);
        ld D2 = get_D2(l, r);
        if (A * A >= D2 * P * P - eps) {
            if (A > 0)
                pos++;
            if (A < 0)
                neg++;
        }

    };

    for (int i = 0; i < n; i++) {
        for (int j = i + 2; j < n; j++) {
            calc(i, j);
        }
    }
    cout << pos << " " << neg << endl;

}


