﻿#include <locale.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <numeric>
#include <iterator>
#include <sstream>
#include <map>
#include <math.h>
#include <stdio.h>
#include <stack>
#include <random>  
#include <ctime>  
#include <queue>
#include <set>

using namespace std;
using ll = long long;
using matr = vector<vector<ll>>;
using dbl = long double;
using ui = unsigned int;
using ld = long double;



mt19937 rnd;

ll  random(ll  limit)
{
	uniform_int_distribution <ll > uniform_dist(0, limit);
	return uniform_dist(rnd);
}


vector<int> mult(vector<int> x, vector<int> y) {
	int n = x.size();
	vector<int> ans(n);
	for (int i = 0; i < n; i++) {
		ans[i] = y[x[i]];
	}
	return ans;
}

vector<int> rev(vector<int> x) {
	int n = x.size();
	vector<int> ans(n);
	for (int i = 0; i < n; i++) {
		ans[x[i]] = i;
	}
	return ans;
}


int  main()
{
	//system("chcp 1251");
	//setlocale(LC_ALL, "Russian");
	

	rnd = mt19937(956231);
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> trans1(n), cycle(n);
		trans1[0] = 1;
		trans1[1] = 0;
		for (int i = 2; i < n; i++) trans1[i] = i;
		for (int i = 0; i < n; i++) {
			cycle[i] = (i + 1) % n;
		}

		vector<int> sopr_trans1(n), sopr_cycle(n);
		cout << "? ";
		for (int i = 0; i < n; i++) cout << trans1[i] + 1 << ' ';
		cout << endl;
		for (int i = 0; i < n; i++) {
			cin >> sopr_trans1[i];
			sopr_trans1[i]--;
		}
		


		cout << "? ";
		for (int i = 0; i < n; i++) cout << cycle[i] + 1 << ' ';
		cout << endl;
		for (int i = 0; i < n; i++) {
			cin >> sopr_cycle[i];
			sopr_cycle[i]--;
		}
		


		


		vector<vector<int>> trans(n, vector<int>(n));
		for (int i = 0; i < n; i++) {
			trans[i][i] = (i + 1) % n;
			trans[i][(i + 1) % n] = i;
			for (int j = 2; j < n; j++) {
				trans[i][(i + j) % n] = (i + j) % n;
			}
		}

		vector<vector<int>> sopr_trans(n, vector<int>(n));

		sopr_trans[0] = sopr_trans1;

		for (int i = 1; i < n; i++) {
			
			sopr_trans[i] = mult(mult(rev(sopr_cycle), sopr_trans[i - 1]), sopr_cycle);
		}

		

		

		vector<set<int>> pairs(n);

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (sopr_trans[i][j] != j)
					pairs[i].insert(sopr_trans[i][j]);
			}

		}
		vector<int> ans(n);
		for (int i = 0; i < n; i++) {
			set<int> s1, s2;
			s1 = pairs[i];
			s2 = pairs[(i + 1) % n];
			for (auto a : s1) {
				if (s2.count(a) == 0) ans[i] = a;
			}
		}
		cout << "! ";
		for (int i = 0; i < n; i++) cout<< ans[i] + 1<< ' ';
		cout << endl;
	}
}

