#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>
#include <bitset>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <queue>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ul = unsigned long long;
using ld = long double;

map<int, vector<pair<int, int>>> g;
const int N = 100001;
int x[N], y[N], w[N], pos[N];
vector<int> ord;

void dfs(int v) {
    while (pos[v] < g[v].size()) {
        auto pp = g[v][pos[v]];
        pos[v]++;
        dfs(pp.first);
        ord.push_back(pp.second);
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, c, cc = 0;
    cin >> n >> c;
    rep(i, n) {
        cin >> x[i] >> y[i] >> w[i];
        if (w[i]) {
            g[x[i]].push_back({y[i], i});
            cc++;
        }
    }
    dfs(c);
    if (ord.size() != cc) {
        cout << "No";
        return 0;
    }
    rep(i, cc - 1)
        if (x[ord[i]] != y[ord[i + 1]]) {
            cout << "No";
            return 0;
        }
    vector<int> li;
    rep(i, n)
        if (!w[i] && x[i] == c)
            li.push_back(i);
    int fl = 0;
    for (int i : ord)
        if (y[i] != cc)
            fl = 1;
    if (!li.empty() && !fl) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    rep(i, n)
        if (!w[i] && x[i] != c)
            cout << i + 1 << ' ';
    reverse(all(ord));
    for (int i : ord) {
        cout << i + 1 << ' ';
        if (y[i] != c) {
            for (int j : li)
                cout << j + 1 << ' ';
            li.clear();
        }
    }
}

