#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>
#include <bitset>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <queue>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ul = unsigned long long;
using ld = long double;

string s;
int n, r2 = 0;
vector<string> res;

void add(string t) {
    if (r2) {
        rep(i, n) {
            if (t[i] == '{')
                t[i] = '[';
            else if (t[i] == '}')
                t[i] = ']';
        }
    }
    res.push_back(t);
    rep(i, n)
        s[i] ^= t[i];
}

string zs(int l) {
    if (l == 1)
        return "0";
    assert(l != 2 && l != 0);
    // assert(l != 2);
    string r = "0*";
    rep(i, l - 2)
        r.push_back('1');
    return r;
}

void add2(string t) {
    add(t);
    if (r2)
        add(zs(1) + "=" + zs(n-2));
}

void add1(int l, int r) {
    if (l == 0) {
        if (r == 3) {
            if (n == 10)
                add2("{10}=0+1+9");
            else
                add2("{10}=10+" + zs(n-8));
        }
        else
            add2("{" + zs(r - l - 1) + "}=" + zs(n-r-2));
    }
    if (r == n - 1) {
        if (l == n - 4) {
            if (n == 10)
                add2("0+1+9={10}");
            else
                add2(zs(n-8) + "+10={10}");
        }
        else
            add2(zs(l-1) + "={" + zs(r - l - 1) + "}");
    }
    // assert(false);
}

int f(int cm) {
    for (int i = 2; i < s.size() - 2; i++) {
        if (!(s[i] & cm))
            continue;
        if (i == n - 4)
            add1(i, n - 1);
        else
            add1(0, i);
    }
    if (s[1] & cm) {
        add2("{{0}}=" + zs(n-6));
        add1(0, 3);
        add1(4, n - 1);
    }
    if (s[n - 2] & cm) {
        add2(zs(n-6) + "={{0}}");
        add1(0, n - 5);
        add1(n - 4, n - 1);
    }
    if (s[n - 1] & cm) {
        add1(0, 2);
        add1(2, n - 1);
    }
    if (s[0] & cm) {
        cout << "NO\n";
        return 1;
    }
    return 0;
}

void add3(int p) {
    string s;
    if (p > 0 && p < n - 5 && p != n - 7) {
        rep(i, p)
            s.push_back('1');
        s += "*0*0=" + zs(n-p-5);
        add(s);
        s[p] = '0';
        add(s);
    }
    else if (p > 0 && p < n - 1) {
        s = zs(p-4);
        s += "=0*1*";
        rep(i, n - p - 1)
            s.push_back('1');
        add(s);
        s[p] = '1';
        add(s);
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t;
    cin >> t;
    rep(z, t) {
        res.clear();
        cin >> s;
        n = s.size();
        r2 = 1;
        int c32 = 0;
        for (char c : s)
            if (c & 32)
                c32++;
        if (c32 % 2) {
            add(zs(1) + "=" + zs(n - 2));
        }
        if (f(32))
            continue;
        rep(i, n)
            assert(!(s[i] & 32));
        // for (auto &pp : res)
        //     cout << pp << '\n';
        r2 = 0;
        if (f(64))
            continue;
        if (s[0] & 16) {
            add("(0)=" + zs(n-4));
            add("0+0=" + zs(n-4));
        }
        if (s[n - 1] & 16) {
            add(zs(n-4) + "=(0)");
            add(zs(n-4) + "=0+0");
        }
        for (int i = 1; i < n - 1; i++)
            if (s[i] & 16)
                add3(i);
        string cs = "0=0*1";
        rep(i, n - 5)
            cs.push_back('0');
        for (int i = 4; i < n; i++) {
            for (int ms = 7; ms <= 8; ms++) {
                int x = (s[i] & ms);
                if (x) {
                    add(cs);
                    cs[i] ^= x;
                    add(cs);
                    cs[i] ^= x;
                }
            }
        }
        cs = "1000*0=" + zs(n-7);
        rep(i, 4) {
            for (int ms = 7; ms <= 8; ms++) {
                int x = (s[i] & ms);
                if (x) {
                    add(cs);
                    cs[i] ^= x;
                    add(cs);
                    cs[i] ^= x;
                }
            }
        }
        sort(all(res));
        res.resize(unique(all(res)) - res.begin());
        cout << "YES\n" << res.size() << '\n';
        for (auto &pp : res) {
            cout << pp << '\n';
        }
    }
}

