﻿#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O4")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tracer")
#pragma GCC target("sse2")
#pragma GCC target("sse3")
#pragma GCC target("popcnt")
#pragma GCC target("abm")
#pragma GCC target("mmx")
#pragma GCC target("tune=native")

using namespace std;

#define IOS ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define nl '\n'
#define no "NO"<<'\n'
#define yes "YES"<<'\n'
#define random sdagagdkasfsdkgsdkgm
#define x0 fslfmlasflsafsdka
#define y0 kdmsfdlfskflfdsfsf

const long long maxn = 1 << 18;
long double pi = acos(-1);
const long long mod = 1e9 + 7;

mt19937 mt((unsigned int)time(0));

inline int random() {
  return abs((int)mt());
}

#ifdef FFT

const int K = 18;


int rev[maxn];

complex < long double > root[maxn];

complex < long double > a[maxn], b[maxn], c[maxn], fa[maxn], fb[maxn], fc[maxn];

const complex < long double > im_one = {0, 1};

void init_roots( ) {

	for ( int k = 1; k < maxn; k *= 2 ) {
		complex < long double > temp = exp( pi * im_one / ( long double ) k );

		root[k] = {1, 0};

		for ( int i = 1; i < k; i++ ) {
			root[k + i] = (i & 1) ? root[(k + i) / 2] * temp : root[(k + i) / 2];
		}

	}
}

inline void init_rev( ) {
	for ( int i = 0; i < maxn; i++ ) {
		for ( int j = 0; j < K; j++ ) {
			rev[i] |= ((1 << (K - j - 1)) & i) ? (1 << j) : 0;
		}
	}

}

inline void fft( complex < long double > * poly, complex < long double > * f_poly ) {
	for ( int i = 0; i < maxn; i++ ) {
		f_poly[rev[i]] = poly[i];
	}


	for ( int k = 1; k < maxn; k *= 2 ) {
		for ( int i = 0; i < maxn; i += 2 * k ) {
			for ( int j = 0; j < k; j++ ) {
				complex < long double > temp = root[j + k] * f_poly[i + j + k];
				f_poly[i + j + k] = f_poly[i + j] - temp;
				f_poly[i + j] = f_poly[i + j] + temp;
			}
		}
	}

}

inline void reverse_fft( complex < long double > * f_poly, complex < long double > * poly ) {
	fft( f_poly, poly );

	reverse( poly + 1, poly + maxn );

	for ( int i = 0; i < maxn; i++ ) {
		poly[i] /= maxn;
	}
}

inline void init_fft( ) {

	init_rev( );
	init_roots( );
}

inline void reset_fft( ) {
	fill( a, a + maxn, 0 );
	fill( b, b + maxn, 0 );
	fill( c, c + maxn, 0 );
	fill( fa, fa + maxn, 0 );
	fill( fb, fb + maxn, 0 );
	fill( fc, fc + maxn, 0 );
}

#endif

#ifdef TREAP

struct item {
	int key, prior, cnt;
	item *l, *r;

	item(int key) : key(key), prior(random()), cnt(1), l(nullptr), r(nullptr) {};
};

typedef item *pitem;

int cnt(pitem t) {
	return t ? t->cnt : 0;
}

void upd_cnt(pitem t) {
	if (t)
		t->cnt = 1 + cnt(t->l) + cnt(t->r);
}

void split(pitem t, int key, pitem &l, pitem &r) {
	if (!t)
		l = r = nullptr;
	else if (key <= t->key)
		split(t->l, key, l, t->l), r = t;
	else
		split(t->r, key, t->r, r), l = t;
	upd_cnt(t);
}

void merge(pitem &t, pitem l, pitem r) {
	if (!l || !r)
		t = l ? l : r;
	else if (l->prior > r->prior)
		merge(l->r, l->r, r), t = l;
	else
		merge(r->l, l, r->l), t = r;
	upd_cnt(t);
}

pitem tree = nullptr;

#endif

template < typename C >
class graphdir {
 public:
  struct edge {
	edge(int a, int b, C d, C h) : from(a), to(b), c(d), f(h) {}

	int from, to;
	C c, f;
  };

  vector<vector<int> > adj;
  vector<edge> e;
  int s, t;

  int dist_to_t;

  vector<int> dist;
  vector<int> ptr;

  void init(int n, int sb, int tb) {
	adj.resize(n);
	dist.resize(n);
	ptr.resize(n);
	s = sb, t = tb;
  }

  void add(int a, int b, C c) {
	adj[a].push_back(e.size());
	e.push_back(edge(a, b, c, 0));
	adj[b].push_back(e.size());
	e.push_back(edge(b, a, 0, 0));
  }

  bool bfs(C upper) {
	fill(dist.begin(), dist.end(), -1);
	dist[s] = 0;
	queue<int> q;
	q.push(s);
	while (!q.empty()) {
	  int v = q.front();
	  q.pop();
	  for (int a : adj[v]) {
		edge x = e[a];
		if (x.c >= x.f + upper) {
		  if (dist[x.to] == -1) {
			dist[x.to] = dist[v] + 1;
			q.push(x.to);
		  }
		}
	  }
	}
	dist_to_t = dist[t];
	fill(ptr.begin(), ptr.end(), 0);
	return dist[t] != -1;
  }

  C dfs(int v, C flow) {
	if (abs(flow) <= 1e-9) {
	  return 0;
	}
	if (v == t) {
	  return flow;
	}
	if (dist[v] >= dist_to_t) {
	  return 0;
	}
	for (; ptr[v] < adj[v].size(); ptr[v]++) {
	  edge to = e[adj[v][ptr[v]]];
	  if (dist[to.to] != dist[v] + 1) {
		continue;
	  }
	  C pushed = dfs(to.to, min(flow, to.c - to.f));
	  if (pushed > 0) {
		e[adj[v][ptr[v]]].f += pushed;
		e[adj[v][ptr[v]] ^ 1].f -= pushed;
		return pushed;
	  }
	}

	return 0;
  }

  C dinic() {
	C upper = 1;
	for (edge x:e) {
	  while (upper < x.c) {
		upper *= 2;
	  }
	  x.f = 0;
	}
	C flow = 0;
	for (; upper > 0; upper /= 2) {
	  while (bfs(upper)) {
		while (true) {
		  C pushed = dfs(s, upper);
		  if (pushed >= 1e-6) {
			flow += pushed;
		  } else {
			break;
		  }
		}
	  }
	}
	return flow;
  }
};

int ttt;

int d;
long double p;

long long c[4000];
long long sumsq[4000];
long long pr[4000];

long long pairpr[4000];

void input() {
  cin >> d >> p;
  for (int i = 1; i <= d; i++) {
	cin >> c[i];
	pr[i] = pr[i - 1] + c[i];
	sumsq[i] = sumsq[i - 1] + c[i] * c[i];
	pairpr[i] = pairpr[i - 1] + c[i - 1] * c[i];
  }
}

void solve() {
  int bad = 0, good = 0;
  for (int l = 1; l <= d; l++) {
	for (int r = l + 2; r <= d; r++) {
	  long long n = (r - l);
	  long long An = c[r] - c[l];
	  long long s1 = (sumsq[r] - sumsq[l]) * n * n;
	  long long s2 = (sumsq[r - 1] - sumsq[l - 1]) * n * n;
	  long long s3 = An * An * n;
	  long long s4 = 2 * n * n * (pairpr[r] - pairpr[l]);
	  long long s5 = 2 * An * n * (pr[r - 1] - pr[l - 1]);
	  long long s6 = 2 * An * n * (pr[r] - pr[l]);
	  long long S = s1 + s2 + s3 - s4 + s5 - s6;
	  if (An > 0 && S == 0) {
		good++;
		continue;
	  }
	  if (An < 0 && S == 0) {
		bad++;
		continue;
	  }
	  if (An >= 0) {
		if (An * An * n >= p * p * S) { good++; }
	  }
	  if (An <= 0) {
		long long nAn = -An;
		if (nAn * nAn * n >= p * p * S) { bad++; }
	  }
	}
  }
  cout<<good<<" "<<bad;
}

int32_t main() {
  IOS
  cout << fixed << setprecision(15);

  //freopen("agro.in", "r", stdin);
  //freopen("agro.out", "w", stdout);
  ttt = 1;
  input();
  while (ttt--) {
	solve();
  }
  return 0;

}