﻿#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O4")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tracer")
#pragma GCC target("sse2")
#pragma GCC target("sse3")
#pragma GCC target("popcnt")
#pragma GCC target("abm")
#pragma GCC target("mmx")
#pragma GCC target("tune=native")

using namespace std;

#define IOS ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define nl '\n'
#define no "NO"<<'\n'
#define yes "YES"<<'\n'
#define random sdagagdkasfsdkgsdkgm
#define x0 fslfmlasflsafsdka
#define y0 kdmsfdlfskflfdsfsf

const long long maxn = 1 << 18;
long double pi = acos(-1);
const long long mod = 1e9 + 7;

mt19937 mt((unsigned int)time(0));

inline int random() {
  return abs((int)mt());
}

#ifdef FFT

const int K = 18;


int rev[maxn];

complex < long double > root[maxn];

complex < long double > a[maxn], b[maxn], c[maxn], fa[maxn], fb[maxn], fc[maxn];

const complex < long double > im_one = {0, 1};

void init_roots( ) {

	for ( int k = 1; k < maxn; k *= 2 ) {
		complex < long double > temp = exp( pi * im_one / ( long double ) k );

		root[k] = {1, 0};

		for ( int i = 1; i < k; i++ ) {
			root[k + i] = (i & 1) ? root[(k + i) / 2] * temp : root[(k + i) / 2];
		}

	}
}

inline void init_rev( ) {
	for ( int i = 0; i < maxn; i++ ) {
		for ( int j = 0; j < K; j++ ) {
			rev[i] |= ((1 << (K - j - 1)) & i) ? (1 << j) : 0;
		}
	}

}

inline void fft( complex < long double > * poly, complex < long double > * f_poly ) {
	for ( int i = 0; i < maxn; i++ ) {
		f_poly[rev[i]] = poly[i];
	}


	for ( int k = 1; k < maxn; k *= 2 ) {
		for ( int i = 0; i < maxn; i += 2 * k ) {
			for ( int j = 0; j < k; j++ ) {
				complex < long double > temp = root[j + k] * f_poly[i + j + k];
				f_poly[i + j + k] = f_poly[i + j] - temp;
				f_poly[i + j] = f_poly[i + j] + temp;
			}
		}
	}

}

inline void reverse_fft( complex < long double > * f_poly, complex < long double > * poly ) {
	fft( f_poly, poly );

	reverse( poly + 1, poly + maxn );

	for ( int i = 0; i < maxn; i++ ) {
		poly[i] /= maxn;
	}
}

inline void init_fft( ) {

	init_rev( );
	init_roots( );
}

inline void reset_fft( ) {
	fill( a, a + maxn, 0 );
	fill( b, b + maxn, 0 );
	fill( c, c + maxn, 0 );
	fill( fa, fa + maxn, 0 );
	fill( fb, fb + maxn, 0 );
	fill( fc, fc + maxn, 0 );
}

#endif

#ifdef TREAP

struct item {
	int key, prior, cnt;
	item *l, *r;

	item(int key) : key(key), prior(random()), cnt(1), l(nullptr), r(nullptr) {};
};

typedef item *pitem;

int cnt(pitem t) {
	return t ? t->cnt : 0;
}

void upd_cnt(pitem t) {
	if (t)
		t->cnt = 1 + cnt(t->l) + cnt(t->r);
}

void split(pitem t, int key, pitem &l, pitem &r) {
	if (!t)
		l = r = nullptr;
	else if (key <= t->key)
		split(t->l, key, l, t->l), r = t;
	else
		split(t->r, key, t->r, r), l = t;
	upd_cnt(t);
}

void merge(pitem &t, pitem l, pitem r) {
	if (!l || !r)
		t = l ? l : r;
	else if (l->prior > r->prior)
		merge(l->r, l->r, r), t = l;
	else
		merge(r->l, l, r->l), t = r;
	upd_cnt(t);
}

pitem tree = nullptr;

#endif

template < typename C >
class graphdir {
 public:
  struct edge {
	edge(int a, int b, C d, C h) : from(a), to(b), c(d), f(h) {}

	int from, to;
	C c, f;
  };

  vector<vector<int> > adj;
  vector<edge> e;
  int s, t;

  int dist_to_t;

  vector<int> dist;
  vector<int> ptr;

  void init(int n, int sb, int tb) {
	adj.resize(n);
	dist.resize(n);
	ptr.resize(n);
	s = sb, t = tb;
  }

  void add(int a, int b, C c) {
	adj[a].push_back(e.size());
	e.push_back(edge(a, b, c, 0));
	adj[b].push_back(e.size());
	e.push_back(edge(b, a, 0, 0));
  }

  bool bfs(C upper) {
	fill(dist.begin(), dist.end(), -1);
	dist[s] = 0;
	queue<int> q;
	q.push(s);
	while (!q.empty()) {
	  int v = q.front();
	  q.pop();
	  for (int a : adj[v]) {
		edge x = e[a];
		if (x.c >= x.f + upper) {
		  if (dist[x.to] == -1) {
			dist[x.to] = dist[v] + 1;
			q.push(x.to);
		  }
		}
	  }
	}
	dist_to_t = dist[t];
	fill(ptr.begin(), ptr.end(), 0);
	return dist[t] != -1;
  }

  C dfs(int v, C flow) {
	if (abs(flow) <= 1e-9) {
	  return 0;
	}
	if (v == t) {
	  return flow;
	}
	if (dist[v] >= dist_to_t) {
	  return 0;
	}
	for (; ptr[v] < adj[v].size(); ptr[v]++) {
	  edge to = e[adj[v][ptr[v]]];
	  if (dist[to.to] != dist[v] + 1) {
		continue;
	  }
	  C pushed = dfs(to.to, min(flow, to.c - to.f));
	  if (pushed > 0) {
		e[adj[v][ptr[v]]].f += pushed;
		e[adj[v][ptr[v]] ^ 1].f -= pushed;
		return pushed;
	  }
	}

	return 0;
  }

  C dinic() {
	C upper = 1;
	for (edge x:e) {
	  while (upper < x.c) {
		upper *= 2;
	  }
	  x.f = 0;
	}
	C flow = 0;
	for (; upper > 0; upper /= 2) {
	  while (bfs(upper)) {
		while (true) {
		  C pushed = dfs(s, upper);
		  if (pushed >= 1e-6) {
			flow += pushed;
		  } else {
			break;
		  }
		}
	  }
	}
	return flow;
  }
};
class big_integer {
  static const int BASE = 1000000000;

  std::vector<int> _digits;

  bool _is_negative;

  void _remove_leading_zeros();

  void _shift_right();

 public:
  class divide_by_zero : public std::exception {
  };

  big_integer();

  big_integer(std::string);

  big_integer(signed char);

  big_integer(unsigned char);

  big_integer(signed short);

  big_integer(unsigned short);

  big_integer(signed int);

  big_integer(unsigned int);

  big_integer(signed long);

  big_integer(unsigned long);

  big_integer(signed long long);

  big_integer(unsigned long long);

  friend std::ostream &operator<<(std::ostream &, const big_integer &);

  operator std::string() const;

  const big_integer operator+() const;

  const big_integer operator-() const;

  const big_integer operator++();

  const big_integer operator++(int);

  const big_integer operator--();

  const big_integer operator--(int);

  friend bool operator==(const big_integer &, const big_integer &);

  friend bool operator<(const big_integer &, const big_integer &);

  friend bool operator!=(const big_integer &, const big_integer &);

  friend bool operator<=(const big_integer &, const big_integer &);

  friend bool operator>(const big_integer &, const big_integer &);

  friend bool operator>=(const big_integer &, const big_integer &);

  friend const big_integer operator+(big_integer, const big_integer &);

  big_integer &operator+=(const big_integer &);

  friend const big_integer operator-(big_integer, const big_integer &);

  big_integer &operator-=(const big_integer &);

  friend const big_integer operator*(const big_integer &, const big_integer &);

  big_integer &operator*=(const big_integer &);

  friend const big_integer operator/(const big_integer &, const big_integer &);

  big_integer &operator/=(const big_integer &);

  friend const big_integer operator%(const big_integer &, const big_integer &);

  big_integer &operator%=(const big_integer &);

  bool odd() const;

  bool even() const;

  const big_integer pow(big_integer) const;
};

big_integer::big_integer() {
  this->_is_negative = false;
}

big_integer::big_integer(std::string str) {
  if (str.length() == 0) {
	this->_is_negative = false;
  } else {
	if (str[0] == '-') {
	  str = str.substr(1);
	  this->_is_negative = true;
	} else {
	  this->_is_negative = false;
	}

	for (long long i = str.length(); i > 0; i -= 9) {
	  if (i < 9)
		this->_digits.push_back(atoi(str.substr(0, i).c_str()));
	  else
		this->_digits.push_back(atoi(str.substr(i - 9, 9).c_str()));
	}

	this->_remove_leading_zeros();
  }
}

void big_integer::_remove_leading_zeros() {
  while (this->_digits.size() > 1 && this->_digits.back() == 0) {
	this->_digits.pop_back();
  }

  if (this->_digits.size() == 1 && this->_digits[0] == 0) this->_is_negative = false;
}

std::ostream &operator<<(std::ostream &os, const big_integer &bi) {
  if (bi._digits.empty()) os << 0;
  else {
	if (bi._is_negative) os << '-';
	os << bi._digits.back();
	char old_fill = os.fill('0');
	for (long long i = static_cast<long long>(bi._digits.size()) - 2; i >= 0; --i) os << std::setw(9) << bi._digits[i];
	os.fill(old_fill);
  }

  return os;
}

bool operator==(const big_integer &left, const big_integer &right) {
  if (left._is_negative != right._is_negative) return false;
  if (left._digits.empty()) {
	if (right._digits.empty() || (right._digits.size() == 1 && right._digits[0] == 0)) return true;
	else return false;
  }

  if (right._digits.empty()) {
	if (left._digits.size() == 1 && left._digits[0] == 0) return true;
	else return false;
  }

  if (left._digits.size() != right._digits.size()) return false;
  for (size_t i = 0; i < left._digits.size(); ++i) if (left._digits[i] != right._digits[i]) return false;

  return true;
}

const big_integer big_integer::operator+() const {
  return big_integer(*this);
}

const big_integer big_integer::operator-() const {
  big_integer copy(*this);
  copy._is_negative = !copy._is_negative;
  return copy;
}

bool operator<(const big_integer &left, const big_integer &right) {
  if (left == right) return false;
  if (left._is_negative) {
	if (right._is_negative) return ((-right) < (-left));
	else return true;
  } else if (right._is_negative) return false;
  else {
	if (left._digits.size() != right._digits.size()) {
	  return left._digits.size() < right._digits.size();
	} else {
	  for (long long i = left._digits.size() - 1; i >= 0; --i) {
		if (left._digits[i] != right._digits[i]) return left._digits[i] < right._digits[i];
	  }

	  return false;
	}
  }
}

bool operator!=(const big_integer &left, const big_integer &right) {
  return !(left == right);
}

bool operator<=(const big_integer &left, const big_integer &right) {
  return (left < right || left == right);
}

bool operator>(const big_integer &left, const big_integer &right) {
  return !(left <= right);
}

bool operator>=(const big_integer &left, const big_integer &right) {
  return !(left < right);
}

const big_integer operator+(big_integer left, const big_integer &right) {
  if (left._is_negative) {
	if (right._is_negative) return -(-left + (-right));
	else return right - (-left);
  } else if (right._is_negative) return left - (-right);
  int carry = 0;
  for (size_t i = 0; i < std::max(left._digits.size(), right._digits.size()) || carry != 0; ++i) {
	if (i == left._digits.size()) left._digits.push_back(0);
	left._digits[i] += carry + (i < right._digits.size() ? right._digits[i] : 0);
	carry = left._digits[i] >= big_integer::BASE;
	if (carry != 0) left._digits[i] -= big_integer::BASE;
  }

  return left;
}

big_integer &big_integer::operator+=(const big_integer &value) {
  return *this = (*this + value);
}

const big_integer big_integer::operator++() {
  return (*this += 1);
}

big_integer::operator std::string() const {
  std::stringstream ss;
  ss << *this;
  return ss.str();
}

big_integer::big_integer(signed char c) {
  if (c < 0) this->_is_negative = true;
  else this->_is_negative = false;
  this->_digits.push_back(std::abs(c));
}

big_integer::big_integer(unsigned char c) {
  this->_is_negative = false;
  this->_digits.push_back(c);
}

big_integer::big_integer(signed short s) {
  if (s < 0) this->_is_negative = true;
  else this->_is_negative = false;
  this->_digits.push_back(std::abs(s));
}

big_integer::big_integer(unsigned short s) {
  this->_is_negative = false;
  this->_digits.push_back(s);
}

big_integer::big_integer(signed int i) {
  if (i < 0) this->_is_negative = true;
  else this->_is_negative = false;
  this->_digits.push_back(std::abs(i) % big_integer::BASE);
  i /= big_integer::BASE;
  if (i != 0) this->_digits.push_back(std::abs(i));
}

big_integer::big_integer(unsigned int i) {
  this->_digits.push_back(i % big_integer::BASE);
  i /= big_integer::BASE;
  if (i != 0) this->_digits.push_back(i);
}

big_integer::big_integer(signed long l) {
  if (l < 0) this->_is_negative = true;
  else this->_is_negative = false;
  this->_digits.push_back(std::abs(l) % big_integer::BASE);
  l /= big_integer::BASE;
  if (l != 0) this->_digits.push_back(std::abs(l));
}

big_integer::big_integer(unsigned long l) {
  this->_digits.push_back(l % big_integer::BASE);
  l /= big_integer::BASE;
  if (l != 0) this->_digits.push_back(l);
}

big_integer::big_integer(signed long long l) {
  if (l < 0) {
	this->_is_negative = true;
	l = -l;
  } else this->_is_negative = false;
  do {
	this->_digits.push_back(l % big_integer::BASE);
	l /= big_integer::BASE;
  } while (l != 0);
}

big_integer::big_integer(unsigned long long l) {
  this->_is_negative = false;
  do {
	this->_digits.push_back(l % big_integer::BASE);
	l /= big_integer::BASE;
  } while (l != 0);
}

const big_integer big_integer::operator++(int) {
  *this += 1;
  return *this - 1;
}

const big_integer big_integer::operator--() {
  return *this -= 1;
}

const big_integer big_integer::operator--(int) {
  *this -= 1;
  return *this + 1;
}

const big_integer operator-(big_integer left, const big_integer &right) {
  if (right._is_negative) return left + (-right);
  else if (left._is_negative) return -(-left + right);
  else if (left < right) return -(right - left);
  int carry = 0;
  for (size_t i = 0; i < right._digits.size() || carry != 0; ++i) {
	left._digits[i] -= carry + (i < right._digits.size() ? right._digits[i] : 0);
	carry = left._digits[i] < 0;
	if (carry != 0) left._digits[i] += big_integer::BASE;
  }

  left._remove_leading_zeros();
  return left;
}

big_integer &big_integer::operator-=(const big_integer &value) {
  return *this = (*this - value);
}

const big_integer operator*(const big_integer &left, const big_integer &right) {
  big_integer result;
  result._digits.resize(left._digits.size() + right._digits.size());
  for (size_t i = 0; i < left._digits.size(); ++i) {
	int carry = 0;
	for (size_t j = 0; j < right._digits.size() || carry != 0; ++j) {
	  long long cur = result._digits[i + j] +
		  left._digits[i] * 1LL * (j < right._digits.size() ? right._digits[j] : 0) + carry;
	  result._digits[i + j] = static_cast<int>(cur % big_integer::BASE);
	  carry = static_cast<int>(cur / big_integer::BASE);
	}
  }

  result._is_negative = left._is_negative != right._is_negative;
  result._remove_leading_zeros();
  return result;
}

big_integer &big_integer::operator*=(const big_integer &value) {
  return *this = (*this * value);
}

void big_integer::_shift_right() {
  if (this->_digits.size() == 0) {
	this->_digits.push_back(0);
	return;
  }
  this->_digits.push_back(this->_digits[this->_digits.size() - 1]);
  for (size_t i = this->_digits.size() - 2; i > 0; --i) this->_digits[i] = this->_digits[i - 1];
  this->_digits[0] = 0;
}

const big_integer operator/(const big_integer &left, const big_integer &right) {
  if (right == 0) throw big_integer::divide_by_zero();
  big_integer b = right;
  b._is_negative = false;
  big_integer result, current;
  result._digits.resize(left._digits.size());
  for (long long i = static_cast<long long>(left._digits.size()) - 1; i >= 0; --i) {
	current._shift_right();
	current._digits[0] = left._digits[i];
	current._remove_leading_zeros();
	int x = 0, l = 0, r = big_integer::BASE;
	while (l <= r) {
	  int m = (l + r) / 2;
	  big_integer t = b * m;
	  if (t <= current) {
		x = m;
		l = m + 1;
	  } else r = m - 1;
	}

	result._digits[i] = x;
	current = current - b * x;
  }

  result._is_negative = left._is_negative != right._is_negative;
  result._remove_leading_zeros();
  return result;
}

big_integer &big_integer::operator/=(const big_integer &value) {
  return *this = (*this / value);
}

const big_integer operator%(const big_integer &left, const big_integer &right) {
  big_integer result = left - (left / right) * right;
  if (result._is_negative) result += right;
  return result;
}

big_integer &big_integer::operator%=(const big_integer &value) {
  return *this = (*this % value);
}

bool big_integer::odd() const {
  if (this->_digits.size() == 0) return false;
  return this->_digits[0] & 1;
}

bool big_integer::even() const {
  return !this->odd();
}

const big_integer big_integer::pow(big_integer n) const {
  big_integer a(*this), result(1);
  while (n != 0) {
	if (n.odd()) result *= a;
	a *= a;
	n /= 2;
  }

  return result;
}

int ttt;

int d;
string p;
long long up;
long long dp;

long long c[4000];
long long sumsq[4000];
long long pr[4000];

long long pairpr[4000];

long long gettilldot(const string &a) {
  long long result = 0;
  for (char i : a) {
	if (i == '.') { break; }
	result = 10 * result + (i - '0');
  }
  return result;
}

long long getafterdot(const string &a) {
  long long result = 0;
  bool flag = false;
  int cnt = 0;
  for (char i : a) {
	if (i == '.') {
	  flag = true;
	  continue;
	}
	if (flag) {
	  cnt++;
	  result = 10 * result + (i - '0');
	}
  }
  for (int i = 0; i < 3 - cnt; i++) {
	result *= 10;
  }
  return result;
}

void input() {
  cin >> d >> p;
  long long f = gettilldot(p);
  long long s = getafterdot(p);
  up = f * 1000 + s;
  dp = 1000;

  for (int i = 1; i <= d; i++) {
	cin >> c[i];
	pr[i] = pr[i - 1] + c[i];
	sumsq[i] = sumsq[i - 1] + c[i] * c[i];
	pairpr[i] = pairpr[i - 1] + c[i - 1] * c[i];
  }
}

void solve() {
  int bad = 0, good = 0;
  for (int l = 1; l <= d; l++) {
	for (int r = l + 2; r <= d; r++) {
	  big_integer n = (r - l);
	  big_integer An = c[r] - c[l];
	  big_integer s1 = (sumsq[r] - sumsq[l]) * n * n;
	  big_integer s2 = (sumsq[r - 1] - sumsq[l - 1]) * n * n;
	  big_integer s3 = An * An * n;
	  big_integer s4 = 2 * n * n * (pairpr[r] - pairpr[l]);
	  big_integer s5 = 2 * An * n * (pr[r - 1] - pr[l - 1]);
	  big_integer s6 = 2 * An * n * (pr[r] - pr[l]);
	  big_integer S = s1 + s2 + s3 - s4 + s5 - s6;
	  if (An > 0 && S == 0) {
		good++;
		continue;
	  }
	  if (An < 0 && S == 0) {
		bad++;
		continue;
	  }
	  if (An >= 0) {
		if (An * An * n * dp * dp >= up * up * S) { good++; }
	  }
	  if (An <= 0) {
		big_integer nAn = -An;
		if (nAn * nAn * n * dp * dp >= up * up * S) { bad++; }
	  }
	}
  }
  cout << good << " " << bad;
}

int32_t main() {
  IOS
  cout << fixed << setprecision(15);

  //freopen("agro.in", "r", stdin);
  //freopen("agro.out", "w", stdout);
  ttt = 1;
  input();
  while (ttt--) {
	solve();
  }
  return 0;

}