#include <bits/stdc++.h>

#include <utility>

using namespace std;

using ll = long long int;
using ld = long double;
using ui = unsigned int;
using ull = unsigned long long;
using pp = pair<int, int>;
using tt = tuple<int, int, int>;

const int inf = (int) 1e9 + 1;
//const int mod = (int) 1e9 + 7;
const int mod = 998244353;
//const ll inf = (ll) 1e18;

#define umap unordered_map
#define uset unordered_set
#define Power ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define pb push_back

template<typename T>
T gcd(T a, T b) {
  return b ? gcd(b, a % b) : a;
}

template<typename T>
T lcp(T a, T b) {
  return a * b / gcd(a, b);
}

mt19937_64 mers((random_device()) ());

vector<ll> t;

void build(int v, int l, int r, const vector<ll> &a) {
  if (r <= l)
    return;
  if (r - l == 1) {
    t[v] = a[l];
  } else {
    int m = (r + l) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
  }
}

ll get(int v, int tl, int tr, int l, int r) {
  if (r <= l)
    return 0;
  if (tl == l && tr == r)
    return t[v];
  int m = (tl + tr) / 2;
  return get(2 * v + 1, tl, m, l, min(r, m)) +
         get(2 * v + 2, m, tr, max(l, m), r);
}

void solve() {
  int n;
  ld p;
  cin >> n >> p;
  vector<ll> a(n);
  for (auto &x : a)
    cin >> x;
  vector<ll> d(n - 1);
  for (int i = 0; i < n - 1; i++)
    d[i] = (a[i + 1] - a[i]) * (a[i + 1] - a[i]);
  t.resize(4 * d.size());
  build(0, 0, n - 1, d);
  ll x = 0, y = 0;
  for (int l = 0; l < n; l++) {
    for (int r = l + 2; r < n; r++) {
      ll s = a[r] - a[l];
      ll pr = get(0, 0, n - 1, l, r);
      ld tmp = ((r - l) * pr - s * s) * p * p;
      if (s > 0) {
        if (s * s >= tmp)
          x++;
      } else if (s < 0) {
        if (s * s >= tmp)
          y++;
      }
    }
  }
  cout << x << " " << y;
}

signed main() {

  Power;


#ifdef _DEBUG
  (void) freopen("input.txt", "r", stdin);
  (void) freopen("output.txt", "w", stdout);
#else
  //  (void)freopen("lwdb.in", "r", stdin);
  //  (void)freopen("lwdb.out", "w", stdout);
#endif

  int queue_counter = 1;
//  cin >> queue_counter;
  while (queue_counter--) {
    solve();
  }

  return 0;
}