#include <bits/stdc++.h>
//#define DEBUG
using namespace std;

typedef long long ll;

struct CAS
{
    int a, b, w;
    int a_id, b_id;
    int number;
    CAS(int i_a, int i_b, int i_w, int i_a_id, int i_b_id, int i_number):
    a(i_a), b(i_b), w(i_w), a_id(i_a_id), b_id(i_b_id), number(i_number) {};
};

void solveI()
{
    int s;
    cin >> s;
    double d = sqrt((double) s);
    for(int i = 0; i < d + 1; i++)
        for(int j = 0; j < d + 1; j++)
            if(i*i + j*j == s) {
                cout << 0 << ' ' << 0 << endl;
                cout << i << ' ' << j << endl;
                cout << j << ' ' << -i << endl;
                cout << i + j << ' ' << j - i << endl;
                return;
            }
    cout << "Impossible";

}



vector<int> eulerPath;
vector<vector<int> > g;
vector<int> global_ans;


void FindEulerPath(int v)
{
    int i = 0;
    while(i < g[v].size())
    {
//        cout << g[v].size() << "size\n";
        int u = g[v][i];
        g[v].erase(g[v].begin() + i);
        FindEulerPath(u);
        i++;

    }
    eulerPath.emplace_back(v);
}

void solveE()
{
    int n, c;
    cin >> n >> c;
    vector<CAS> CASes;

    unordered_map<int, int> vertices;
    unordered_set<int> s_vertices;
    int a, b, w, id = 0;
    for(int i = 0; i < n; i++)
    {
        cin >> a >> b >> w;

        if(s_vertices.find(a) == s_vertices.end()) {
            s_vertices.insert(a);
            vertices[a] = id;
            id++;
        }
        if(s_vertices.find(b) == s_vertices.end()) {
            s_vertices.insert(b);
            vertices[b] = id;
            id++;
        }
        int a_id = vertices[a], b_id = vertices[b];
        CASes.emplace_back(CAS(a, b, w, a_id, b_id, i));
    }

    unordered_map<int, unordered_map<int, vector<int> > > ordered_cases;
    unordered_map<int, vector<int>> ordered_cases_negative;
    for(auto i: CASes)
        if(i.w)
            ordered_cases[i.a_id][i.b_id].emplace_back(i.number);
        else
            ordered_cases_negative[i.a_id].emplace_back(i.number);




    g.resize(id);
    vector<pair<int, int> > deg(id);
//    cout << "here1\n";
    for(CAS i: CASes){
        if(i.w) {
            g[i.a_id].emplace_back(i.b_id);
            deg[i.a_id].first++;
            deg[i.b_id].second++;
        }
    }
//    cout << "here2\n";

//    for(auto i: deg)
//        cout << i.first << ' ' << i.second << '\n';

    int c1 = 0, c2 = 0, i1 = -1, i2 = -1;
    for(int i = 0; i < id; i++) {
        if (abs(deg[i].first - deg[i].second) > 1) {
            cout << "No";
            return;
        }
        if(deg[i].first - deg[i].second == 1)
        {
            c1++;
            i1 = i;
        }
        if(deg[i].first - deg[i].second == -1)
        {
            c2++;
            i2 = i;
        }
        if(c1 > 1 or c2 > 1)
        {

            cout << "No";
            return;
        }
    }
    if(c1 == c2 && c1 == 1) {
        if (i1 != vertices[c]) {
            cout << "No";
            return;
        }

    else{
        if(deg[i1].first == 0)
        {
            cout << "No";
            return;
        }
    }
    }
//    cout << "here3";
    bool extra_edge = false;
    if(c1 == c2 && c1 == 1) {
//        pair<int, int> critical_edge = {i2, i1};
        extra_edge = true;
//        cout << i1 << ' ' << i2 << "___\n";
        deg[i2].first++;
        deg[i1].second++;
        g[i2].emplace_back(i1);
    }

//    for(auto i: deg)
//        cout << i.first << ' ' << i.second << '\n';

    FindEulerPath(vertices[c]);
//    for(auto i: eulerPath)
//        cout << i;

    reverse(eulerPath.begin(), eulerPath.end());
    if(extra_edge)
        eulerPath.pop_back();
//    for(auto i: eulerPath)
//        cout << i + 1 << ' ';

    vector<int> pp;
    for(auto ggg: ordered_cases_negative)
        if(ggg.first != eulerPath[0])
        {
            for(auto h: ggg.second) {
                global_ans.emplace_back(h + 1);
//                cout << h + 1 << ' ';
//                ordered_cases_negative[ggg.first].erase(ggg.second.begin());
            }
            pp.emplace_back(ggg.first);
        }
    for(auto i: pp)
        ordered_cases_negative.erase(i);

    int eeeee = 0;
    for(int i = 1; i < eulerPath.size(); i++)
    {
        int current = eulerPath[i], prev = eulerPath[i - 1];
        eeeee = current;
        pp.clear();
        for(auto ggg: ordered_cases_negative)
            if(ggg.first != prev)
            {
                for(auto h: ggg.second) {
//                    cout << h + 1 << ' ';
                    global_ans.emplace_back(h + 1);
//                ordered_cases_negative[ggg.first].erase(ggg.second.begin());
                }
                pp.emplace_back(ggg.first);
            }
        for(auto j: pp)
            ordered_cases_negative.erase(j);


//        cout << ordered_cases[prev][current][0] + 1 << ' ';
            global_ans.emplace_back(ordered_cases[prev][current][0] + 1);
        ordered_cases[prev][current].erase(ordered_cases[prev][current].begin());
    }
    pp.clear();
    for(auto ggg: ordered_cases_negative)
        if(ggg.first != eeeee)
        {
            for(auto h: ggg.second) {
//                    cout << h + 1 << ' ';
                global_ans.emplace_back(h + 1);
//                ordered_cases_negative[ggg.first].erase(ggg.second.begin());
            }
            pp.emplace_back(ggg.first);
        }
    for(auto i: pp)
        ordered_cases_negative.erase(i);

    if(!ordered_cases_negative.empty()) {

        cout << "No";
        return;
    }
    cout << "Yes" << endl;
    for(auto i: global_ans)
        cout << i << ' ';


}




int main() {
    void (*solve)() = solveE;

#ifdef DEBUG
    const char* filename = "E.txt";
    freopen(filename, "r", stdin);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++) {
        eulerPath.clear();
        g.clear();
        global_ans.clear();
        solve();
        cout << "\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
    }
#endif
#ifndef DEBUG
    solve();
#endif
    return 0;
}