#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> a;

int binarySearch(int start, int maxDist) {
    int l = start - 1, r = a.size();
    while (r - l > 1) {
        int m = l + (r - l) / 2;
        if (a[m] - a[start] <= maxDist) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

main() {
    int n;
    cin >> n;
    a.resize(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    int maxDist = -1;
    for (int i = 1; i <= n; ++i) {
        maxDist = max(maxDist, a[i] - a[i - 1]);
    }
    for (int i = 0; i < n; ++i) {
        int lastPosition = binarySearch(i, maxDist);
        if (lastPosition != i + 1) {
            cout << 0;
            return 0;
        }
    }
    cout << maxDist;
    return 0;
}