#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;

int main() 
{
    ll n, w, h, s;
    cin >> n >> w >> h >> s;
    vector<vector<ll>> res;
    res.resize(h);
    for (int i = 0; i < h; i++) res[i].resize(n);
    vector<vector<char>> sym;
    vector<char> sym_char;
    sym.resize(h);
    for (int j = 0; j < h; j++) sym[j].resize(w);
    for (int i = 0; i < n; i++)
    {
        char t;
        cin >> t;
        sym_char.push_back(t);
        for (int j = 0; j < h; j++)
            for (int k = 0; k < w; k++)
            {
                char c;
                cin >> c;
                sym[j][k] = c;
            }
        for (int j = 0; j < h; j++)
        {
            ll sw = 0;
            for (int k = 0; k < w - 1; k++)
            {
                if (sym[j][k] != sym[j][k + 1]) sw++;
            }
            if (sym[j][0] == '#') sw++;
            if (sym[j][w - 1] == '#') sw++;
            res[j][i] = sw;
        }
    }
    vector<vector<ll>> resT;
    resT.resize(n);
    for (int i = 0; i < n; i++) resT[i].resize(h);
    for (int i = 0; i < h; i++)
    {
        for (int j = 0; j < n; j++)
            resT[j][i] = res[i][j];
    }
    vector<ll> compare;
    compare.resize(n);
    for (int i = 0; i < n; i++)
    {
        compare[i] = *std::max_element(resT[i].begin(), resT[i].end());
    }
    int maxElementIndex = std::max_element(compare.begin(), compare.end()) - compare.begin();
    int maxElement = *std::max_element(compare.begin(), compare.end());
    while (s > 0)
    {
        s -= maxElement;
        cout << sym_char[maxElementIndex];
    }
    return 0;
}