#include <iostream>
#include <string>
#include <functional>
#include <map>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;

struct op {
    ll a, b, w, id;
};


int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    ll n, c;
    cin >> n >> c;

    vector<op> ops;

    for (ll i = 0; i < n; ++i) {
        op o;
        cin >> o.a >> o.b >> o.w;
        o.id = i;
        ops.push_back(o);
    }

    vector<ll> k1, k2;
    map<ll, vector<op>> g;
    map<ll, ll> ind;
    map<ll, ll> skip;
    set<ll> all;

    for (auto &o : ops) {
        if (o.w == 1) {
            g[o.a].push_back(o);
            ind[o.b]++;
            all.insert(o.a);
            all.insert(o.b);
            continue;
        }
        if (o.a == c) k2.push_back(o.id); else k1.push_back(o.id);
    }

    vector<ll> bad;

    for (auto from : all) {
        if (g[from].size() != ind[from]) {
            bad.push_back(from);
        }
    }

    bool kek = false;

    if (!bad.empty()) {
        if (bad.size() != 2) {
            cout << "No\n";
            return 0;
        }
        ll a = bad[0];
        ll b = bad[1];
        if (ind[a] > g[a].size()) swap(a, b);

        if (ind[a] + 1 != g[a].size()) { cout << "No\n"; return 0; }
        if (ind[b] - 1 != g[b].size()) { cout << "No\n"; return 0; }
        op o;
        o.id = -1;
        o.a = b;
        o.b = a;
        g[b].push_back(o);
        kek = true;
    }

    ll v = c;
    
    while (1) { 
        auto &tov = g[v];
        auto &sk = skip[v];
        if (v != c && !k2.empty()) {
            for (ll x : k2) {
                k1.push_back(x);
            }
            k2.clear();
        }
        if (sk < tov.size()) {
            k1.push_back(tov[sk].id);
            v = tov[sk].b;
            ++sk;
        } else {
            break;
        }
    }

    ll expected = n;
    if (kek) expected++;

    if (k1.size() == expected) {
        cout << "Yes\n";
        if (kek) {
            bool z = false;
            for (ll x : k1) {
                if (x == -1) {
                    z = true;
                    continue;
                }
                
                if (z) cout << x + 1 << ' ';
            }

            for (ll x : k1) {
                if (x == -1) break;
                cout << x + 1 << ' ';
            }
        } else {
            for (ll x : k1) {
                cout << x + 1 << ' ';
            }
        }
        cout << "\n";
    } else {
        cout << "No" << endl;
        return 0;
    }

    return 0;
}
