#include <iostream>
#include <string>
#include <functional>
#include <map>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;

struct op {
    ll a, b, w, id;
};


int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    ll n, c;
    cin >> n >> c;

    vector<op> ops;

    for (ll i = 0; i < n; ++i) {
        op o;
        cin >> o.a >> o.b >> o.w;
        o.id = i;
        ops.push_back(o);
    }

    vector<ll> k1, k2;
    map<ll, vector<op>> g;
    map<ll, ll> ind;
    map<ll, ll> skip;
    set<ll> all;

    for (auto &o : ops) {
        if (o.w == 1) {
            g[o.a].push_back(o);
            ind[o.b]++;
            all.insert(o.a);
            all.insert(o.b);
            continue;
        }
        if (o.a == c) k2.push_back(o.id); else k1.push_back(o.id);
    }

    vector<ll> bad;

    for (auto from : all) {
        if (g[from].size() != ind[from]) {
            bad.push_back(from);
        }
    }

    bool kek = false;

//    if (!bad.empty()) {
//        if (bad.size() != 2) {
//            cout << "No\n";
//            return 0;
//        }
//        ll a = bad[0];
//        ll b = bad[1];
//        if (ind[a] > g[a].size()) swap(a, b);
//
//        if (ind[a] + 1 != g[a].size()) { cout << "No\n"; return 0; }
//        if (ind[b] - 1 != g[b].size()) { cout << "No\n"; return 0; }
//        op o;
//        o.id = -1;
//        o.a = b;
//        o.b = a;
//        g[b].push_back(o);
//        kek = true;
//        cerr << b << "->" << a << endl;
//    }

    vector<ll> k0;

    function<void(ll)> dfs = [&](ll v) {
        auto &tov = g[v];
        auto &sk = skip[v];
        while (sk < tov.size()) {
            ll oldsk = sk;
            sk++;
            dfs(tov[oldsk].b);
            k0.push_back(tov[oldsk].id);
        }
    };

    dfs(c);

    reverse(k0.begin(), k0.end());

    vector<ll> zz;

    if (kek) {
        bool z = false;
        zz = k1;
        for (ll x : k0) {
            if (x == -1) {
                z = true;
                continue;
            }
            
            if (z) zz.push_back(x);
        }

        for (ll x : k0) {
            if (x == -1) break;
            zz.push_back(x);
        }
    } else {
        zz = k1;
        for (ll x : k0) {
            zz.push_back(x);
        }
    }

    vector<ll> zz2;

    bool fail = false;
    ll v = c;
    for (ll x : zz) {
        zz2.push_back(x);
        auto o = ops[x];
        if (o.a == v) {
            v = o.b;
            if (o.w == 0) {
                fail = true;
                break;
            }
        } else if (o.w == 1) {
            fail = true;
            break;
        }

        if (v != c) {
            for (ll i : k2) {
                zz2.push_back(i);
            }
            k2.clear();
        }
    }

    if (fail || !k2.empty() || zz2.size() != n) {
        cout << "No" << endl;
        return 0;
    }

    cout << "Yes\n";
    for (ll x : zz2) {
        cout << x + 1 << ' ';
    }
    cout << "\n";

    return 0;
}
