﻿#include <iostream>
#include <fstream>
#include <cstdio>

#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>

#include <functional>
#include <utility>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <iomanip>

#include <cassert>
#include <random>
#include <chrono>

#include <complex>

using namespace std;

#define ll int
#define ld long double
#define prll pair<ll,ll>
#define m_p make_pair
#define INF (ll)1e18
#define sup (ll)ULLONG_MAX

const ll q = 239017;
const ll mod = 1e9 + 7;
const ll mod2 = 1e9 + 13;
const ll N = 1e5 + 100;
const ll M = 3e5 + 100;
const ll L = 26;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

//tsl::robin_map<ll, vector<prll>> g;
//tsl::robin_map<ll, char> used1;
//map<ll, vector<prll>> g;
map<ll, char> used1;

vector<prll> g[N];
ll used[N];

vector<ll> orda, lil;
void dfs(ll v, ll id) {
	used[id] = 1;
	orda.push_back(id);
	lil.push_back(v);
	while (true) {
		ll cur = lil.back();
		bool flag = 0;
		for (auto el : g[cur]) {
			if (used[el.second])continue;
			flag = true;
			dfs(el.first, el.second);
			break;
		}
		if (!flag)break;
	}
}

void $main()
{
	ll n, c; cin >> n >> c;
	ll m = 0;

	ll it = 0;
	if (used1.find(c) == used1.end()) {
		used1[c] = it++;
	}
	//tsl::robin_map<ll, vector<ll>> class_vichetov;
	map<ll, vector<ll>> class_vichetov;
	for (ll i = 0; i < n; ++i) {
		ll u, v, w; cin >> u >> v >> w;

		if (used1.find(u) == used1.end()) {
			used1[u] = it++;
		}

		if (used1.find(v) == used1.end()) {
			used1[v] = it++;
		}

		if (!w)
			class_vichetov[used1[u]].emplace_back(i);
		else
			g[used1[u]].emplace_back(used1[v], i), m++;
	}

	lil.push_back(used1[c]);
	while (true) {
		ll cur = lil.back();
		bool flag = 0;
		for (auto el : g[cur]) {
			if (used[el.second])continue;
			flag = true;
			dfs(el.first, el.second);
			break;
		}
		if (!flag)break;
	}

	if ((ll)orda.size() != m) {
		cout << "No";
		exit(0);
	}

	vector<ll> ans;
	ll cur = 0;
	it = 0;
	while (it < (ll)lil.size()) {
		cur = lil[it];

		vector<ll> del;
		for (auto el : class_vichetov) {
			if (el.first != cur) {
				del.push_back(el.first);
				for (ll che : class_vichetov[el.first])
					ans.push_back(che);
			}
		}
		for (ll el : del)
			class_vichetov.erase(el);

		if (it < (ll)orda.size()) {
			ans.push_back(orda[it]);
		}
		++it;
	}

	if (!class_vichetov.empty()) {
		cout << "No";
		exit(0);
	}

	cout << "Yes\n";
	for (ll el : ans)
		cout << el + 1 << " ";
}

int main()
{
#ifndef ONLINE_JUDGE
	//freopen("input.txt", "r", stdin);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	$main();

	return 0;
}