#include <bits/stdc++.h>

#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define ll long long
#define ld double

using namespace std;
mt19937_64 rnd(std::chrono::system_clock::now().time_since_epoch().count());

const int N = 55;
ll C[N][N];

ll getPali(ll n, ll k) {
    ll ans = 0;
    if (k % 2 == 0) {
        ans += C[n / 2][k / 2];
    } else {
        if (n % 2) {
            ans += C[n / 2][(k - 1) / 2];
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    cout.setf(ios::fixed), cout.precision(10);

    for (int i = 0; i < N; ++i) {
        C[i][i] = C[i][0] = 1;
        for (int j = 1; j < i; ++j) {
            C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
        }
    }

    int n, k;
    cin >> n >> k;

    ll ans = 0;

    for (int i = 0; i <= min(n, k); ++i) {
        if (k - i > n) continue;
        ll x = getPali(n, i);
        ll c = (C[n][i] - x) / 2 + x;
        if (k - i == i) {
            ans += 2 * c;
        } else {
            ans += c;
        }
    }
    cout << ans << "\n";

    return 0;
}