#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#include <unordered_map>
#include <immintrin.h>
#include <functional>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <fstream>
#include <stdio.h>
#include <complex>
#include <iomanip>
#include <climits>
#include <bitset>
#include <math.h>
#include <string>
#include <random>
#include <vector>
#include <time.h>
#include <chrono>
#include <queue>
#include <deque>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <db, db> pdd;
typedef complex <double> cmpl;

const ll MOD = (ll)1e9 + 7;
const ll MOD1 = 2286661337;
const ll MOD2 = 998244353;
const int INF = (int)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)1e5;

struct CAS {
    int a, b, w;

    CAS(int a = 0, int b = 0, int w = 0) : a(a), b(b), w(w) {}
};

int n, c, cnt_edge;
CAS a[N + 1];
map <int, vector <int>> G;
map <int, int> cnt_in;
bool deleted_[N + 1];
vector <int> euler_path, res;

void find_euler_path(int v = c, int ind_back_edge = -1) {
    for (int ind : G[v]) {
        if (deleted_[ind]) {
            continue;
        }
        int u = a[ind].b;
        deleted_[ind] = true;
        find_euler_path(u, ind);
    }
    if (ind_back_edge != -1) {
        euler_path.push_back(ind_back_edge);
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d%d", &n, &c);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", &a[i].a, &a[i].b, &a[i].w);
        if (a[i].w) {
            G[a[i].a].push_back(i);
            ++cnt_in[a[i].b];
            ++cnt_edge;
        }
    }
    int start = -1, end_ = -1;
    for (auto elem : G) {
        if (elem.second.size() != cnt_in[elem.first]) {
            if (elem.second.size() == cnt_in[elem.first] + 1) {
                if (start == -1) {
                    start = elem.first;
                } else {
                    printf("No");
                    return 0;
                }
            } else if (elem.second.size() + 1 == cnt_in[elem.first]) {
                if (end_ == -1) {
                    end_ = elem.first;
                } else {
                    printf("No");
                    return 0;
                }
            } else {
                printf("No");
                return 0;
            }
        }
    }
    if (start != -1 && end_ != -1) {
        if (start != c) {
            printf("No");
            return 0;
        }
        G[end_].push_back(n);
        a[n].a = end_, a[n].b = start, a[n].w = 1;
        ++cnt_edge;
    }
    //assert(start_ == -1 )
    bool has_c = false;
    for (int i = 0; i < n; ++i) {
        if (a[i].w == 0) {
            if (a[i].a == c) {
                has_c = true;
            } else {
                res.push_back(i + 1);
            }
        }
    }
    int ind_for_c = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i].w == 1) {
            if (a[i].b != c) {
                ind_for_c = i;
                break;
            }
        }
    }
    if (has_c && ind_for_c == -1) {
        printf("No");
        return 0;
    }
    find_euler_path();
    if (euler_path.size() != cnt_edge) {
        printf("No");
        return 0;
    }
    reverse(euler_path.begin(), euler_path.end());
    int erase_ind = -1;
    for (int i = 0; i < euler_path.size(); ++i) {
        if (euler_path[i] == n) {
            erase_ind = i;
            break;
        }
    }
    if (erase_ind != -1) {
        vector <int> h;
        for (int i = (erase_ind + 1) % euler_path.size(); i != erase_ind; i = (i + 1) % euler_path.size()) {
            h.push_back(euler_path[i]);
        }
        euler_path = h;
    }
    for (int i = 0; i < euler_path.size(); ++i) {
        res.push_back(euler_path[i] + 1);
        if (euler_path[i] == ind_for_c) {
            for (int j = 0; j < n; ++j) {
                if (a[j].w == 0 && a[j].a == c) {
                    res.push_back(j + 1);
                }
            }
        }
    }
    printf("Yes\n");
    for (int elem : res) {
        printf("%d ", elem);
    }
    return 0;
}
