#include <iostream>
#include <algorithm>
#include <queue>
#include <numeric>
#include <cassert>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run() {
    int s;
    cin >> s;
    for (int a = 0; a * a <= s; a++) {
        for (int b = 0; b * b <= s; b++) {
            if (a * a + b * b == s) {
                printf("%d %d\n%d %d\n%d %d\n%d %d", 0, 0, a, b, -b, a, a - b, a + b);
                return;
            }
        }
    }
    cout << "Impossible";
}

int main() {
    //ios::sync_with_stdio(false);
    cout.tie(0);
    cout.precision(10);
    cout << fixed;
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++)
        run();
}
