#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <iomanip>
#include <stack>
#include <queue>
#include <string>
#include <cmath>
#include <map>
#include <random>
#include <chrono>

using namespace std;

#define pb push_back
#define f first
#define s second
#define pii pair <int, int>
 
typedef long long ll;
typedef long double ld;
typedef vector <int> vi;

const int MAXN = 1e6 + 10;
ll INF = 1e9 + 10;
ll MOD = 1e9 + 7;
ld EPS = 1e-12;

void fastIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n;

bool q(int x, int y) {
    cout << x + 1 << ' ' << y + 1 << endl;
    string s;
    cin >> s;
    if (s == "WIN")
        exit(0);
    return s == "SWAPPED";
}

int main() {
    fastIO();
    cin >> n;
    for (int i = 0; i < n; i++) {
        int num_op_done = 0;
        bool broken = 0;
        for (int j = 0; j < i - 1; j++) {
            bool res = q(j, j + 1);
            num_op_done++;
            if (res) {
                for (int k = j + 2; k < n; k++) {
                    res = q(j, k);
                    num_op_done++;
                    if (res) {
                        q(j + 1, k);
                        num_op_done++;
                        break;
                    }
                }
                broken = 1;
                break;
            }
        }
        if (i > 0 && !broken) {
            for (int k = i; k < n; k++) {
                q(i - 1, k);
                num_op_done++;
            }
        }
        for (int j = i + 1; j < n; j++) {
            q(i, j);
            num_op_done++;
        }
        for (int j = 0; j < 2 * n - num_op_done; j++) {
            q(n - 2, n - 1);
        }
    }


    return 0;
}