#include <cassert>
#include <utility>
#include <tuple>
#include <iostream>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cstring>

using namespace std;
typedef long long ll;

//#define int ll

#define sz(x) (int)x.size()
#define pb push_back
#define eb emplace_back
#define agn assign
#define DEBUG(x) cerr << #x << ": " << x << "\n";
#define F first
#define S second

#define BOUNDS_1(x, n) (x >= 0 && x < n)
#define BOUNDS_2(x, n) (x > 0 && x <= n)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<double, int> pdi;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int INF = 1000 * 1000 * 1000 + 10;
//const int M = 1000 * 1000 * 1000 + 7;
const ll INFLL = 1000ll * 1000 * 1000 * 1000 * 1000 * 1000;

typedef tuple<int, int, int> tiii;
typedef vector<tiii> vtiii;

const int N = 1e5 + 5;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n;
    cin >> n;

    vi a(n);
    for (int &t : a)
        cin >> t;

    a.pb(0);
    sort(ALL(a));

    int b = 0, c = INF;
    for (int i = 1; i <= n; ++i) {
        b = max(b, a[i] - a[i - 1]);
        if (i >= 2)
            c = min(c, a[i] - a[i - 2]);
    }

    if (c > b)
        cout << b << "\n";
    else
        cout << "0\n";
}
