// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")
 
#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <algorithm>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <numeric>
#include <time.h>
#include <stack>
#include <bitset>
#include <sstream>

#define prev asasddlsa
#define rank aljds

#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, r, l) for (int i = r; i >= l; i++)
 
using namespace std;
 
typedef long long ll;
typedef long double dbl;
 
template<typename T>
void print(const vector<T>& s){
    for (auto x : s)
        cout << x << " ";
    cout << endl;
}
 
template<class T>   
void print(const T* s, int n){
    for (int i = 0; i < n; i++)
        cout << s[i] << ' ';
    cout << endl;
}

template<class T>
void print(vector<vector<T>> s){
    for (int i = 0; i < s.size(); i++)
        print(s[i]);
}

const int maxn = 2e5 + 7;

int cur[maxn];
vector<pair<int, int>> s[maxn];
vector<int> euler, ans;
int in[maxn], out[maxn];


void dfs(int v){
    // cout << v << endl;
    // cout << 
    while (cur[v] < s[v].size()){
        auto p = s[v][cur[v]++];
        dfs(p.first);
        euler.push_back(v);
        ans.push_back(p.second);
    }
}

set<pair<int, int>> kek;

int buildGraph(vector<pair<int, int>> lst, vector<int> w, int v){
    vector<int> values{v};
    for (auto x : lst){
        values.push_back(x.first);
        values.push_back(x.second);
    }
    sort(values.begin(), values.end());
    values.resize(unique(values.begin(), values.end()) - values.begin());
    for (int i = 0; i < lst.size(); i++){
        int t = lower_bound(values.begin(), values.end(), lst[i].first) - values.begin();
        int u = lower_bound(values.begin(), values.end(), lst[i].second) - values.begin();
        if (w[i] == 0)
            kek.insert({t, i});
        else {
            s[t].push_back({u, i});
            out[t]++, in[u]++;
        }
    }
    int n = values.size();
    int cntIns = 0, cntOuts = 0;
    int inn, outt;
    for (int t = 0; t < n; t++){
        if (in[t] == out[t] + 1 && in[t] != out[t] && in[t] - 1 != out[t]){
            cout << "No\n";
            exit(0);
        }
        if (in[t] == out[t] + 1){
            cntIns++;
            inn = t;
        }
        if (in[t] - 1 == out[t]){
            cntOuts++;
            outt = t;
        }
    }
    if (cntIns > 1 || cntOuts > 1 || cntIns != cntOuts){
        cout << "No\n";
        exit(0);
    }
    v = lower_bound(values.begin(), values.end(), v) - values.begin();
    // cout << v << ' ' << in[v] << ' ' << out[v] << endl;
    if (out[v] != in[v] + 1 && (in[v] == out[v] && cntIns > 0)){
        cout << "No\n";
        exit(0);
    }
    if (cntIns == 1)
        s[inn].push_back({outt, -1});
    return v;
}

void solve(){
    int n, v;
    cin >> n >> v;
    vector<pair<int, int>> s(n);
    vector<int> w(n);
    for (int i = 0; i < n; i++)
        cin >> s[i].first >> s[i].second >> w[i];
    v = buildGraph(s, w, v);
    dfs(v);
    reverse(ans.begin(), ans.end());
    reverse(euler.begin(), euler.end());
    assert(ans.size() == euler.size());
    assert(euler[0] == v);
    int prevv = 0, r = 1;
    for (int i = 0; i < ans.size(); i++){
        if (euler[i] == v)
            prevv = i;
        if (ans[i] == -1)
            r = i + 1;
    }
    vector<int> res, vv;
    for (int i = 0; i < prevv + 1; i++){
        res.push_back(ans[i]);
        vv.push_back(euler[i]);
    }
    for (int i = r; i < ans.size(); i++){
        res.push_back(ans[i]);
        vv.push_back(euler[i]);        
    }
    for (int i = prevv + 1; i < r; i++){
        res.push_back(ans[i]);
        vv.push_back(euler[i]);        
    }
    vector<int> toprint;
    for (int i = 0; i < res.size(); i++){
        while (kek.size() && kek.begin()->first != vv[i]){
            auto p = *kek.begin();
            kek.erase(p);
            toprint.push_back(p.second + 1);
        }
        while (kek.size() && kek.rbegin()->first != vv[i]){
            auto p = *kek.rbegin();
            kek.erase(p);
            toprint.push_back(p.second + 1);
        }
        if (res[i] != -1)
            toprint.push_back(res[i] + 1);
    }
    if (kek.size())
        cout << "No\n";
    else
        print(toprint);
}

int main(){
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(13);
    cout << fixed;
    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; i++)
        solve();
    return 0;
}
