from copy import deepcopy
import itertools

import sys
sys.setrecursionlimit(1000000)

letterCount = 8

def isspace(c):
    return c == ' ' or c == '(' or c == ')'

def replace(expression_, occurences, values):
    expression = [x for x in expression_]
    for i in range(letterCount):
        for c in occurences[i]:
            expression[c] = str(values[i])
    return ''.join(expression)

def issub(b, a):
    for c in b:
        if c not in a:
            return False
    return True

def parse(expression_):
    expression = ' ' + expression_ + ' '
    occurences = [[] for i in range(letterCount)]
    for i, c in enumerate(expression):
        if c in 'abcdefgh':
            if isspace(expression[i - 1]) and isspace(expression[i + 1]):
                occurences[ord(c) - ord('a')].append(i)

    values, res = [], []
    for i in itertools.product([0, 1], repeat=letterCount):
        values.append(deepcopy(i))
        # print(occurences[0])
        # print(replace(expresssion, occurences, i))
        res.append(eval(replace(expression, occurences, i)))

    for i, val1 in enumerate(values):
        for j, val2 in enumerate(values):
            ok = True
            for k in range(letterCount):
                if val1[k] > val2[k]:
                    ok = False
            if ok and res[i] > res[j]:
                print('IMPOSSIBLE')
                exit(0)

    dis = set()
    for i in range(len(values) - 1, -1, -1):
        val = values[i]
        if res[i] == 0:
            t = 'abcdefgh'
            kek = ''
            for k in range(letterCount):
                if val[k] == 0:
                    kek += t[k]
            ok = True
            for lol in dis:
                if issub(lol, kek):
                    ok = False
            if ok:
                dis.add(kek)
    return dis


vals = list(parse(input()))


n = 50
a = [[' '] * n for i in range(n)]

tot = 0

pos = []

for num in range(5):
    sy = num * 10
    for i in range(num + 1, n - (4 - num)):
        tot += 1
        a[i][sy] = '+'
        ccc = 7 if num < 4 else 8
        ttt = []
        for j in range(ccc):
            ttt.append((i, sy + 1 + j))
            a[i][sy + 1 + j] = '-'
        pos.append(ttt)
        a[i][sy + 1 + ccc] = '+'

for j in range(n):
    if j != 48 and (j == 49 or j % 10 == 0 or j % 10 == 8):
        a[0][j] = '+'
        if j % 10 != 0:
            for i in range(1, n):
                if (a[i][j] == ' '):
                    a[i][j] = '|'
                else:
                    break
    elif j >= 9:
        a[0][j] = '-'

for i in range(0, n):
    if (a[i][0] == ' '):
        a[i][0] = '+'
        for j in range(1, n):
            if a[i][j] == ' ':
                a[i][j] = '-'
            else:
                break


#vals = ['ab', 'ac']
vals.sort(key=lambda x: len(x))
vals = vals[::-1]
pos = pos[::-1]

for i in range(len(pos)):
    if i < len(vals):
        for j in range(len(pos[i])):
            x, y = pos[i][j]
            if j < len(vals[i]):
                a[x][y] = vals[i][j]
    else:
        for x, y in pos[i]:
            a[x][y] = ' '

#print(tot)

for i in range(n):
    print(''.join(a[i]))

# for i in pos:
#     print(i)
