//#define FAKE
#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

int n;

#ifdef FAKE

vector<int> secret;
vector<int> revsec;

void init()
{
	cin >> n;
	secret.resize(n);
	revsec.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> secret[i];
		revsec[secret[i] - 1] = i + 1;
	}
}

vector<int> req(vector<int> req_a)
{
	vector<int> ret;
	for (int i = 0; i < n; i++)
		ret.push_back(secret[req_a[revsec[i] - 1] - 1]);
	cout << "? ";
	for (int i : req_a)
		cout << i << " ";
	cout << "\n";
	for (int i : ret)
		cout << i << " ";
	cout << "\n";
	return ret;
}

void submit(vector<int> ans)
{
	cout << "! ";
	for (int i : ans)
		cout << i << " ";
	if (ans == secret)
		cout << "OK\n";
	else if (ans == revsec)
		cout << "REVERSED\n";
	else
		cout << "BAD\n";
}

#else

void init()
{
	cin >> n;
}

vector<int> req(vector<int> req_a)
{
	cout << "? ";
	for (int i : req_a)
		cout << i << " ";
	cout << endl;
	vector<int> ret(n);
	for (int &i : ret)
		cin >> i;
	return ret;
}

void submit(vector<int> ans)
{
	cout << "! ";
	for (int i : ans)
		cout << i << " ";
	cout << endl;
}

#endif

int main()
{

	int T;
	cin >> T;
	while (T--)
	{
		init();
		//req({ 3, 2, 1, 4 });
		vector<int> req_a;
		req_a.push_back(1);
		for (int i = 3; i <= n; i++)
		{
			req_a.push_back(i);
		}
		req_a.push_back(2);
		vector<int> arr = req(req_a);
		int v0 = 0;
		for (int i = 0; i < n; i++)
			if (arr[i] == i + 1)
				v0 = i + 1;
		//assert(v0);
		req_a.clear();
		for (int i = 2; i <= n; i++)
		{
			req_a.push_back(i);
		}
		req_a.push_back(1);
		arr = req(req_a);
		vector<int> ans;
		for (int t = v0, cnt = 0; cnt < n; cnt++)
		{
			ans.push_back(t);
			t = arr[t - 1];
		}
		submit(ans);
	}
	return 0;
}