#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int v;
    int id;
};


void dfs(int s, vector<vector<edge>> &g, vector<bool> &visi)
{
    visi[s] = true;
    for (auto ed : g[s])
    {
        if (!visi[ed.v])
        {
            dfs(ed.v, g, visi);
        }
    }

}

void ndfs(int s, vector<vector<edge>> &g, vector<int> &start, vector<edge> &ans)
{
    for (int i = start[s]; i < g[s].size(); i++)
    {
        edge ed = g[s][i];
        start[s]++;
        ndfs(ed.v, g, start, ans);
        ans.push_back(ed);
    }

}

int main()
{
    int n, c;
    cin >> n >> c;
    vector<int> eqc;
    vector<int> neqc;
    vector<vector<edge>> g;
    unordered_map<int, int> m_set;
    vector<int> in;
    int s = 0;
    for (int i = 0; i < n; i++)
    {
        int a, b, w;
        cin >> a >> b >> w;
        if (w)
        {
            if (m_set.find(a) == m_set.end())
            {
                m_set[a] = s;
                s++;
                g.push_back(vector<edge>());
                in.push_back(0);
            }
            if (m_set.find(b) == m_set.end())
            {
                m_set[b] = s;
                s++;
                g.push_back(vector<edge>());
                in.push_back(0);
            }
            in[m_set[b]]++;
            g[m_set[a]].push_back({m_set[b], i});
        }
        else
        {
            if (a == c)
                eqc.push_back(i + 1);
            else
                neqc.push_back(i + 1);
        }
    }
    int last = -1;
    c = m_set[c];
    for (int i = 0; i < g.size(); i++)
    {
        if (in[i] != g[i].size() && c != i)
        {
            if (last == -1)
                last = i;
            else
            {
                cout << "NO";
                return 0;
            }
        }
    }
    if (last == -1 && in[c] != g[c].size())
    {
        cout << "NO";
        return 0;
    }
    if (last != -1 && (in[c] + 1 != g[c].size() || in[last] != g[last].size() + 1))
    {
        cout << "NO";
        return 0;
    }
    if (in[c] != g[c].size())
    {
        g[last].push_back({c, n});
    }
    vector<bool> visi(g.size());
    dfs(c, g, visi);
    for (int i = 0; i < g.size(); i++)
    {
        if (!visi[i])
        {
            cout << "No";
            return 0;
        }
    }
    visi.clear();
    in.clear();
    vector<edge> ans;
    vector<int> start(g.size());
    ndfs(c, g, start, ans);
    cout << "Yes" << endl;
    for (auto a : neqc)
        cout << a << " ";
    bool one = true;
    int si = ans.size();
    for (int i = si - 1; i > 0; i--) {
        cout << ans[i].id + 1 << " ";
        if (ans[i].v != c && one) {
            for (auto a : eqc)
                cout << a << " ";
            one = false;
        }
    }
}
