//
// Created by ahmad on 14.11.2020.
//

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

#define ff first
#define ss second
#define mp(x, y) make_pair(x, y)
#define gt(x, y) get<y>(x)
#define all(x) x.begin(), x.end()

using ll = int64_t;
using ul = uint64_t;
using ld = long double;

int main() {
  ios_base::sync_with_stdio(false);
  size_t n, w, h, s;
  cin >> n >> w >> h >> s;
  vector< pair<char, vector<string> > > letters(n);
  for (size_t i = 0; i < n; i++) {
    cin >> letters[i].first;
    letters[i].second.resize(h);
    for (size_t j = 0; j < h; j++) {
      cin >> letters[i].second[j];
    }
  }
  size_t max_lett = 0;
  size_t max_switches = 0;
  for (size_t i = 0; i < n; i++) {
    size_t max_row = 0;
    for (size_t j = 0; j < h; j++) {
      char prev_char = '.';
      size_t num_of_switches = 0;
      for (size_t k = 0; k < w; k++) {
        if (prev_char != letters[i].second[j][k]) {
          num_of_switches++;
        }
        prev_char = letters[i].second[j][k];
      }
      if (prev_char == '#') {
        num_of_switches++;
      }
      max_row = max(max_row, num_of_switches);
    }
    assert(max_row > 0);
    if (max_switches < max_row) {
      max_lett = i;
      max_switches = max_row;
    }
  }
  for (size_t i = 0; i < max(1ul, s / max_switches); i++) {
    cout << letters[max_lett].first;
  }
  cout << flush;
  return 0;
}