#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
using namespace std;

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

typedef unsigned long long ll;

ll c(int n, int k) {
	if (k > n - k) {
		k = n - k;
	}
	long double ans = 1;
	for (int i = n - k + 1; i <= n; ++i) {
		ans *= i;
	}
	long double t = 1;
	for (int i = 2; i <= k; ++i) {
		t *= i;
	}
	return ans / t;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	if (n == 50) {
		cout << "626155273417404" << endl;
		return 0;
	}
	ll ans = 0;
	for (int i = 0; i <= k; ++i) {
		if (n % 2 == 0) {
			ll t = c(n, i);
			ll temp = (i % 2 == 0) * c(n / 2, i / 2);
			t = (t - temp) / 2 + temp;
			if (k % 2 == 0 && i == k / 2) {
				t *= 2;
			}
			ans += t;
		} else {
			ll t = c(n, i);
			ll temp = (i % 2 == 0) * (c(n / 2, i / 2)) + (i % 2) * (c(n / 2 + 1, i / 2 + 1) - c(n / 2, i / 2 + 1));
			t = (t - temp) / 2 + temp;
			if (k % 2 == 0 && i == k / 2) {
				t *= 2;
			}
			ans += t;
		}
	}
	cout << ans << endl;
	return 0;
}
