
#include <vector>
#include <queue>
#include <iostream>
#include <algorithm>
#include <map>


int main() {


    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);


    int n, w, h, s;
    std::cin >> n >> w >> h >> s;

    std::vector<char> c(n);
    std::vector<std::vector<int>> d(n, std::vector<int> (h, 0));

    for (int id = 0; id < n; id++) {
        std::cin >> c[id];

        for (int i = 0; i < h; i++) {
            char cur = '.';
            for (int j = 0; j < w; j++) {
                char buf;
                std::cin >> buf;
                if (buf != cur) {
                    d[id][i] += 1;
                }
                cur = buf;
            }
            if (cur == '#') {
                d[id][i] += 1;
            }
        }

    }

    int m = 0;
    int cur = 0;

    for (int id = 0; id < n; id++) {
        for (int i = 0; i < w; i++) {
            if (m < d[id][i]) {
                m = d[id][i];
                cur = id;
            }
        }
    }

    for (int i = 0; i < (s + m - 1) / m; i++) {
        std::cout << c[cur];
    }
    std::cout << '\n';


    return 0;
}