#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_map>
#include <queue>
//#include "optimization.h"
#include <set>
#include <cmath>

using namespace std;

long long dp[55][55];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    if (k == 0 || k == 2 * n) {
        cout << 2;
        return 0;
    }
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = 1;
        dp[i][i] = 1;
        for (int j = 1; j < i; ++j) {
            dp[i][j] = dp[i - 1][j - 1] + dp[i - 1][j];
        }
    }
    long long ans = 0;
    if (n % 2 == 0) {
        for (int i = max(0, k - n); i <= min(n, k); ++i) {
            if (i == k / 2 && i == (k + 1) / 2) {
                ans += (dp[n][i]);
                continue;
            }
            if (i % 2 == 0) {
                ans += ((dp[n][i] + dp[n / 2][i / 2]) / 2);
            } else
                ans += (dp[n][i] / 2);
        }
    } else {
        for (int i = max(0, k - n); i <= min(n, k); ++i) {
            if (i == k / 2 && i == (k + 1) / 2) {
                ans += (dp[n][i] + dp[n / 2][k / 2] * dp[n / 2][k / 2]);
                continue;
            }
            ans += ((dp[n][i] + dp[n / 2][i / 2]) / 2);
        }
    }

    cout << ans;
    return 0;
}