//--------------------------------------------------
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,popcnt,fma")
#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
//--------------------------------------------------
#include <bits/stdc++.h>
#include <chrono>
#include <set>
#include <map>
#include <deque>
#include <cmath>
#include <queue>
#include <cassert>
#include <random>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <time.h>
#include <ctime>
#include <string>
#include <cstdio>
#include <vector>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <stack>
#include <cstring>
//--------------------------------------------------
#define forn(i, n) for(int i = 0; i < n; i++)
#define forw(i, n) for(int i = n-1; i >= 0; --i)
#define forns(i, n, s) for(int i = s; i < n; i++)
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(),v.end()
#define allr(v) v.rbegin(),v.rend()
//----------------------------------------------------
using namespace std;
//----------------------------------------------------
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef vector<ll> lnum;
typedef complex<ld> comp;
//----------------------------------------------------
const ll mod = 1e9 + 7, mod2 = 998244353;
const ld eps = 1e-6;
const ll inf = 1e18;
const int base = 1e9;
const ld PI = 3.14159265358979;
//----------------------------------------------------
#define endl '\n';
//----------------------------------------------------
int n, c, ones = 0, founded = 0;
vector<int> path;
map<int, vector<tuple<int, int>>> g;
map<int, vector<tuple<int, int>>> g2;
map<int, vector<int>> zeros;
map<int, vector<int>> lols;
map<int, int> tout;
map<int, bool> sorted;
int timer = 0;
//----------------------------------------------------
unsigned int bitcount(ull val) { return __builtin_popcount(val) + __builtin_popcount(val >> 32); }

void local() {
    freopen("test.in", "r", stdin);
}

void remote() {
}

void read() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> c;
    forn(i, n){
        int a, b, w;
        cin >> a >> b >> w;
        ones += w;
        if(w == 1) {
            if(a != b) g[a].pb({b, i}), g2[a].pb({b, i});
            else{
                lols[a].pb(i);
            }
        }
        else {
            zeros[a].pb(i);
        }
    }
}

void sortdfs(int v){
    timer++;
    vector<tuple<int, int>> &q = g2[v];
    while(!q.empty()) {
        const tuple<int, int> &t = q.back();
        q.pop_back();

        sortdfs(get<0>(t));
        tout[get<1>(t)] = timer;
    }
}


bool compare(const tuple<int, int> &t1, const tuple<int, int> &t2){
    return tout[get<1>(t1)] < tout[get<1>(t2)];
}

void dfs(int v, int d = 0){


    vector<int> del;
    for(const pair<int, vector<int>> &p: zeros){
        if(p.x != v){
            del.pb(p.x);
            for(const int &el : p.y)
                path.pb(el);
        }
    }
    for(const int &e: del) zeros.erase(zeros.find(e));

    while(!lols[v].empty()){
        path.pb(lols[v].back());
        lols[v].pop_back();
        d++;
    }


    founded = max(founded, d);
    vector<tuple<int, int>> &q = g[v];
    if(!sorted[v])
        sort(all(q), compare), sorted[v] = true;

    while(!q.empty()){
        const tuple<int, int>&t = q.back();
        q.pop_back();

        path.pb(get<1>(t));
        dfs(get<0>(t), d+1);
    }

}

int main() {
#ifdef MY_DEBUG
    local();
#else
    remote();
#endif
    read();

    sortdfs(c);
    dfs(c);
    if(founded == ones && zeros.empty()){
        cout << "Yes" << endl;
        forn(i, path.size()) cout << path[i]+1 << " ";
    }else{
        cout << "No" << endl;
    }
}

