// #include "stdafx.h"
// #include <conio.h>
#include <iostream>
#include <vector>
#include <math.h>

using namespace std;

#define MAX 3001

int sign(double a) {
	return a > 0 ? 1 : -1;
}

double ACC(int n, int* c, int start) {
	return double(c[start + n] - c[start]) / n;
}

double Dev(int n, int* c, int start) {
	double A = ACC(n, c, start);
	double sum = 0;
	for (int i = start + 1; i <= start + n; i++) {
		sum += (c[i] - c[i - 1] - A) * (c[i] - c[i - 1] - A);
	}
	return sqrt(sum / n);
}

int check(double A, double D, double P) {
	if (A == 0)
		return 0;
	if (D == 0)
		return sign(A);
	if (A / D >= P)
		return 1;
	if (A / D <= -1.0 * P)
		return -1;
	return 0;
}

int main() {
	int d, S;
	int c[MAX];
	double P, A, D;

	cin >> d >> P;
	for (int i = 0; i < d; i++)
		cin >> c[i];
	int pos = 0, neg = 0;

	for (int l = 0; l < d; l++)
		for (int r = l + 2; r < d; r++) {
			A = ACC(r - l, c, l);
			D = Dev(r - l, c, l);
			S = check(A, D, P);
			if (S == 1)
				pos++;
			if (S == -1)
				neg++;
		}
		
	cout << pos << " " << neg;
	// char f = _getch();
	return 0;
}