import java.io.BufferedReader
import java.io.InputStream
import java.io.InputStreamReader
import java.util.*
import kotlin.math.ceil
import kotlin.math.floor
import kotlin.math.round
import kotlin.math.sqrt


fun main() {
    val scanner = FastReader(System.`in`)
    val square = scanner.nextInt()
    val sqrtSquare = sqrt(square.toFloat())
    //println("${ceil(sqrtSquare)} ${floor(sqrtSquare)} ${sqrtSquare}")
    var wasAns = false
    if (ceil(sqrtSquare).toInt() == floor(sqrtSquare).toInt()) {
        println("${0 + round(sqrtSquare).toInt()} ${0 + round(sqrtSquare).toInt()}")
        println("0 0")
        println("0 ${0 + round(sqrtSquare).toInt()}")
        println("${0 + round(sqrtSquare).toInt()} 0")
        wasAns = true
    } else {
        loop@ for (i in 1..floor(sqrtSquare).toInt())
            for (j in 1..floor(sqrtSquare).toInt())
                if (i * i + j * j == square) {
                    println("${0 + j} ${0 + i}")
                    println("0 0")
                    println("${0 + j - i} ${0 + i + j}")
                    println("${0 + j - i - j} ${0 + i + j - i}")
                    wasAns = true
                    break@loop
                }
    }
    if (!wasAns) {
        println("Impossible")
    }
}

internal class FastReader(input: InputStream?) {
    var br: BufferedReader
    var st: StringTokenizer? = null
    operator fun next(): String? {
        while (st == null || !st!!.hasMoreElements()) {
            st = try {
                StringTokenizer(br.readLine())
            } catch (e: Exception) {
                return null
            }
        }
        return st!!.nextToken()
    }

    fun nextInt(): Int {
        return next()!!.toInt()
    }

    fun nextLong(): Long {
        return next()!!.toLong()
    }

    init {
        br = BufferedReader(InputStreamReader(input))
    }
}