#include <iostream>
#include <random>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <random>
#include <queue>
#include <set>
#include <assert.h>
#include <cmath>
#include <bitset>
#include <deque>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <memory.h>
#include <string.h>

using namespace std;

struct Edge {
    int u, i;
};

vector<vector<Edge>> g;
vector<Edge> es;

vector<int> was;

void dfs(int v) {
    was[v] = 1;
    while (g[v].size()) {
        Edge e = g[v].back();
        g[v].pop_back();
        dfs(e.u);
        es.push_back(e);
    }
}

struct Q {
    int a, b, w;
};

int main() {
    ios_base::sync_with_stdio(false), cin.tie(0);

    int n, c;
    cin >> n >> c;
    unordered_map<int, int> mp;
    mp[c] = 0;
    int cnt = 1;
    int a, b, w;
    vector<Q> q(n);
    for (int i = 0; i < n; i++) {
        cin >> a >> b >> w;
        if (mp.find(a) == mp.end()) {
            mp[a] = cnt;
            cnt++;
        }
        if (mp.find(b) == mp.end()) {
            mp[b] = cnt;
            cnt++;
        }
        a = mp[a], b = mp[b];
        q[i] = {a, b, w};
    }
    g.resize(cnt);
    was.resize(cnt);
    vector<pair<int, int> > bad;
    vector<int> degDif(cnt);
    for (int i = 0; i < n; i++) {
        if (q[i].w == 1) {
            g[q[i].a].push_back({q[i].b, i});
            degDif[q[i].a]++;
            degDif[q[i].b]--;
        }
        else {
            bad.emplace_back(q[i].a, i);
        }
    }

    if (!(degDif[0] == 0 || degDif[0] == 1)) {
        cout << "No";
        return 0;
    }
    bool good = true;
    int minusone = 0;
    for (int i = 1; i < degDif.size(); i++) {
        if (degDif[i] == 0) {
            continue;
        }
        if (degDif[i] == -1) {
            minusone++;
        }
        else {
            good = false;
        }
    }
    if (minusone > 1) {
        good = false;
    }
    if (good == false) {
        cout << "No";
        return 0;
    }


    dfs(0);
    reverse(es.begin(), es.end());
    for (auto &i : g) {
        if (i.size() > 0) {
            cout << "No";
            return 0;
        }
    }

    int wascnt = 0;
    for (auto &i : was) {
        wascnt += i;
    }
    if (wascnt == 1) {
        bool ok = true;
        for (auto &i : bad) {
            if (i.first == 0) {
                ok = false;
            }
        }
        if (ok) {
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                cout << i + 1 << ' ';
            }
        }
        else {
            cout << "No";
        }
        return 0;
    }

    cout << "Yes\n";
    vector<int> verybad;
    for (auto &i : bad) {
        if (i.first != 0) {
            cout << i.second + 1 << ' ';
        }
        else {
            verybad.push_back(i.second);
        }
    }
    int cur;
    for (auto &i : es) {
        cout << i.i + 1 << ' ';
        cur = i.u;
        if (cur != 0 && verybad.size() != 0) {
            for (auto &j : verybad) {
                cout << j + 1 << ' ';
            }
            verybad.clear();
        }
    }

    return 0;
}