#include <iostream>
#include <random>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <random>
#include <queue>
#include <set>
#include <assert.h>
#include <cmath>
#include <bitset>
#include <deque>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <memory.h>
#include <string.h>

using namespace std;

typedef unsigned long long ull;

int n, k;
vector<vector<ull>> c(52, vector<ull>(52));

ull difPalk(int t) {
    if (n % 2 == 0 && t % 2 == 1)
        return c[n][t] / 2;
    return (c[n][t] - c[n / 2][t / 2]) / 2 + c[n / 2][t / 2];
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(0);


    for (int i = 0; i < 52; ++i) {
        c[i][0] = 1;
        for (int j = 1; j <= i; ++j) {
            c[i][j] = c[i - 1][j] + c[i - 1][j - 1];
        }
    }

    ull ans = 0;
    cin >> n >> k;
    for (int t = 0; t <= k - t; t++) {
        if (t > n || k - t > n)
            continue;
        if (2 * t != k) {
            ans += difPalk(t);
            ans += difPalk(k - t);
        }
        else {
            ans += difPalk(t);
            ans += difPalk(k - t);
        }
    }
    cout << ans;


    return 0;
}
