#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <vector>
#include <map>

using namespace std;

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define FR(i, n) for(int i = 0; i < n; i++)
#define fs first
#define sc second
#define td third
#define all(x) x.begein(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ll long long

struct triple{
    int first, second, third;
};

char revert(char c) {
    if(c == '.') {
        return '#';
    } else {
        return '*';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);

    int n, w, h, s;
    cin >> n >> w >> h >> s;
    map<int, char> m;
    vector<vector<string>> v;
    int m_err = -1;
    FR(i, n) {
        char c;
        cin >> c;
        m[i] = c;
        vector<string> help;
        FR(j, h) {
            string help2;
            cin >> help2;
            help.push_back(help2);
        }
        v.push_back(help);
    }

    vector<vector<triple>> switches;
    FR(i, n) {
        vector<triple> help;
        FR(j, h) {
            triple c;
            c.fs = 0; c.sc = 0; c.td = 0;
            c.fs = v[i][j][0];
            c.td = v[i][j][w-1];
            char ls = v[i][j][0];
            FOR(ii, 1, w) {
                if(v[i][j][ii] != ls) {
                    ls = revert(ls);
                    c.sc++;
                }
            }
            help.push_back(c);
        }
        switches.push_back(help);
    }

    int b1, b2;
    int sum = -1;
    FR(i, n) {
        FR(j, n) {
            FR(x, w) {
                int sm = switches[i][x].sc + switches[j][x].sc;
                if(switches[i][x].td != switches[j][x].fs) sm++;
                if(sum < sm) {
                    b1 = i;
                    b2 = j;
                    sum = sm;
                }
            }
        }
    }

    for(int i = 0; i < s; i += sum) {
        cout << m[b1] << m[b2];
    }
    return 0;
}