from math import ceil


def calc_switches(s):
    cnt = 0
    for i, c in enumerate(s[1:], 1):
        if c != s[i - 1]:
            cnt += 1
    return cnt


n, w, h, s = [int(i) for i in input().split()]

letters = []
imgs = []

for _ in range(n):
    img = []
    letters.append(input())
    for _ in range(h):
        img.append(input())
    imgs.append(img)

# graphs = []
# for row_n in range(h):
#     graphs.append([])
#     for i, img1 in enumerate(imgs):
#         graphs[row_n].append([])
#         for j, img2 in enumerate(imgs):
#             graphs[row_n][i].append(calc_switches(img1[row_n] + '.' + img2[row_n]))
#     graphs[row_n].append([])
#     for img in imgs:
#         graphs[row_n][n].append(calc_switches('.' + img[row_n]))

img_row_self_costs = []
cur_max = 0
cur_img = None
for i, img in enumerate(imgs):
    img_row_costs = []
    for row in range(h):
        img_row_costs.append(calc_switches('.' + img[row] + '.'))
    if max(img_row_costs) > cur_max:
        cur_max = max(img_row_costs)
        cur_img = i

img_n = ceil(s / cur_max)
print(letters[cur_img] * img_n)
