def mean(l):
    return sum(l) / len(l)


def std(l):
    s = 0
    m = mean(l)
    for elem in l:
        s += (elem - m) ** 2
    return s / len(l)


def d_subseg(i, j, pseudo_prefix_d, prefix_a):
    cur_a = (prefix_a[j] * j - prefix_a[i] * i)/(j - i)
    cur_d = (pseudo_prefix_d[j] - pseudo_prefix_d[i]) - cur_a**2 * (j - i)
    return (cur_d / (j - i)) ** (1/2)


def a_subseg(i, j, prefix_a):
    return (prefix_a[j] * j - prefix_a[i] * i)/(j - i)


d, p = input().split()
d, p = int(d), float(p)
c = [int(i) for i in input().split()]

# difs = []
# for i in range(1, d):
#     difs.append(c[i] - c[i-1])
#
# anton_prefix_a = []
# anton_prefix_b = []
# for i in range(1, len(difs) + 1):
#     anton_prefix_a.append(mean(difs[:i]))
#     anton_prefix_b.append(std(difs[:i]))

prefix_a = [0] * d
prefix_a[0] = 0
for i in range(1, d):
    prefix_a[i] = ((prefix_a[i - 1] * (i - 1)) + c[i] - c[i - 1]) / i

pseudo_prefix_d = [0] * d
prefix_d = [0] * d
for i in range(1, d):
    pseudo_prefix_d[i] = pseudo_prefix_d[i - 1] + (c[i] - c[i - 1])**2
    prefix_d[i] = (pseudo_prefix_d[i] - i * prefix_a[i]**2) / i


positive_cnt = 0
negative_cnt = 0
for i in range(d):
    for j in range(i + 2, d):
        cur_a = a_subseg(i, j, prefix_a)
        cur_d = d_subseg(i, j, pseudo_prefix_d, prefix_a)
        if cur_d == 0:
            if cur_a > 0:
                positive_cnt += 1
            elif cur_a < 0:
                negative_cnt += 1
        else:
            if cur_a / cur_d >= p:
                positive_cnt += 1
            if cur_a / cur_d <= -p:
                negative_cnt += 1

print(positive_cnt, negative_cnt)
