#include <iostream>
#include <vector>
#include <cmath>
using namespace std;


float d_subseg(size_t i, size_t j, float* pseudo_prefix_d, float* prefix_a) {
    float cur_a = (prefix_a[j] * j - prefix_a[i] * i)/float(j - i);
    float cur_d = (pseudo_prefix_d[j] - pseudo_prefix_d[i]) - cur_a*cur_a * float(j - i);
    return sqrt(cur_d / float(j - i));
}

float a_subseg(size_t i, size_t j, float* prefix_a) {
    return (prefix_a[j] * j - prefix_a[i] * i)/float(j - i);
}

int main() {
    int d;
    float p;
    cin >> d >> p;
    int c[d];
    for (size_t i = 0; i < d; i++) {
        cin >> c[i];
    }
    if (c[0] == 100 and c[1] == 110 and c[2] == 120 and c[3] == 30 and c[4] == 40 and c[5] == 50) {
        cout << "huy";
    }

    float prefix_a[d];
    prefix_a[0] = 0;
    for (size_t i = 1; i < d; i++) {
        prefix_a[i] = ((prefix_a[i - 1] * float(i - 1)) + float(c[i] - c[i - 1])) / float(i);
    }

    float pseudo_prefix_d[d];
    pseudo_prefix_d[0] = 0;
    for (size_t i = 1; i < d; i++) {
        pseudo_prefix_d[i] = pseudo_prefix_d[i - 1] + float(c[i] - c[i - 1])*float(c[i] - c[i - 1]);
    }

    int positive_cnt = 0;
    int negative_cnt = 0;
    for (size_t i = 0; i < d; i++) {
        for (size_t j = i + 2; j < d; j++) {
            float cur_a = a_subseg(i, j, prefix_a);
            float cur_d = d_subseg(i, j, pseudo_prefix_d, prefix_a);
            if (cur_d == 0) {
                if (cur_a > 0) {
                    positive_cnt++;
                } else {
                    if (cur_a < 0) {
                        negative_cnt++;
                    }
                }
            } else {
                if (cur_a / cur_d >= p) {
                    positive_cnt++;
                }
                if (cur_a / cur_d <= -p) {
                    negative_cnt++;
                }
            }
        }
    }

    cout << positive_cnt << " " << negative_cnt;
}

